"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _List = _interopRequireDefault(require("../List"));
var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var AutoCompleteFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(AutoCompleteFilter, _Component);
  var _super = _createSuper(AutoCompleteFilter);
  function AutoCompleteFilter(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, AutoCompleteFilter);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;
      var minFilterLength = _this.props.minFilterLength;
      if (!filter || filter.length < minFilterLength) {
        return data;
      }
      var _this$props = _this.props,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField,
        renderer = _this$props.renderer,
        filterCallback = _this$props.filterCallback;
      if (filterCallback) {
        return filterCallback(filter, data);
      }
      return data.filter(function (item) {
        if (!item) {
          return false;
        }
        if (renderer) {
          return renderer(item).toString().toUpperCase().includes(filter.toUpperCase());
        }
        if ((0, _typeof2["default"])(item) === 'object') {
          var itemDisplay = _Util["default"].getTextByDisplayField(item, displayField, valueField);
          if (itemDisplay) {
            return itemDisplay.toString().toUpperCase().includes(filter.toUpperCase());
          }
        }
        return item.toString().toUpperCase().includes(filter.toUpperCase());
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterFocus", function () {
      if (_this.props.disabled) {
        return;
      }
      var onFocus = _this.props.onFocus,
        filter = _this.state.filter,
        state = {
          filterFocused: true,
          tempSelectIndex: null
        };
      onFocus && onFocus.apply(void 0, arguments);
      if (filter) {
        state.popupVisible = true;
      }
      _this.setState(state);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterBlur", function () {
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        onBlur = _this$props2.onBlur;
      !disabled && onBlur && onBlur.apply(void 0, arguments);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterKeyDown", function (e) {
      var useDynamicRenderList = _this.props.useDynamicRenderList,
        _this$state = _this.state,
        tempSelectIndex = _this$state.tempSelectIndex,
        listData = _this$state.listData,
        listEl = useDynamicRenderList ? _this.dynamicRenderList && _this.dynamicRenderList.current : _this.list && _this.list.current;
      var state = null;
      if (e.keyCode === 38 || e.keyCode === 40) {
        state = {};
        var index = !isNaN(tempSelectIndex) && tempSelectIndex > -1 ? tempSelectIndex : -1;
        if (e.keyCode === 38) {
          // up
          index--;
        } else if (e.keyCode === 40) {
          // down
          index++;
        }
        state.tempSelectIndex = _Valid["default"].range(index, 0, listData.length - 1);
      }
      _this.setState(state, function () {
        var onFilterKeyDown = _this.props.onFilterKeyDown;
        onFilterKeyDown && onFilterKeyDown(e);
        listEl && listEl.adjustScroll();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterPressEnter", function (e, filter) {
      var autoClose = _this.props.autoClose,
        state = {};
      if (autoClose) {
        state.popupVisible = false;
      }
      _this.setState(state, function () {
        var onFilterPressEnter = _this.props.onFilterPressEnter;
        onFilterPressEnter && onFilterPressEnter(filter);
        _this.update();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      var _this$props3 = _this.props,
        data = _this$props3.data,
        minFilterLength = _this$props3.minFilterLength,
        state = {
          filter: filter,
          popupVisible: !!filter && filter.length >= minFilterLength,
          tempSelectIndex: null
        };
      if (!filter) {
        state.listData = data;
        state.value = null;
      } else {
        state.listData = _this.filterData(filter);
      }
      _this.setState(state, function () {
        var onFilterChange = _this.props.onFilterChange;
        onFilterChange && onFilterChange(filter);
        _this.pop && _this.pop.current && _this.pop.current.resetPosition();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePop", function () {
      _this.setState({
        popupVisible: false
      }, function () {
        var onPopupClosed = _this.props.onPopupClosed;
        onPopupClosed && onPopupClosed();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (pop) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.wrapperEl, _this.triggerEl, (0, _reactDom.findDOMNode)(pop));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemClick", function (value) {
      var _this$props4 = _this.props,
        autoClose = _this$props4.autoClose,
        valueField = _this$props4.valueField,
        displayField = _this$props4.displayField,
        renderer = _this$props4.renderer,
        filter = renderer ? renderer(value) : _Util["default"].getTextByDisplayField(value, displayField, valueField),
        state = {
          tempSelectIndex: null,
          value: value,
          filter: filter,
          listData: _this.filterData(filter)
        },
        isChanged = _this.state.value != value;
      if (autoClose) {
        state.popupVisible = false;
      }
      _this.setState(state, function () {
        var _this$props5 = _this.props,
          onItemClick = _this$props5.onItemClick,
          onChange = _this$props5.onChange;
        onItemClick && onItemClick(value);
        isChanged && onChange && onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "update", function () {
      var _this$props6 = _this.props,
        displayField = _this$props6.displayField,
        valueField = _this$props6.valueField,
        renderer = _this$props6.renderer,
        _this$state2 = _this.state,
        filter = _this$state2.filter,
        tempSelectIndex = _this$state2.tempSelectIndex,
        listData = _this$state2.listData;
      var state = null;
      if (filter && listData && listData.length > 0) {
        state = {};
        var index = !isNaN(tempSelectIndex) && tempSelectIndex > -1 ? tempSelectIndex : -1;
        state.value = index > -1 ? listData[index] : null;
        if (index > -1) {
          state.filter = renderer ? renderer(state.value) : _Util["default"].getTextByDisplayField(state.value, displayField, valueField);
        }
        state.listData = _this.filterData(state.filter);
      }
      state && _this.setState(state, function () {
        var _this$props7 = _this.props,
          onFilterChange = _this$props7.onFilterChange,
          onChange = _this$props7.onChange;
        onFilterChange && onFilterChange(state.filter);
        onChange && onChange(state.value);
      });
    });
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.dynamicRenderList = /*#__PURE__*/(0, _react.createRef)();
    _this.list = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      tempSelectIndex: null,
      value: props.value,
      filter: props.filterInitValue,
      popupVisible: false,
      isAbove: false,
      listData: props.data
    };
    return _this;
  }
  (0, _createClass2["default"])(AutoCompleteFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props8 = this.props,
        className = _this$props8.className,
        popupClassName = _this$props8.popupClassName,
        style = _this$props8.style,
        popupStyle = _this$props8.popupStyle,
        theme = _this$props8.theme,
        popupTheme = _this$props8.popupTheme,
        name = _this$props8.name,
        placeholder = _this$props8.placeholder,
        disabled = _this$props8.disabled,
        iconCls = _this$props8.iconCls,
        rightIconCls = _this$props8.rightIconCls,
        valueField = _this$props8.valueField,
        displayField = _this$props8.displayField,
        descriptionField = _this$props8.descriptionField,
        position = _this$props8.position,
        noMatchedPopupVisible = _this$props8.noMatchedPopupVisible,
        noMatchedMsg = _this$props8.noMatchedMsg,
        popupChildren = _this$props8.popupChildren,
        renderer = _this$props8.renderer,
        resetPopPositionWait = _this$props8.resetPopPositionWait,
        useDynamicRenderList = _this$props8.useDynamicRenderList,
        listHeight = _this$props8.listHeight,
        itemHeight = _this$props8.itemHeight,
        scrollBuffer = _this$props8.scrollBuffer,
        onFilterClear = _this$props8.onFilterClear,
        onMouseOver = _this$props8.onMouseOver,
        onMouseOut = _this$props8.onMouseOut,
        parentEl = _this$props8.parentEl,
        _this$state3 = this.state,
        isAbove = _this$state3.isAbove,
        tempSelectIndex = _this$state3.tempSelectIndex,
        value = _this$state3.value,
        filter = _this$state3.filter,
        popupVisible = _this$state3.popupVisible,
        listData = _this$state3.listData,
        isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove,
        isEmpty = !listData || listData.length < 1;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('auto-complete-filter', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, name ? /*#__PURE__*/_react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: _Util["default"].getValueByValueField(value, valueField, displayField)
      }) : null, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: (0, _classnames["default"])('auto-complete-filter-trigger', isEmpty && !noMatchedPopupVisible ? '' : popupVisible ? ' activated' : '', isAboveFinally ? ' above' : ' blow'),
        theme: theme,
        value: filter,
        placeholder: placeholder,
        disabled: disabled,
        iconCls: iconCls,
        rightIconCls: rightIconCls,
        onFocus: this.handleFilterFocus,
        onBlur: this.handleFilterBlur,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        onChange: this.handleFilterChange,
        onKeyDown: this.handleFilterKeyDown,
        onPressEnter: this.handleFilterPressEnter,
        onClear: onFilterClear,
        onRightIconClick: this.handleFilterPressEnter
      }), isEmpty && !noMatchedPopupVisible ? null : /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        ref: this.pop,
        className: (0, _classnames["default"])('auto-complete-filter-popup', isAboveFinally ? ' above' : ' blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        theme: popupTheme,
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePop
      }, isEmpty ? /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "auto-complete-filter-list",
        theme: popupTheme,
        data: [{
          itemRenderer: function itemRenderer() {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: "no-matched-list-item"
            }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
              className: "fas fa-exclamation-triangle no-matched-list-item-icon"
            }), "No matched value."));
          },
          disableTouchRipple: true
        }]
      }) : useDynamicRenderList ? /*#__PURE__*/_react["default"].createElement(_DynamicRenderList["default"], {
        ref: this.dynamicRenderList,
        className: "auto-complete-filter-list",
        theme: popupTheme,
        data: listData,
        value: listData[tempSelectIndex],
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        listHeight: listHeight,
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        onItemClick: this.handleItemClick
      }) : /*#__PURE__*/_react["default"].createElement(_List["default"], {
        ref: this.list,
        className: "auto-complete-filter-list",
        theme: popupTheme,
        data: listData,
        value: listData[tempSelectIndex],
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        onItemClick: this.handleItemClick
      }), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return AutoCompleteFilter;
}(_react.Component);
(0, _defineProperty2["default"])(AutoCompleteFilter, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(AutoCompleteFilter, "Position", _Position["default"]);
AutoCompleteFilter.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the auto complete.
   */
  name: _propTypes["default"].string,
  /**
   * The placeholder of the field.
   */
  placeholder: _propTypes["default"].string,
  /**
   * Children passed into the List.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  value: _propTypes["default"].any,
  /**
   * If true, the auto complete will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the popup list automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  minFilterLength: _propTypes["default"].number,
  /**
   * Callback function fired when filter changed.
   */
  filterCallback: _propTypes["default"].func,
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * The visiblity of no matched popup.
   */
  noMatchedPopupVisible: _propTypes["default"].bool,
  /**
   * The message of no matched value.
   */
  noMatchedMsg: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  popupChildren: _propTypes["default"].any,
  filterInitValue: _propTypes["default"].string,
  useDynamicRenderList: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * The function that trigger when filter changes.
   */
  onFilterChange: _propTypes["default"].func,
  /**
   * The function that trigger when press enter.
   */
  onFilterPressEnter: _propTypes["default"].func,
  /**
   * The function that trigger when filter cleared.
   */
  onFilterClear: _propTypes["default"].func,
  /**
   * The function that trigger when value changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * The function that trigger when touch-tap the list items.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when AutoCompleteFilter get focus.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when AutoCompleteFilter lose focus.
   */
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onPopupClosed: _propTypes["default"].func,
  onFilterKeyDown: _propTypes["default"].func
};
AutoCompleteFilter.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  data: [],
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: false,
  minFilterLength: 1,
  iconCls: null,
  rightIconCls: 'fas fa-search',
  noMatchedPopupVisible: true,
  filterInitValue: '',
  useDynamicRenderList: false,
  resetPopPositionWait: 250
};
var _default = AutoCompleteFilter;
exports["default"] = _default;