"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BadgeType = _interopRequireDefault(require("../_statics/BadgeType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["children", "className", "style", "visible", "type", "value", "overflowValue", "overflowRenderer"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Badge = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Badge, _Component);
  var _super = _createSuper(Badge);
  function Badge(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Badge);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOverflow", function () {
      var _this$props = _this.props,
        value = _this$props.value,
        overflowValue = _this$props.overflowValue,
        overflowRenderer = _this$props.overflowRenderer;
      if (!overflowRenderer) {
        return "".concat(overflowValue, "+");
      }
      if (typeof overflowRenderer === 'function') {
        return overflowRenderer === null || overflowRenderer === void 0 ? void 0 : overflowRenderer(value, overflowValue);
      }
      return overflowRenderer;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleValue", function () {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.value;
      var _this$props2 = _this.props,
        type = _this$props2.type,
        overflowValue = _this$props2.overflowValue;
      if (type !== _BadgeType["default"].NUMBER) {
        return null;
      }
      if (overflowValue == null || value <= overflowValue) {
        return value;
      }
      return _this.handleOverflow();
    });
    return _this;
  }

  /**
   * handle display when value overflow
   * @returns {string}
   */
  (0, _createClass2["default"])(Badge, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        children = _this$props3.children,
        className = _this$props3.className,
        style = _this$props3.style,
        visible = _this$props3.visible,
        type = _this$props3.type,
        value = _this$props3.value,
        overflowValue = _this$props3.overflowValue,
        overflowRenderer = _this$props3.overflowRenderer,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded);
      return /*#__PURE__*/_react["default"].createElement("span", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('badge-wrapper', (0, _defineProperty2["default"])({
          'no-child': !children
        }, className, className)),
        style: style
      }), children, visible ? /*#__PURE__*/_react["default"].createElement("sup", {
        className: (0, _classnames["default"])('badge', "badge-".concat(type))
      }, this.handleValue()) : null);
    }
  }]);
  return Badge;
}(_react.Component);
(0, _defineProperty2["default"])(Badge, "Type", _BadgeType["default"]);
Badge.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  visible: _propTypes["default"].bool,
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_BadgeType["default"])),
  value: _propTypes["default"].number,
  overflowValue: _propTypes["default"].number,
  overflowRenderer: _propTypes["default"].any
};
Badge.defaultProps = {
  visible: true,
  type: _BadgeType["default"].DOT
};
var _default = Badge;
exports["default"] = _default;