"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _CascaderListItem = _interopRequireDefault(require("../_CascaderListItem"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _HorizontalDirection = _interopRequireDefault(require("../_statics/HorizontalDirection"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _CascaderCalculation = _interopRequireDefault(require("../_vendors/CascaderCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CascaderList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CascaderList, _Component);
  var _super = _createSuper(CascaderList);
  function CascaderList(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CascaderList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }
      if (!_Calculation["default"].isItemChecked(node, value, _this.props)) {
        value.push(node);
      }
      if (!node.children || node.children.length < 1) {
        return;
      }
      var _iterator = _createForOfIteratorHelper(node.children),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var item = _step.value;
          _this.addRecursiveValue(item, value);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }
      var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);
      if (index > -1) {
        value.splice(index, 1);
      }
      if (!node.children || node.children.length < 1) {
        return;
      }
      var _iterator2 = _createForOfIteratorHelper(node.children),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var item = _step2.value;
          _this.removeRecursiveValue(item, value);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateValue", function (value) {
      var _this$props = _this.props,
        data = _this$props.data,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField;
      var result = [];
      _Util["default"].postOrderTraverse({
        children: data
      }, function (node) {
        if (!node.children || node.children.length < 1) {
          if (value.findIndex(function (item) {
            return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(node, valueField, displayField);
          }) > -1) {
            result.push(node);
          }
        } else {
          if (node.children.every(function (child) {
            return result.findIndex(function (item) {
              return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(child, valueField, displayField);
            }) > -1;
          })) {
            result.push(node);
          }
        }
      });
      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeClick", function (node, index, path, e) {
      var onNodeClick = _this.props.onNodeClick;
      onNodeClick === null || onNodeClick === void 0 ? void 0 : onNodeClick(node, index, path, e);
      _this.setState({
        activatedPath: path
      }, function () {
        var _this$props$onPathCha, _this$props2;
        return (_this$props$onPathCha = (_this$props2 = _this.props).onPathChange) === null || _this$props$onPathCha === void 0 ? void 0 : _this$props$onPathCha.call(_this$props2, path);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeSelect", function (node, path) {
      if (!node) {
        return;
      }
      var _this$props3 = _this.props,
        selectMode = _this$props3.selectMode,
        isSelectRecursive = _this$props3.isSelectRecursive,
        value = _this.state.value,
        state = {};
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value ? value.slice() : value;
        if (!result || !(0, _isArray["default"])(result)) {
          result = [];
        }
        if (isSelectRecursive) {
          _this.addRecursiveValue(node, result);
          result = _this.updateValue(result);
        } else {
          result.push(node);
        }
        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT && !_CascaderCalculation["default"].hasChildren(node)) {
        state.value = node;
      }
      _this.setState(state, function () {
        var _this$props$onNodeSel, _this$props4, _this$props$onChange, _this$props5;
        (_this$props$onNodeSel = (_this$props4 = _this.props).onNodeSelect) === null || _this$props$onNodeSel === void 0 ? void 0 : _this$props$onNodeSel.call(_this$props4, node, path);
        state.value && ((_this$props$onChange = (_this$props5 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props5, state.value));
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeDeselect", function (node, path) {
      var selectMode = _this.props.selectMode;
      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var isSelectRecursive = _this.props.isSelectRecursive,
        stateValue = _this.state.value;
      var value = stateValue ? stateValue.slice() : stateValue;
      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        if (isSelectRecursive) {
          _this.removeRecursiveValue(node, value);
          value = _this.updateValue(value);
        } else {
          var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);
          if (index > -1) {
            value.splice(index, 1);
          }
        }
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props$onNodeDes, _this$props6, _this$props$onChange2, _this$props7;
        (_this$props$onNodeDes = (_this$props6 = _this.props).onNodeDeselect) === null || _this$props$onNodeDes === void 0 ? void 0 : _this$props$onNodeDes.call(_this$props6, node, path);
        (_this$props$onChange2 = (_this$props7 = _this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props7, value);
      });
    });
    var _value = _Calculation["default"].getInitValue(props);
    _this.state = {
      value: _value,
      activatedPath: props.initActivatedPath || _CascaderCalculation["default"].calPath(_value, props.data, props)
    };
    return _this;
  }
  (0, _createClass2["default"])(CascaderList, [{
    key: "render",
    value: function render() {
      var _this$props8 = this.props,
        children = _this$props8.children,
        className = _this$props8.className,
        style = _this$props8.style,
        theme = _this$props8.theme,
        selectTheme = _this$props8.selectTheme,
        listWidth = _this$props8.listWidth,
        expandDirection = _this$props8.expandDirection,
        data = _this$props8.data,
        expandedIconCls = _this$props8.expandedIconCls,
        radioUncheckedIconCls = _this$props8.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props8.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props8.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props8.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props8.checkboxIndeterminateIconCls,
        idField = _this$props8.idField,
        valueField = _this$props8.valueField,
        displayField = _this$props8.displayField,
        descriptionField = _this$props8.descriptionField,
        disabled = _this$props8.disabled,
        isLoading = _this$props8.isLoading,
        readOnly = _this$props8.readOnly,
        selectMode = _this$props8.selectMode,
        isSelectRecursive = _this$props8.isSelectRecursive,
        itemDisabled = _this$props8.itemDisabled,
        renderer = _this$props8.renderer,
        expandIconVisible = _this$props8.expandIconVisible,
        _this$state = this.state,
        value = _this$state.value,
        activatedPath = _this$state.activatedPath;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('cascader-list', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread(_objectSpread({}, style), {}, {
          width: _CascaderCalculation["default"].getMaxDepth(activatedPath) * listWidth
        }),
        disabled: disabled
      }, /*#__PURE__*/_react["default"].createElement(_CascaderListItem["default"], {
        listWidth: listWidth,
        expandDirection: expandDirection,
        activatedPath: activatedPath,
        data: data,
        value: value,
        theme: theme,
        selectTheme: selectTheme,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        disabled: disabled,
        isLoading: isLoading,
        readOnly: readOnly,
        selectMode: selectMode,
        itemDisabled: itemDisabled,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        isSelectRecursive: isSelectRecursive,
        renderer: renderer,
        expandIconVisible: expandIconVisible,
        onNodeClick: this.handleNodeClick,
        onNodeSelect: this.handleNodeSelect,
        onNodeDeselect: this.handleNodeDeselect
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return CascaderList;
}(_react.Component);
(0, _defineProperty2["default"])(CascaderList, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(CascaderList, "ExpandDirection", _HorizontalDirection["default"]);
(0, _defineProperty2["default"])(CascaderList, "Theme", _Theme["default"]);
CascaderList.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme of the tree node.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  listWidth: _propTypes["default"].number,
  /**
   * The theme of the tree node select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The mode of tree node.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The direction of expansion.
   */
  expandDirection: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalDirection["default"])),
  /**
   * Children passed into the tree node.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,
    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    children: _propTypes["default"].array,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  })),
  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the tree will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true, the tree will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * Cascader List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  initActivatedPath: _propTypes["default"].array,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  expandIconVisible: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node touch tap.
   */
  onNodeClick: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node selected.
   */
  onNodeSelect: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node deselected.
   */
  onNodeDeselect: _propTypes["default"].func,
  onPathChange: _propTypes["default"].func,
  /**
   * Callback function fired when the tree changed.
   */
  onChange: _propTypes["default"].func
};
CascaderList.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  listWidth: 200,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  expandDirection: _HorizontalDirection["default"].RIGHT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isSelectRecursive: true
};
var _default = CascaderList;
exports["default"] = _default;