"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Percent = _interopRequireDefault(require("../_Percent"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CircularProgress = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CircularProgress, _Component);
  var _super = _createSuper(CircularProgress);
  function CircularProgress(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CircularProgress);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    _this.state = {
      percent: [0, 0]
    };
    return _this;
  }
  (0, _createClass2["default"])(CircularProgress, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        style = _this$props.style,
        r = _this$props.r,
        width = _this$props.width,
        word = _this$props.word,
        percent = _this$props.percent,
        percentStyle = _this$props.percentStyle,
        l = 2 * r * Math.PI,
        svgStyle = _objectSpread(_objectSpread({}, style), {}, {
          width: (r + width) * 2,
          height: (r + width) * 2
        });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('circular-progress', (0, _defineProperty2["default"])({}, className, className)),
        style: svgStyle
      }, /*#__PURE__*/_react["default"].createElement("svg", {
        className: "circular-progress-svg"
      }, /*#__PURE__*/_react["default"].createElement("circle", {
        className: "circular-progress-circle",
        cx: r + width,
        cy: r + width,
        r: r,
        strokeWidth: width,
        fill: "none",
        style: {
          strokeDasharray: percent / 100 * l + ',' + l
        }
      })), word ? /*#__PURE__*/_react["default"].createElement(_Percent["default"], {
        endNum: percent,
        style: percentStyle
      }, children) : null);
    }
  }]);
  return CircularProgress;
}(_react.Component);
CircularProgress.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The style of the percent text description.
   */
  percentStyle: _propTypes["default"].object,
  /**
   * The radius of the progress in pixels.
   */
  r: _propTypes["default"].number,
  /**
   * Stroke width in pixels.
   */
  width: _propTypes["default"].number,
  /**
   * Override the progress's color.
   */
  // rgba: PropTypes.string,

  /**
   * The value of progress.
   */
  percent: _propTypes["default"].number,
  /**
   * If true,there will have a text description.
   */
  word: _propTypes["default"].bool
};
CircularProgress.defaultProps = {
  percentStyle: {},
  r: 48,
  width: 2,
  // rgba: 'rgb(0, 188, 212)',
  percent: 0,
  word: true
};
var _default = CircularProgress;
exports["default"] = _default;