"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _moment = _interopRequireDefault(require("moment"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _DayPicker = _interopRequireDefault(require("../_DayPicker"));
var _MonthPicker = _interopRequireDefault(require("../_MonthPicker"));
var _YearPicker = _interopRequireDefault(require("../_YearPicker"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DateUtil = _interopRequireDefault(require("../_vendors/DateUtil"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "name", "placeholder", "dateFormat", "maxValue", "minValue", "position", "popupClassName", "rightIconCls", "readOnly", "disabled", "parentEl"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DateRangePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DateRangePicker, _Component);
  var _super = _createSuper(DateRangePicker);
  function DateRangePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DateRangePicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDatePickerChange", function (select, selectLevel) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        datePickerLevel: selectLevel
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTextFieldChange", function (select, text) {
      if (text && text.length) {
        var flag = (0, _moment["default"])(text, _this.props.dateFormat, true).isValid();
        if (flag) {
          var initValue = (0, _moment["default"])(text).format('YYYY-MM-DD');
          var selectYear = initValue.split('-')[0],
            selectMonth = initValue.split('-')[1],
            selectDay = initValue.split('-')[2];
          if (select == 'left') {
            if ((0, _moment["default"])(text).isBefore(_this.state.right.text)) {
              //     state.startTime = text;
              //     state.left.text = text;
              //     state.left.year = selectYear;
              //     state.left.month = selectMonth;
              //     state.left.day = selectDay;
              //     if (selectYear == state.right.year && selectMonth == state.right.month) {
              //         if (selectMonth == 12) {
              //             state.right.month = 1;
              //             state.right.year = +selectYear + 1;
              //         } else {
              //             state.right.month = +selectMonth + 1;
              //         }
              //     }
              _this.setState({
                startTime: (0, _moment["default"])(text).isBefore(_this.state.right.text) ? text : _this.state.startTime,
                left: _objectSpread(_objectSpread({}, _this.state.left), {}, {
                  text: (0, _moment["default"])(text).isBefore(_this.state.right.text) ? text : _this.state.left.text,
                  year: (0, _moment["default"])(text).isBefore(_this.state.right.text) ? selectYear : _this.state.left.selectYear,
                  month: (0, _moment["default"])(text).isBefore(_this.state.right.text) ? selectMonth : _this.state.left.selectMonth,
                  day: (0, _moment["default"])(text).isBefore(_this.state.right.text) ? selectDay : _this.state.left.selectDay
                }),
                right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
                  month: selectYear == _this.state.right.year && selectMonth == _this.state.right.month ? selectMonth == 12 ? 1 : +selectMonth + 1 : _this.state.right.month,
                  year: selectYear == _this.state.right.year && selectMonth == _this.state.right.month ? +selectYear + 1 : _this.state.right.year
                })
              });
            }
          } else {
            // if (moment(state.startTime).isBefore(text)) {
            //     state.endTime = text;
            //     state.right.text = text;
            //     if (selectYear == state.left.year && selectMonth == state.left.month) {
            //         state.right.month = +selectMonth + 1;
            //     } else {
            //         state.right.year = selectYear;
            //         state.right.month = selectMonth;
            //         state.right.day = selectDay;
            //     }
            // }
            _this.setState({
              endTime: (0, _moment["default"])(_this.state.startTime).isBefore(text) ? text : _this.state.endTime,
              right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
                text: (0, _moment["default"])(_this.state.startTime).isBefore(text) ? text : _this.state.right.text,
                year: (0, _moment["default"])(_this.state.startTime).isBefore(text) ? selectYear == _this.state.left.year && selectMonth == _this.state.left.month ? _this.state.right.year : selectYear : _this.state.right.year,
                month: (0, _moment["default"])(_this.state.startTime).isBefore(text) ? selectYear == _this.state.left.year && selectMonth == _this.state.left.month ? +selectMonth + 1 : selectMonth : _this.state.right.month,
                day: (0, _moment["default"])(_this.state.startTime).isBefore(text) ? selectYear == _this.state.left.year && selectMonth == _this.state.left.month ? _this.state.right.day : selectDay : _this.state.right.day
              })
            });
          }
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerChange", function (select, date) {
      if (_this.state.endTime) {
        _this.setState((0, _defineProperty2["default"])({
          startTime: date.time,
          endTime: '',
          hoverTime: ''
        }, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
          text: date.time,
          year: date.year,
          month: date.month,
          day: date.day
        })));
      } else if (_this.state.startTime) {
        var startTime = _this.state.startTime,
          endTime;
        if ((0, _moment["default"])(startTime).isBefore(date.time)) {
          endTime = date.time;
        } else {
          endTime = startTime;
          startTime = date.time;
        }
        _this.setState({
          startTime: startTime,
          endTime: endTime,
          historyStartTime: startTime,
          historyEndTime: endTime,
          hoverTime: '',
          value: [(0, _moment["default"])(startTime).format(_this.props.dateFormat), (0, _moment["default"])(endTime).format(_this.props.dateFormat)],
          left: _objectSpread(_objectSpread({}, _this.state.left), {}, {
            text: startTime
          }),
          right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
            text: endTime
          })
        }, function () {
          _this.props.onChange && _this.props.onChange([(0, _moment["default"])(startTime).format(_this.props.dateFormat), (0, _moment["default"])(endTime).format(_this.props.dateFormat)]);
        });
      } else {
        _this.setState((0, _defineProperty2["default"])({
          startTime: date.time,
          endTime: '',
          hoverTime: ''
        }, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
          text: date.time,
          year: date.year,
          month: date.month,
          day: date.day
        })));
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDayPickerHover", function (select, date) {
      var startTime = _this.state.startTime,
        endTime = _this.state.endTime;
      if (startTime && endTime == '') {
        _this.setState({
          hoverTime: date.time,
          left: _objectSpread(_objectSpread({}, _this.state.left), {}, {
            text: (0, _moment["default"])(startTime).isBefore(date.time) ? startTime : date.time
          }),
          right: _objectSpread(_objectSpread({}, _this.state.right), {}, {
            text: (0, _moment["default"])(startTime).isBefore(date.time) ? date.time : startTime
          })
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthAndYearChange", function (select, date) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        year: date.year,
        month: date.month
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMonthPickerChange", function (select, date) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        datePickerLevel: 'day',
        year: date.year,
        month: date.month
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleYearPickerChange", function (select, year) {
      _this.setState((0, _defineProperty2["default"])({}, select, _objectSpread(_objectSpread({}, _this.state[select]), {}, {
        datePickerLevel: 'month',
        year: year
      })));
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function (e) {
      if (_this.validValue) {
        _this.setState({
          popupVisible: !_this.state.popupVisible
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      var dateFormat = _this.props.dateFormat,
        _this$state = _this.state,
        left = _this$state.left,
        right = _this$state.right,
        startTime = _this$state.startTime,
        endTime = _this$state.endTime,
        historyStartTime = _this$state.historyStartTime,
        historyEndTime = _this$state.historyEndTime,
        hoverTime = _this$state.hoverTime,
        leftDate = _objectSpread(_objectSpread({}, left), {}, {
          datePickerLevel: 'day',
          text: !endTime ? historyStartTime : left.text,
          year: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyStartTime).format('YYYY') : left.year : left.year,
          month: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyStartTime).format('MM') : left.month : left.month,
          day: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyStartTime).format('DD') : left.day : left.day
        }),
        rightDate = _objectSpread(_objectSpread({}, right), {}, {
          datePickerLevel: 'day',
          text: !endTime ? historyEndTime : right.text,
          year: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyStartTime).format('YYYY') == (0, _moment["default"])(historyEndTime).format('YYYY') && (0, _moment["default"])(historyStartTime).format('MM') == (0, _moment["default"])(historyEndTime).format('MM') ? (0, _moment["default"])(historyEndTime).format('MM') == 12 ? +(0, _moment["default"])(historyEndTime).format('YYYY') + 1 : (0, _moment["default"])(historyEndTime).format('YYYY') : (0, _moment["default"])(historyEndTime).format('YYYY') : right.year : right.year,
          month: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyStartTime).format('YYYY') == (0, _moment["default"])(historyEndTime).format('YYYY') && (0, _moment["default"])(historyStartTime).format('MM') == (0, _moment["default"])(historyEndTime).format('MM') ? (0, _moment["default"])(historyEndTime).format('MM') == 12 ? 1 : +(0, _moment["default"])(historyEndTime).format('MM') + 1 : (0, _moment["default"])(historyEndTime).format('MM') : right.month : right.month,
          day: !endTime ? historyStartTime && historyEndTime ? (0, _moment["default"])(historyEndTime).format('DD') : right.day : right.day
        });
      !_this.props.disabled && _this.setState({
        popupVisible: false,
        startTime: !endTime ? historyStartTime : startTime,
        endTime: !endTime ? historyEndTime : endTime,
        hoverTime: !endTime ? '' : hoverTime,
        value: [(0, _moment["default"])(leftDate.text, dateFormat), (0, _moment["default"])(rightDate.text, dateFormat)],
        left: leftDate,
        right: rightDate
      }, function () {
        _this.props.onChange && _this.props.onChange([(0, _moment["default"])(leftDate.text, dateFormat), (0, _moment["default"])(rightDate.text, dateFormat)]);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (pop) {
      if (_this.props.position) {
        return;
      }
      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(pop));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setValue", function (value, format) {
      if (value && value.length > 1) {
        var leftValue = value[0],
          rightValue = value[1];
        if (!!leftValue) {
          if ((0, _moment["default"])(leftValue, format).isValid() || !!rightValue && (0, _moment["default"])(leftValue, format).isValid()) {
            var left = _objectSpread(_objectSpread({}, _this.state.left), {}, {
                text: leftValue,
                year: (0, _moment["default"])(value[0]).format('YYYY'),
                month: (0, _moment["default"])(value[0]).format('MM'),
                day: (0, _moment["default"])(value[0]).format('DD')
              }),
              right = _objectSpread(_objectSpread({}, _this.state.right), {}, {
                text: rightValue,
                year: rightValue ? (0, _moment["default"])(value[1]).format('YYYY') : (0, _moment["default"])(value[0]).format('YYYY'),
                month: rightValue ? (0, _moment["default"])(value[1]).format('MM') : (0, _moment["default"])(value[0]).format('MM'),
                day: rightValue ? (0, _moment["default"])(value[1]).format('DD') : (0, _moment["default"])(value[0]).format('DD')
              });
            _this.setState({
              left: _DateUtil["default"].setDateRange(left, right).start,
              right: _DateUtil["default"].setDateRange(left, right).end,
              startTime: leftValue,
              endTime: rightValue,
              historyStartTime: leftValue,
              historyEndTime: rightValue
            });
            // state.left.text = leftValue;
            // state.left.year = moment(value[0]).format('YYYY');
            // state.left.month = moment(value[0]).format('MM');
            // state.left.day = moment(value[0]).format('DD');
            // state.right.text = rightValue;
            // state.right.year = rightValue ? moment(value[1]).format('YYYY') : moment(value[0]).format('YYYY');
            // state.right.month = rightValue ? moment(value[1]).format('MM') : moment(value[0]).format('MM');
            // state.right.day = rightValue ? moment(value[1]).format('DD') : moment(value[0]).format('DD');
            // state.left = DateUtil.setDateRange(state.left, state.right).start;
            // state.right = DateUtil.setDateRange(state.left, state.right).end;
            // state.startTime = leftValue;
            // state.endTime = rightValue;
            // state.historyStartTime = leftValue;
            // state.historyEndTime = rightValue;
            // this.setState({
            //     startTime: leftValue,
            //     endTime: rightValue,
            //     historyStartTime: leftValue,
            //     historyEndTime: rightValue
            // });
          } else {
            _this.validValue = false;
            console.error('Invalid date');
          }
        } else {
          var _left = _objectSpread(_objectSpread({}, _this.state.left), {}, {
              text: '',
              year: (0, _moment["default"])().format('YYYY'),
              month: (0, _moment["default"])().format('MM'),
              day: (0, _moment["default"])().format('DD')
            }),
            _right = _objectSpread(_objectSpread({}, _this.state.right), {}, {
              text: '',
              year: (0, _moment["default"])().format('YYYY'),
              month: (0, _moment["default"])().format('MM'),
              day: (0, _moment["default"])().format('DD')
            });
          _this.setState({
            left: _DateUtil["default"].setDateRange(_left, _right).start,
            right: _DateUtil["default"].setDateRange(_left, _right).end,
            startTime: '',
            endTime: '',
            historyStartTime: '',
            historyEndTime: ''
          });
        }
      }
    });
    var _initValue = (0, _moment["default"])();
    _this.validValue = true;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    var _startTime = '',
      _endTime = '';
    _this.state = {
      value: props.value,
      // Moment object
      popupVisible: false,
      isAbove: false,
      left: {
        text: _startTime,
        datePickerLevel: 'day',
        year: _initValue.format('YYYY'),
        month: _initValue.format('MM'),
        day: _initValue.format('DD')
      },
      right: {
        text: _endTime,
        datePickerLevel: 'day',
        year: _initValue.format('MM') == 12 ? +_initValue.format('YYYY') + 1 : _initValue.format('YYYY'),
        month: _initValue.format('MM') == 12 ? 1 : +_initValue.format('MM') + 1,
        day: _initValue.format('DD')
      },
      startTime: '',
      endTime: '',
      historyStartTime: '',
      historyEndTime: '',
      hoverTime: ''
    };
    return _this;
  }
  (0, _createClass2["default"])(DateRangePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        value = _this$props.value,
        dateFormat = _this$props.dateFormat;
      this.setValue(value, dateFormat);
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        name = _this$props2.name,
        placeholder = _this$props2.placeholder,
        dateFormat = _this$props2.dateFormat,
        maxValue = _this$props2.maxValue,
        minValue = _this$props2.minValue,
        position = _this$props2.position,
        popupClassName = _this$props2.popupClassName,
        rightIconCls = _this$props2.rightIconCls,
        readOnly = _this$props2.readOnly,
        disabled = _this$props2.disabled,
        parentEl = _this$props2.parentEl,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded),
        _this$state2 = this.state,
        popupVisible = _this$state2.popupVisible,
        left = _this$state2.left,
        right = _this$state2.right,
        startTime = _this$state2.startTime,
        endTime = _this$state2.endTime,
        hoverTime = _this$state2.hoverTime,
        isAbove = _this$state2.isAbove,
        handleMonthAndYearChange = this.handleMonthAndYearChange,
        handleDayPickerChange = this.handleDayPickerChange,
        handleDatePickerChange = this.handleDatePickerChange,
        handleDayPickerHover = this.handleDayPickerHover,
        handleMonthPickerChange = this.handleMonthPickerChange,
        handleYearPickerChange = this.handleYearPickerChange;
      var textFieldValue = left.text && right.text ? left.text + '~ ' + right.text : '',
        maxYear = right.year,
        maxMonth = right.month;
      maxYear = maxMonth == 1 ? +maxYear - 1 : maxYear;
      maxMonth = maxMonth == 1 ? 11 : +maxMonth - 2;
      var maxDay = _DateUtil["default"].MonthDays(maxYear)[maxMonth],
        leftMaxValue = maxValue && (0, _moment["default"])([maxYear, maxMonth, maxDay]).isAfter(maxValue) ? maxValue : (0, _moment["default"])([maxYear, maxMonth, maxDay]).format('YYYY-MM-DD'),
        minYear = left.year,
        minMonth = left.month;
      minYear = minMonth == 12 ? +minYear + 1 : minYear;
      minMonth = minMonth == 12 ? 1 : +minMonth + 1;
      var rightMinValue = minValue && (0, _moment["default"])([minYear, minMonth - 1, 1]).isBefore(minValue) ? minValue : (0, _moment["default"])([minYear, minMonth - 1, 1]).format('YYYY-MM-DD'),
        leftProps = _objectSpread(_objectSpread({}, left), {}, {
          value: left.text,
          maxValue: maxValue && minValue ? (0, _moment["default"])(leftMaxValue).isAfter((0, _moment["default"])(maxValue)) ? maxValue : leftMaxValue : !maxValue && minValue ? _moment["default"].max((0, _moment["default"])(leftMaxValue), (0, _moment["default"])(minValue)).format('YYYY-MM-DD') : maxValue && !minValue ? (0, _moment["default"])(leftMaxValue).isAfter((0, _moment["default"])(maxValue)) ? maxValue : leftMaxValue : leftMaxValue,
          minValue: minValue,
          startTime: startTime,
          endTime: endTime,
          hoverTime: hoverTime,
          dateFormat: dateFormat
        }),
        rightProps = _objectSpread(_objectSpread({}, right), {}, {
          value: right.text,
          minValue: maxValue && minValue ? (0, _moment["default"])(rightMinValue).isAfter((0, _moment["default"])(minValue)) ? rightMinValue : minValue : !maxValue && minValue ? (0, _moment["default"])(rightMinValue).isAfter((0, _moment["default"])(minValue)) ? rightMinValue : minValue : maxValue && !minValue ? _moment["default"].max((0, _moment["default"])(rightMinValue), (0, _moment["default"])(maxValue)).format('YYYY-MM-DD') : rightMinValue,
          maxValue: maxValue,
          startTime: startTime,
          endTime: endTime,
          hoverTime: hoverTime,
          dateFormat: dateFormat
        });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('date-range-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: "date-range-picker-field",
        name: name,
        placeholder: placeholder,
        value: textFieldValue,
        readOnly: true,
        disabled: disabled,
        rightIconCls: rightIconCls,
        clearButtonVisible: false,
        isFocusedSelectAll: false,
        onClick: function onClick(e) {
          _this2.togglePopup(e);
        }
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        className: "date-range-picker-popup ".concat(popupClassName),
        visible: popupVisible,
        parentEl: parentEl,
        triggerEl: this.triggerEl,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        hasTriangle: false,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "calendar-date-input-wrap"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "DateRangePickerHeaderInput"
      }, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        className: "fl calendar-input",
        placeholder: placeholder,
        value: left.text,
        clearButtonVisible: false,
        readOnly: readOnly,
        onChange: function onChange(text) {
          _this2.handleTextFieldChange('left', text);
        }
      }), /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        className: "fl calendar-input",
        placeholder: placeholder,
        value: right.text,
        clearButtonVisible: false,
        readOnly: readOnly,
        onChange: function onChange(text) {
          _this2.handleTextFieldChange('right', text);
        }
      }))), left.datePickerLevel == 'day' ? /*#__PURE__*/_react["default"].createElement(_DayPicker["default"], (0, _extends2["default"])({}, restProps, leftProps, {
        isFooter: false,
        isRange: true,
        monthAndYearChange: function monthAndYearChange(date) {
          return handleMonthAndYearChange('left', date);
        },
        onChange: function onChange(date) {
          return handleDayPickerChange('left', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return handleDatePickerChange('left', pickerLevel);
        },
        hoverHandle: function hoverHandle(date) {
          return handleDayPickerHover('left', date);
        }
      })) : left.datePickerLevel == 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], (0, _extends2["default"])({}, restProps, leftProps, {
        onChange: function onChange(date) {
          return handleMonthPickerChange('left', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return handleDatePickerChange('left', pickerLevel);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], (0, _extends2["default"])({}, restProps, leftProps, {
        onChange: function onChange(date) {
          return handleYearPickerChange('left', date);
        }
      })), right.datePickerLevel == 'day' ? /*#__PURE__*/_react["default"].createElement(_DayPicker["default"], (0, _extends2["default"])({}, restProps, rightProps, {
        isFooter: false,
        isRange: true,
        monthAndYearChange: function monthAndYearChange(date) {
          return handleMonthAndYearChange('right', date);
        },
        onChange: function onChange(date) {
          return handleDayPickerChange('right', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return handleDatePickerChange('right', pickerLevel);
        },
        hoverHandle: function hoverHandle(date) {
          return handleDayPickerHover('left', date);
        }
      })) : right.datePickerLevel == 'month' ? /*#__PURE__*/_react["default"].createElement(_MonthPicker["default"], (0, _extends2["default"])({}, restProps, rightProps, {
        onChange: function onChange(date) {
          return handleMonthPickerChange('right', date);
        },
        previousClick: function previousClick(pickerLevel) {
          return handleDatePickerChange('right', pickerLevel);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_YearPicker["default"], (0, _extends2["default"])({}, restProps, rightProps, {
        onChange: function onChange(date) {
          return handleYearPickerChange('right', date);
        }
      }))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var value = _ComponentUtil["default"].getDerivedState(props, state, 'value'),
        dateFormat = _ComponentUtil["default"].getDerivedState(props, state, 'dateFormat');
      return {
        prevProps: props,
        dateFormat: dateFormat,
        value: value
      };
    }
  }]);
  return DateRangePicker;
}(_react.Component);
(0, _defineProperty2["default"])(DateRangePicker, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(DateRangePicker, "Position", _Position["default"]);
DateRangePicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * DateRangePicker input name.
   */
  name: _propTypes["default"].string,
  /**
   * This is the initial date value of the component.
   */
  value: _propTypes["default"].array,
  /**
   * The ending of a range of valid dates. The range includes the endDate.
   */
  maxValue: _propTypes["default"].string,
  /**
   * The beginning of a range of valid dates. The range includes the startDate.
   */
  minValue: _propTypes["default"].string,
  /**
   * DateRangePicker textField element placeholder.
   */
  placeholder: _propTypes["default"].string,
  /**
   * Date format.
   */
  dateFormat: _propTypes["default"].string,
  /**
   * If true,dateRangePicker textField is readOnly.
   */
  readOnly: _propTypes["default"].bool,
  /**
   * If true,dateRangePicker textField is disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the date selection box will displayed.
   */
  popupVisible: _propTypes["default"].bool,
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  previousYearIconCls: _propTypes["default"].string,
  previousMonthIconCls: _propTypes["default"].string,
  nextYearIconCls: _propTypes["default"].string,
  nextMonthIconCls: _propTypes["default"].string,
  parentEl: _propTypes["default"].object,
  /**
   * Callback function that is fired when the date value changes.
   */
  onChange: _propTypes["default"].func
};
DateRangePicker.defaultProps = {
  name: '',
  placeholder: 'Date',
  popupClassName: '',
  dateFormat: 'YYYY-MM-DD',
  previousYearIconCls: 'fas fa-angle-double-left',
  previousMonthIconCls: 'fas fa-angle-left',
  nextYearIconCls: 'fas fa-angle-double-right',
  nextMonthIconCls: 'fas fa-angle-right',
  position: _Position["default"].BOTTOM_LEFT,
  readOnly: false,
  disabled: false
};
var _default = DateRangePicker;
exports["default"] = _default;