"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _DraggableListItem = _interopRequireDefault(require("../_DraggableListItem"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _ListSeparator = _interopRequireDefault(require("../_statics/ListSeparator"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DraggableList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DraggableList, _Component);
  var _super = _createSuper(DraggableList);
  function DraggableList(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DraggableList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isListDisabled", function (listDisabled) {
      var data = _this.props.data,
        value = _this.state.value;
      return typeof listDisabled === 'function' ? listDisabled(value, data) : listDisabled;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemDisabled", function (listItemDisabled, item, itemDisabled) {
      var data = _this.props.data,
        value = _this.state.value;
      return listItemDisabled != null && (typeof listItemDisabled === 'function' ? listItemDisabled(item, value, data) : listItemDisabled) || itemDisabled != null && (typeof itemDisabled === 'function' ? itemDisabled(item, value, data) : itemDisabled);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isItemDragDisabled", function (item) {
      var _this$props = _this.props,
        data = _this$props.data,
        itemDragDisabled = _this$props.itemDragDisabled,
        value = _this.state.value;
      return itemDragDisabled != null && (typeof itemDragDisabled === 'function' ? itemDragDisabled(item, value, data) : itemDragDisabled);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemSelect", function (item, index) {
      var selectMode = _this.props.selectMode;
      var value = _this.state.value;
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        if (!value || !(0, _isArray["default"])(value)) {
          value = [];
        }
        value.push(item);
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        value = item;
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props2 = _this.props,
          onItemSelect = _this$props2.onItemSelect,
          onChange = _this$props2.onChange;
        onItemSelect && onItemSelect(item, index);
        onChange && onChange(value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleListItemDeselect", function (item, index) {
      var selectMode = _this.props.selectMode;
      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var _this$props3 = _this.props,
        valueField = _this$props3.valueField,
        displayField = _this$props3.displayField;
      var value = _this.state.value;
      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        value = value.filter(function (valueItem) {
          return _Util["default"].getValueByValueField(valueItem, valueField, displayField) !== _Util["default"].getValueByValueField(item, valueField, displayField);
        });
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props4 = _this.props,
          onItemDeselect = _this$props4.onItemDeselect,
          onChange = _this$props4.onChange;
        onItemDeselect && onItemDeselect(item, index);
        onChange && onChange(value, index);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemDragEnd", function (result) {
      /**
       *  result: {
       *      draggableId,
       *      type,
       *      source: {
       *          droppableId,
       *          index
       *      },
       *      destination: {
       *          droppableId,
       *          index
       *      }
       *  }
       */

      if (!result || !('draggableId' in result) || !result.source || !('index' in result.source) || !result.destination || !('index' in result.destination)) {
        return;
      }
      var data = _this.state.data;
      _Util["default"].reorder(data, result.source.index, result.destination.index);
      _this.setState({
        data: data
      }, function () {
        var _this$props5 = _this.props,
          handleItemDragEnd = _this$props5.handleItemDragEnd,
          onSequenceChange = _this$props5.onSequenceChange;
        handleItemDragEnd && handleItemDragEnd(result);
        onSequenceChange && onSequenceChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "renderListItem", function (item, index) {
      if (!item) {
        return;
      }
      var _this$props6 = _this.props,
        theme = _this$props6.theme,
        itemHeight = _this$props6.itemHeight,
        idField = _this$props6.idField,
        valueField = _this$props6.valueField,
        displayField = _this$props6.displayField,
        descriptionField = _this$props6.descriptionField,
        disabled = _this$props6.disabled,
        itemDisabled = _this$props6.itemDisabled,
        isLoading = _this$props6.isLoading,
        renderer = _this$props6.renderer,
        selectTheme = _this$props6.selectTheme,
        selectMode = _this$props6.selectMode,
        radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props6.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
        anchorIconCls = _this$props6.anchorIconCls,
        onItemClick = _this$props6.onItemClick,
        value = _this.state.value,
        self = (0, _assertThisInitialized2["default"])(_this),
        props = {
          index: index,
          style: {
            height: itemHeight
          },
          theme: item.theme || theme,
          selectTheme: item.selectTheme || selectTheme,
          radioUncheckedIconCls: item.radioUncheckedIconCls || radioUncheckedIconCls,
          radioCheckedIconCls: item.radioCheckedIconCls || radioCheckedIconCls,
          checkboxUncheckedIconCls: item.checkboxUncheckedIconCls || checkboxUncheckedIconCls,
          checkboxCheckedIconCls: item.checkboxCheckedIconCls || checkboxCheckedIconCls,
          checkboxIndeterminateIconCls: item.checkboxIndeterminateIconCls || checkboxIndeterminateIconCls,
          anchorIconCls: item.anchorIconCls || anchorIconCls,
          checked: _Calculation["default"].isItemChecked(item, value, self.props),
          selectMode: selectMode,
          renderer: renderer,
          onSelect: function onSelect() {
            self.handleListItemSelect(item, index);
          },
          onDeselect: function onDeselect() {
            self.handleListItemDeselect(item, index);
          }
        };
      return (0, _typeof2["default"])(item) === 'object' ? /*#__PURE__*/_react["default"].createElement(_DraggableListItem["default"], (0, _extends2["default"])({}, item, props, {
        key: item[idField] || index,
        data: item,
        value: _Util["default"].getValueByValueField(item, valueField, displayField),
        text: _Util["default"].getTextByDisplayField(item, displayField, valueField),
        desc: item[descriptionField] || null,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item, item.disabled),
        isLoading: isLoading || item.isLoading,
        isDragDisabled: _this.isItemDragDisabled(item),
        onClick: function onClick(e) {
          onItemClick && onItemClick(item, index, e);
          item.onClick && item.onClick(e);
        }
      })) : /*#__PURE__*/_react["default"].createElement(_DraggableListItem["default"], (0, _extends2["default"])({}, props, {
        key: index,
        data: item,
        value: item,
        text: item,
        disabled: _this.isListDisabled(disabled) || _this.isItemDisabled(itemDisabled, item),
        isLoading: isLoading,
        isDragDisabled: _this.isItemDragDisabled(item),
        onClick: function onClick(e) {
          return onItemClick && onItemClick(item, index, e);
        }
      }));
    });
    _this.state = {
      data: _props.data,
      value: _Calculation["default"].getInitValue(_props)
    };
    return _this;
  }
  (0, _createClass2["default"])(DraggableList, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props7 = this.props,
        children = _this$props7.children,
        className = _this$props7.className,
        style = _this$props7.style,
        disabled = _this$props7.disabled,
        onNodeDragStart = _this$props7.onNodeDragStart,
        data = this.state.data;
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
        onDragStart: onNodeDragStart,
        onDragEnd: this.handleItemDragEnd
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('draggable-list', (0, _defineProperty2["default"])({}, className, className)),
        disabled: disabled,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "droppable"
      }, function (dropProvided) {
        return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          ref: dropProvided.innerRef,
          className: "draggable-list-items"
        }, dropProvided.droppableProps), data && data.map(function (item, index) {
          return item === _ListSeparator["default"] ? /*#__PURE__*/_react["default"].createElement("div", {
            key: index,
            className: "draggable-list-separator"
          }) : _this2.renderListItem(item, index);
        }), dropProvided.placeholder);
      }), children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        data: _ComponentUtil["default"].getDerivedState(props, state, 'data'),
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return DraggableList;
}(_react.Component);
(0, _defineProperty2["default"])(DraggableList, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableList, "LIST_SEPARATOR", _ListSeparator["default"]);
(0, _defineProperty2["default"])(DraggableList, "Theme", _Theme["default"]);
DraggableList.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme of the list item.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the list item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The mode of listItem.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Children passed into the ListItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The list item's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The title value of the list button.
     */
    title: _propTypes["default"].string,
    /**
     * If true,the list item will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,
    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    /**
     * If true,the item will have center displayed ripple effect.
     */
    rippleDisplayCenter: _propTypes["default"].bool,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].symbol])),
  value: _propTypes["default"].any,
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the list will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * List item disabled callback.
   */
  itemDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  /**
   * If true, the list will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * List item drag disabled callback.
   */
  itemDragDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  anchorIconCls: _propTypes["default"].string,
  itemHeight: _propTypes["default"].number,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item touch tap.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item select.
   */
  onItemSelect: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item deselect.
   */
  onItemDeselect: _propTypes["default"].func,
  /**
   * Callback function fired when the list changed.
   */
  onChange: _propTypes["default"].func,
  onNodeDragStart: _propTypes["default"].func,
  handleItemDragEnd: _propTypes["default"].func,
  onSequenceChange: _propTypes["default"].func
};
DraggableList.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  itemDisabled: false,
  isLoading: false,
  itemDragDisabled: false,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square',
  anchorIconCls: 'fas fa-bars'
};
var _default = DraggableList;
exports["default"] = _default;