"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _classnames = _interopRequireDefault(require("classnames"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _DraggableTreeNode = _interopRequireDefault(require("../_DraggableTreeNode"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _TreeCalculation = _interopRequireDefault(require("../_vendors/TreeCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DraggableTree = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DraggableTree, _Component);
  var _super = _createSuper(DraggableTree);
  function DraggableTree(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DraggableTree);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }
      if (!_Calculation["default"].isItemChecked(node, value, _this.props)) {
        value.push(node);
      }
      if (!node.children || node.children.length < 1) {
        return;
      }
      var _iterator = _createForOfIteratorHelper(node.children),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var item = _step.value;
          _this.addRecursiveValue(item, value);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeRecursiveValue", function (node, value) {
      if (!node || !value) {
        return;
      }
      var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);
      if (index > -1) {
        value.splice(index, 1);
      }
      if (!node.children || node.children.length < 1) {
        return;
      }
      var _iterator2 = _createForOfIteratorHelper(node.children),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var item = _step2.value;
          _this.removeRecursiveValue(item, value);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateValue", function (value) {
      var _ref;
      var _this$props = _this.props,
        data = _this$props.data,
        valueField = _this$props.valueField,
        displayField = _this$props.displayField;
      var result = [];
      _Util["default"].postOrderTraverse((0, _isArray["default"])(data) ? (_ref = {}, (0, _defineProperty2["default"])(_ref, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref, "children", data), _ref) : data, function (node) {
        if (!(_VirtualRoot["default"] in node)) {
          if (!node.children || node.children.length < 1) {
            if (value.findIndex(function (item) {
              return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(node, valueField, displayField);
            }) > -1) {
              result.push(node);
            }
          } else {
            if (node.children.every(function (child) {
              return result.findIndex(function (item) {
                return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(child, valueField, displayField);
              }) > -1;
            })) {
              result.push(node);
            }
          }
        }
      });
      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTreeNodeSelect", function (node, path, e) {
      if (!node) {
        return;
      }
      var _this$props2 = _this.props,
        selectMode = _this$props2.selectMode,
        isSelectRecursive = _this$props2.isSelectRecursive;
      var value = _this.state.value;
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        if (!value || !(0, _isArray["default"])(value)) {
          value = [];
        }
        if (isSelectRecursive) {
          _this.addRecursiveValue(node, value);
          value = _this.updateValue(value);
        } else {
          value.push(node);
        }
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        value = node;
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props3 = _this.props,
          onNodeSelect = _this$props3.onNodeSelect,
          onChange = _this$props3.onChange;
        onNodeSelect && onNodeSelect(node, path, e);
        onChange && onChange(value, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTreeNodeDeselect", function (nodeData, path, e) {
      var selectMode = _this.props.selectMode;
      if (selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var isSelectRecursive = _this.props.isSelectRecursive;
      var value = _this.state.value;
      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        if (isSelectRecursive) {
          _this.removeRecursiveValue(node, value);
          value = _this.updateValue(value);
        } else {
          var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);
          if (index > -1) {
            value.splice(index, 1);
          }
        }
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props4 = _this.props,
          onNodeDeselect = _this$props4.onNodeDeselect,
          onChange = _this$props4.onChange;
        onNodeDeselect && onNodeDeselect(node, path, e);
        onChange && onChange(value, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeToggleStart", function () {
      var beforeNodeToggle = _this.props.beforeNodeToggle;
      if (beforeNodeToggle && beforeNodeToggle() === false) {
        return;
      }
      _this.setState({
        isNodeToggling: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeToggleEnd", function () {
      _this.setState({
        isNodeToggling: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNodeDragStart", function (initial) {
      var onNodeDragStart = _this.props.onNodeDragStart;
      onNodeDragStart && onNodeDragStart(initial);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onNodeDragEnd", function (result) {
      var _ref2;
      if (!result || !('draggableId' in result) || !result.source || !('index' in result.source) || !result.destination || !('index' in result.destination)) {
        return;
      }
      var data = _this.state.data,
        sourceIndex = result.source.index,
        destinationIndex = result.destination.index;
      _TreeCalculation["default"].findNodeById((0, _isArray["default"])(data) ? (_ref2 = {}, (0, _defineProperty2["default"])(_ref2, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref2, "children", data), _ref2) : data, result.draggableId, function (node, index, parent) {
        if (!parent.children || !(sourceIndex in parent.children) || !(destinationIndex in parent.children)) {
          return;
        }
        _Util["default"].reorder(parent.children, sourceIndex, destinationIndex);
        _this.setState({
          data: data
        }, function () {
          var _this$props5 = _this.props,
            onNodeDragEnd = _this$props5.onNodeDragEnd,
            onSequenceChange = _this$props5.onSequenceChange;
          onNodeDragEnd && onNodeDragEnd(result);
          onSequenceChange && onSequenceChange(data);
        });
      });
    });
    _this.state = {
      data: props.data,
      value: _Calculation["default"].getInitValue(props),
      isNodeToggling: false
    };
    return _this;
  }
  (0, _createClass2["default"])(DraggableTree, [{
    key: "render",
    value: function render() {
      var _ref3;
      var _this$props6 = this.props,
        children = _this$props6.children,
        className = _this$props6.className,
        style = _this$props6.style,
        theme = _this$props6.theme,
        allowCollapse = _this$props6.allowCollapse,
        collapsed = _this$props6.collapsed,
        collapsedIconCls = _this$props6.collapsedIconCls,
        expandedIconCls = _this$props6.expandedIconCls,
        radioUncheckedIconCls = _this$props6.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props6.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props6.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props6.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props6.checkboxIndeterminateIconCls,
        idField = _this$props6.idField,
        valueField = _this$props6.valueField,
        displayField = _this$props6.displayField,
        descriptionField = _this$props6.descriptionField,
        disabled = _this$props6.disabled,
        isLoading = _this$props6.isLoading,
        readOnly = _this$props6.readOnly,
        selectMode = _this$props6.selectMode,
        renderer = _this$props6.renderer,
        onNodeClick = _this$props6.onNodeClick,
        isNodeCollapsed = _this$props6.isNodeCollapsed,
        _this$state = this.state,
        data = _this$state.data,
        value = _this$state.value,
        isNodeToggling = _this$state.isNodeToggling;
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
        onDragStart: this.onNodeDragStart,
        onDragEnd: this.onNodeDragEnd
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('draggable-tree', (0, _defineProperty2["default"])({}, className, className)),
        disabled: disabled,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_DraggableTreeNode["default"], {
        data: (0, _isArray["default"])(data) ? (_ref3 = {}, (0, _defineProperty2["default"])(_ref3, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref3, "children", data), _ref3) : data,
        value: value,
        theme: theme,
        idField: idField,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        disabled: disabled,
        isLoading: isLoading,
        readOnly: readOnly,
        selectMode: selectMode,
        renderer: renderer,
        allowCollapse: allowCollapse,
        collapsed: collapsed,
        collapsedIconCls: collapsedIconCls,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        isNodeToggling: isNodeToggling,
        isNodeCollapsed: isNodeCollapsed,
        onClick: function onClick() {
          return onNodeClick && onNodeClick.apply(void 0, arguments);
        },
        onNodeToggleStart: this.handleNodeToggleStart,
        onNodeToggleEnd: this.handleNodeToggleEnd,
        onSelect: this.handleTreeNodeSelect,
        onDeselect: this.handleTreeNodeDeselect
      }), children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        data: _ComponentUtil["default"].getDerivedState(props, state, 'data'),
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return DraggableTree;
}(_react.Component);
(0, _defineProperty2["default"])(DraggableTree, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DraggableTree, "Theme", _Theme["default"]);
DraggableTree.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme of the tree node.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the tree node select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The mode of tree node.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Children passed into the tree node.
   */
  data: _propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    tip: _propTypes["default"].string,
    /**
     * The position of tip.
     */
    tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
    children: _propTypes["default"].array,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].array]),
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the tree will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true, the tree will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node touch tap.
   */
  onNodeClick: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node selected.
   */
  onNodeSelect: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node deselected.
   */
  onNodeDeselect: _propTypes["default"].func,
  /**
   * Callback function fired when the tree changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  isNodeCollapsed: _propTypes["default"].func,
  beforeNodeToggle: _propTypes["default"].func,
  onNodeDragStart: _propTypes["default"].func,
  onNodeDragEnd: _propTypes["default"].func,
  onSequenceChange: _propTypes["default"].func
};
DraggableTree.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isSelectRecursive: false,
  allowCollapse: true,
  collapsed: false
};
var _default = DraggableTree;
exports["default"] = _default;