"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _RaisedButton = _interopRequireDefault(require("../RaisedButton"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _excluded = ["children", "className", "triggerClassName", "popupClassName", "style", "triggerStyle", "popupStyle", "theme", "activatedTheme", "popupTheme", "position", "iconCls", "triggerValue", "title", "tip", "tipPosition", "rightIconCls", "disabled", "isLoading", "disableTouchRipple", "autoPopupWidth", "resetPopPositionWait", "parentEl", "triggerEl", "shouldFollowScroll", "onMouseOver", "onMouseOut", "autoClose", "isBlurClose", "placeholderClassName", "onOpenPopup", "onClosePopup"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Dropdown = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Dropdown, _Component);
  var _super = _createSuper(Dropdown);
  function Dropdown(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Dropdown);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.trigger && _this.trigger.current && _this.trigger.current.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.trigger && _this.trigger.current && _this.trigger.current.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.trigger && _this.trigger.current && _this.trigger.current.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.pop && _this.pop.current && _this.pop.current.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function (e) {
      _this.setState({
        popupVisible: true
      }, function () {
        var _this$props = _this.props,
          onOpenPopup = _this$props.onOpenPopup,
          onFocus = _this$props.onFocus;
        onOpenPopup && onOpenPopup(e);
        onFocus && onFocus(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function (e) {
      _this.setState({
        popupVisible: false
      }, function () {
        var _this$props2 = _this.props,
          onClosePopup = _this$props2.onClosePopup,
          onBlur = _this$props2.onBlur;
        onClosePopup && onClosePopup(e);
        onBlur && onBlur(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRequestClose", function (e) {
      if (!_this.props.isBlurClose) {
        return;
      }
      _this.closePopup(e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "togglePopup", function (e) {
      var onTriggerClick = _this.props.onTriggerClick,
        popupVisible = _this.state.popupVisible;
      onTriggerClick && onTriggerClick(popupVisible, e);
      if (popupVisible) {
        _this.closePopup(e);
      } else {
        _this.openPopup(e);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      if (_this.props.position) {
        return;
      }
      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    _this.dropdown = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownEl = null;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      popupVisible: false,
      isAbove: false
    };
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(Dropdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownEl = this.dropdown && this.dropdown.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        children = _this$props3.children,
        className = _this$props3.className,
        triggerClassName = _this$props3.triggerClassName,
        popupClassName = _this$props3.popupClassName,
        style = _this$props3.style,
        triggerStyle = _this$props3.triggerStyle,
        popupStyle = _this$props3.popupStyle,
        theme = _this$props3.theme,
        activatedTheme = _this$props3.activatedTheme,
        popupTheme = _this$props3.popupTheme,
        position = _this$props3.position,
        iconCls = _this$props3.iconCls,
        triggerValue = _this$props3.triggerValue,
        title = _this$props3.title,
        tip = _this$props3.tip,
        tipPosition = _this$props3.tipPosition,
        rightIconCls = _this$props3.rightIconCls,
        disabled = _this$props3.disabled,
        isLoading = _this$props3.isLoading,
        disableTouchRipple = _this$props3.disableTouchRipple,
        autoPopupWidth = _this$props3.autoPopupWidth,
        resetPopPositionWait = _this$props3.resetPopPositionWait,
        parentEl = _this$props3.parentEl,
        triggerEl = _this$props3.triggerEl,
        shouldFollowScroll = _this$props3.shouldFollowScroll,
        onMouseOver = _this$props3.onMouseOver,
        onMouseOut = _this$props3.onMouseOut,
        autoClose = _this$props3.autoClose,
        isBlurClose = _this$props3.isBlurClose,
        placeholderClassName = _this$props3.placeholderClassName,
        onOpenPopup = _this$props3.onOpenPopup,
        onClosePopup = _this$props3.onClosePopup,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props3, _excluded),
        _this$state = this.state,
        popupVisible = _this$state.popupVisible,
        isAbove = _this$state.isAbove,
        isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove;
      return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        className: (0, _classnames["default"])('dropdown', (0, _defineProperty2["default"])({
          activated: popupVisible
        }, className, className)),
        style: style
      }), /*#__PURE__*/_react["default"].createElement(_RaisedButton["default"], {
        ref: this.trigger,
        className: (0, _classnames["default"])('dropdown-trigger', isAboveFinally ? 'above' : 'blow', (0, _defineProperty2["default"])({
          activated: popupVisible
        }, triggerClassName, triggerClassName)),
        style: triggerStyle,
        theme: popupVisible ? activatedTheme : theme,
        value: triggerValue,
        title: title,
        tip: tip,
        tipPosition: tipPosition,
        triggerEl: triggerEl,
        parentEl: parentEl,
        iconCls: iconCls,
        rightIconCls: "".concat(rightIconCls, " dropdown-trigger-icon"),
        disabled: disabled,
        isLoading: isLoading,
        disableTouchRipple: disableTouchRipple,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        onClick: this.togglePopup
      }), /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        ref: this.pop,
        className: (0, _classnames["default"])('dropdown-popup', isAboveFinally ? 'above' : 'blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: autoPopupWidth ? Object.assign({
          width: this.triggerEl && this.triggerEl.offsetWidth
        }, popupStyle) : popupStyle,
        theme: popupTheme,
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAboveFinally ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        resetPositionWait: resetPopPositionWait,
        shouldFollowScroll: shouldFollowScroll,
        onRender: this.handlePopupRender,
        onRequestClose: this.handleRequestClose
      }, children));
    }
  }]);
  return Dropdown;
}(_react.Component);
(0, _defineProperty2["default"])(Dropdown, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(Dropdown, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Dropdown, "TipPosition", _Position["default"]);
Dropdown.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  placeholderClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the trigger element.
   */
  triggerStyle: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme.
   */
  activatedTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The popup theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  parentEl: _propTypes["default"].object,
  triggerEl: _propTypes["default"].object,
  /**
   * The value of the dropDown trigger.
   */
  triggerValue: _propTypes["default"].any,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, the dropDown will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true, the dropDown will be loading.
   */
  isLoading: _propTypes["default"].bool,
  disableTouchRipple: _propTypes["default"].bool,
  /**
   * Whether following the trigger width or not.
   */
  autoPopupWidth: _propTypes["default"].bool,
  /**
   * If true, the dropdown box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * If true, the dropdown box automatically closed when blur.
   */
  isBlurClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  /**
   * Callback function fired when the popup is open.
   */
  onOpenPopup: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is close.
   */
  onClosePopup: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onTriggerClick: _propTypes["default"].func
};
Dropdown.defaultProps = {
  parentEl: document.body,
  theme: _Theme["default"].DEFAULT,
  activatedTheme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  rightIconCls: 'fas fa-angle-down',
  disabled: false,
  isLoading: false,
  disableTouchRipple: false,
  autoPopupWidth: true,
  autoClose: true,
  isBlurClose: true,
  tipPosition: _Position["default"].BOTTOM,
  resetPopPositionWait: 250
};
var _default = Dropdown;
exports["default"] = _default;