"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Popup = _interopRequireDefault(require("../Popup"));
var _List = _interopRequireDefault(require("../List"));
var _DynamicRenderList = _interopRequireDefault(require("../DynamicRenderList"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _DropdownCalculation = _interopRequireDefault(require("../_vendors/DropdownCalculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DropdownFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DropdownFilter, _Component);
  var _super = _createSuper(DropdownFilter);
  function DropdownFilter(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DropdownFilter);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "filterData", function () {
      var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.filter;
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.data;
      if (!filter) {
        return data;
      }
      var _this$props = _this.props,
        displayField = _this$props.displayField,
        filterCallback = _this$props.filterCallback;
      if (filterCallback) {
        return filterCallback(filter, data);
      }
      var filterFunc = function filterFunc(originData) {
        return originData.filter(function (item) {
          return (0, _typeof2["default"])(item) === 'object' && !!item[displayField] ? item[displayField].toString().toUpperCase().includes(filter.toUpperCase()) : item.toString().toUpperCase().includes(filter.toUpperCase());
        });
      };
      return filterFunc(data);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerFocus", function () {
      var _this$props2 = _this.props,
        disabled = _this$props2.disabled,
        onFocus = _this$props2.onFocus,
        filter = _this.state.filter;
      onFocus && onFocus.apply(void 0, arguments);
      !disabled && filter && _this.setState({
        popupVisible: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerBlur", function () {
      var _this$props3 = _this.props,
        disabled = _this$props3.disabled,
        onBlur = _this$props3.onBlur;
      !disabled && onBlur && onBlur.apply(void 0, arguments);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (filter) {
      var state = {
        filter: filter,
        popupVisible: !!filter
      };
      if (!filter) {
        state.value = undefined;
      }
      _this.setState(state, function () {
        var onFilterChange = _this.props.onFilterChange;
        onFilterChange && onFilterChange(filter);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterPressEnter", function (e, filter) {
      var autoClose = _this.props.autoClose,
        callback = function callback() {
          var onFilterPressEnter = _this.props.onFilterPressEnter;
          onFilterPressEnter && onFilterPressEnter(filter);
        };
      if (autoClose) {
        _this.setState({
          popupVisible: false
        }, function () {
          callback();
        });
      } else {
        callback();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.setState({
        popupVisible: false
      }, function () {
        var onPopupClosed = _this.props.onPopupClosed;
        onPopupClosed && onPopupClosed();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePopupRender", function (popupEl) {
      var isAbove = _DropdownCalculation["default"].isAbove(_this.dropdownFilterEl, _this.triggerEl, (0, _reactDom.findDOMNode)(popupEl));
      if (isAbove !== _this.state.isAbove) {
        _this.setState({
          isAbove: isAbove
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value) {
      var state = {
        value: value
      };
      if (_this.props.autoClose) {
        state.popupVisible = false;
      }
      _this.setState(state, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.dropdownFilter = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownFilterEl = null;
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.state = {
      value: props.value,
      filter: '',
      popupVisible: false,
      isAbove: false
    };
    return _this;
  }
  (0, _createClass2["default"])(DropdownFilter, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownFilterEl = this.dropdownFilter && this.dropdownFilter.current;
      this.triggerEl = this.trigger && this.trigger.current && (0, _reactDom.findDOMNode)(this.trigger.current);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
        className = _this$props4.className,
        popupClassName = _this$props4.popupClassName,
        style = _this$props4.style,
        popupStyle = _this$props4.popupStyle,
        theme = _this$props4.theme,
        popupTheme = _this$props4.popupTheme,
        placeholder = _this$props4.placeholder,
        selectMode = _this$props4.selectMode,
        disabled = _this$props4.disabled,
        iconCls = _this$props4.iconCls,
        rightIconCls = _this$props4.rightIconCls,
        valueField = _this$props4.valueField,
        displayField = _this$props4.displayField,
        descriptionField = _this$props4.descriptionField,
        position = _this$props4.position,
        useDynamicRenderList = _this$props4.useDynamicRenderList,
        listHeight = _this$props4.listHeight,
        itemHeight = _this$props4.itemHeight,
        scrollBuffer = _this$props4.scrollBuffer,
        noMatchedPopupVisible = _this$props4.noMatchedPopupVisible,
        noMatchedMsg = _this$props4.noMatchedMsg,
        popupChildren = _this$props4.popupChildren,
        renderer = _this$props4.renderer,
        parentEl = _this$props4.parentEl,
        radioUncheckedIconCls = _this$props4.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props4.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props4.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props4.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props4.checkboxIndeterminateIconCls,
        onItemClick = _this$props4.onItemClick,
        onFilterClear = _this$props4.onFilterClear,
        onMouseOver = _this$props4.onMouseOver,
        onMouseOut = _this$props4.onMouseOut,
        _this$state = this.state,
        isAbove = _this$state.isAbove,
        value = _this$state.value,
        filter = _this$state.filter,
        popupVisible = _this$state.popupVisible,
        isAboveFinally = position === _Position["default"].TOP || position === _Position["default"].TOP_LEFT || position === _Position["default"].TOP_RIGHT || !position && isAbove,
        listData = this.filterData(),
        isEmpty = listData.length < 1;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.dropdownFilter,
        className: (0, _classnames["default"])('dropdown-filter', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        ref: this.trigger,
        className: (0, _classnames["default"])('dropdown-filter-trigger', isEmpty && !noMatchedPopupVisible ? '' : popupVisible ? 'activated' : '', isAboveFinally ? 'above' : 'blow'),
        theme: theme,
        value: filter,
        placeholder: placeholder,
        disabled: disabled,
        iconCls: iconCls,
        rightIconCls: rightIconCls,
        onFocus: this.handleTriggerFocus,
        onBlur: this.handleTriggerBlur,
        onMouseOver: onMouseOver,
        onMouseOut: onMouseOut,
        onChange: this.handleFilterChange,
        onPressEnter: this.handleFilterPressEnter,
        onClear: onFilterClear,
        onRightIconClick: this.handleFilterPressEnter
      }), isEmpty && !noMatchedPopupVisible ? null : /*#__PURE__*/_react["default"].createElement(_Popup["default"], {
        className: (0, _classnames["default"])('dropdown-filter-popup', isAboveFinally ? ' above' : ' blow', (0, _defineProperty2["default"])({}, popupClassName, popupClassName)),
        style: Object.assign({
          width: this.triggerEl && getComputedStyle(this.triggerEl).width
        }, popupStyle),
        theme: popupTheme,
        visible: popupVisible,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        hasTriangle: false,
        position: position ? position : isAbove ? _Position["default"].TOP_LEFT : _Position["default"].BOTTOM_LEFT,
        onRender: this.handlePopupRender,
        onRequestClose: this.closePopup
      }, isEmpty ? /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "dropdown-filter-list",
        theme: popupTheme,
        selectMode: _SelectMode["default"].SINGLE_SELECT,
        data: [{
          itemRenderer: function itemRenderer() {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: "no-matched-list-item"
            }, noMatchedMsg ? noMatchedMsg : /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement("i", {
              className: "fas fa-exclamation-triangle no-matched-list-item-icon"
            }), "No matched value."));
          },
          disableTouchRipple: true
        }]
      }) : useDynamicRenderList ? /*#__PURE__*/_react["default"].createElement(_DynamicRenderList["default"], {
        className: "dropdown-filter-list",
        theme: popupTheme,
        value: value,
        selectMode: selectMode || _SelectMode["default"].SINGLE_SELECT,
        data: listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        listHeight: listHeight,
        itemHeight: itemHeight,
        scrollBuffer: scrollBuffer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }) : /*#__PURE__*/_react["default"].createElement(_List["default"], {
        className: "dropdown-filter-list",
        theme: popupTheme,
        value: value,
        selectMode: selectMode || _SelectMode["default"].SINGLE_SELECT,
        data: listData,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        renderer: renderer,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        onItemClick: onItemClick,
        onChange: this.handleChange
      }), popupChildren));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return DropdownFilter;
}(_react.Component);
(0, _defineProperty2["default"])(DropdownFilter, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(DropdownFilter, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(DropdownFilter, "Position", _Position["default"]);
DropdownFilter.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The placeholder of the field.
   */
  placeholder: _propTypes["default"].string,
  /**
   * Children passed into the List.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]).isRequired,
  value: _propTypes["default"].any,
  /**
   * If true, the auto complete will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the popup list automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * The type of dropDown list,can be normal,checkbox,radio.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Callback function fired when filter changed.
   */
  filterCallback: _propTypes["default"].func,
  /**
   * Use this property to display an icon.
   */
  iconCls: _propTypes["default"].string,
  /**
   * Use this property to display an icon.
   */
  rightIconCls: _propTypes["default"].string,
  /**
   * The visiblity of no matched popup.
   */
  noMatchedPopupVisible: _propTypes["default"].bool,
  /**
   * The message of no matched value.
   */
  noMatchedMsg: _propTypes["default"].string,
  popupChildren: _propTypes["default"].any,
  useDynamicRenderList: _propTypes["default"].bool,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  parentEl: _propTypes["default"].object,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * The function that trigger when filter changes.
   */
  onFilterChange: _propTypes["default"].func,
  /**
   * The function that trigger when press enter.
   */
  onFilterPressEnter: _propTypes["default"].func,
  /**
   * The function that trigger when filter cleared.
   */
  onFilterClear: _propTypes["default"].func,
  /**
   * The function that trigger when value changed.
   */
  onChange: _propTypes["default"].func,
  /**
   * The function that trigger when touch-tap the list items.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when DropdownFilter get focus.
   */
  onFocus: _propTypes["default"].func,
  /**
   * Callback function fired when DropdownFilter lose focus.
   */
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onPopupClosed: _propTypes["default"].func
};
DropdownFilter.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  data: [],
  disabled: false,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  rightIconCls: 'fas fa-search',
  noMatchedPopupVisible: true,
  useDynamicRenderList: false,
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = DropdownFilter;
exports["default"] = _default;