"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _trim = _interopRequireDefault(require("lodash/trim"));
var _EditableField = _interopRequireDefault(require("../EditableField"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _CharSize = _interopRequireDefault(require("../_vendors/CharSize"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var DynamicRenderTagField = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(DynamicRenderTagField, _Component);
  var _super = _createSuper(DynamicRenderTagField);
  function DynamicRenderTagField(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DynamicRenderTagField);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIndex", function () {
      var _this$props = _this.props,
        data = _this$props.data,
        listHeight = _this$props.listHeight,
        itemHeight = _this$props.itemHeight,
        scrollBuffer = _this$props.scrollBuffer,
        column = _this$props.column,
        scrollTop = _this.state.scrollTop;
      return _Calculation["default"].displayIndexByScrollTopMulColumns(data, listHeight, itemHeight, column, scrollTop, scrollBuffer);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function (e) {
      _this.setState({
        scrollTop: _this.wrapperEl ? _this.wrapperEl.scrollTop : 0
      }, function () {
        var onScroll = _this.props.onScroll;
        onScroll && onScroll(e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getSeparators", function () {
      var separators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.separators;
      return separators && separators.length > 0 ? separators : DEFAULT_SEPARATORS;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "generateSeparatorReg", function () {
      var separators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.separators;
      var seps = _this.getSeparators(separators);
      return new RegExp("\\s*".concat(seps ? seps.map(function (sep) {
        return "\\".concat(sep);
      }).join('|') : '', "\\s*"), 'g');
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeItem", function (index) {
      var data = _this.state.data;
      if (!data || data.length < 1 || !(index in data)) {
        return;
      }
      data.splice(index, 1);
      _this.setState({
        data: data
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      if (_this.props.disabled || _Dom["default"].findParentByClassName(e.target, 'tag-field-item-wrapper') || _Dom["default"].hasClass(e.target, 'tag-field-input')) {
        return;
      }
      var callback = function (e) {
        var _this2 = this;
        return function () {
          if (_this2.state.itemEditing || _this2.wrapperEl && _Dom["default"].findParentByClassName(e.target, 'dynamic-tag-field') != _this2.wrapperEl) {
            _this2.setState({
              inputIndex: _this2.state.data.length
            });
            return;
          }
          var x = e.clientX,
            y = e.clientY;
          if (!x || !y) {
            return;
          }
          var offset = _Dom["default"].getOffset(_this2.wrapperEl);
          if (!offset) {
            return;
          }

          // const inputIndex = this.calInputIndex(e);
          // this.setState({
          //     inputIndex
          // }, () => {
          setTimeout(function () {
            _this2.inputEl && _this2.inputEl.focus();
            // this.wrapperEl.scrollLeft = 0;
            // this.wrapperEl.scrollTop = 0;
          }, 0);
          // });
        };
      }.bind((0, _assertThisInitialized2["default"])(_this))(e);
      if (_this.state.inputValue) {
        _this.insertInputValue(callback);
      } else {
        callback();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputChange", function (e) {
      if (_this.props.disabled) {
        return;
      }
      var value = e.target.value,
        inputValue = value ? value.replace(/\r?\n/gm, '') : value;
      _this.setState({
        inputValue: inputValue
      }, function () {
        var onInputChange = _this.props.onInputChange,
          width = _CharSize["default"].calculateStringWidth(inputValue, _this.testEl);
        _this.inputWrapperEl && (_this.inputWrapperEl.style.width = "".concat(width + 9, "px"));
        _this.inputEl && (_this.inputEl.style.height = Math.max(_this.inputEl.scrollHeight, 24) + 'px');
        onInputChange && onInputChange(inputValue);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInputKeyDown", function (e) {
      if (_this.props.disabled) {
        return;
      }
      if (e.keyCode === 13) {
        _this.insertInputValue();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "insertInputValue", function (callback) {
      if (_this.props.disabled) {
        return;
      }
      var _this$state = _this.state,
        data = _this$state.data,
        inputValue = _this$state.inputValue,
        inputIndex = _this$state.inputIndex;
      if (!inputValue) {
        return;
      }
      var splitedValue = (0, _trim["default"])(inputValue).split(_this.generateSeparatorReg()).filter(function (item) {
        return !!item;
      });
      data.splice.apply(data, [inputIndex, 0].concat((0, _toConsumableArray2["default"])(splitedValue)));
      _this.setState({
        data: data,
        inputValue: '',
        inputIndex: inputIndex + splitedValue.length
      }, function () {
        _this.inputWrapperEl && (_this.inputWrapperEl.style.width = '9px');
        _this.inputEl && (_this.inputEl.style.height = '24px');
        var onChange = _this.props.onChange;
        onChange && onChange(data);
        callback && callback();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemChange", function (value, index) {
      if (_this.props.disabled) {
        return;
      }
      var data = _this.state.data;
      if (value) {
        var splitedValue = value.split(_this.generateSeparatorReg()).filter(function (item) {
          return item;
        });
        data.splice.apply(data, [index, 1].concat((0, _toConsumableArray2["default"])(splitedValue)));
      } else {
        data.splice(index, 1);
      }
      _this.setState({
        data: data
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemEditStart", function (editingItemIndex) {
      if (_this.props.disabled) {
        return;
      }
      _this.setState({
        itemEditing: true,
        editingItemIndex: editingItemIndex
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleItemEditEnd", function () {
      if (_this.props.disabled) {
        return;
      }
      _this.setState({
        itemEditing: false
      });
    });
    _this.inputSymbol = Symbol('input');
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    _this.inputWrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.inputWrapperEl = null;
    _this.input = /*#__PURE__*/(0, _react.createRef)();
    _this.inputEl = null;
    _this.test = /*#__PURE__*/(0, _react.createRef)();
    _this.testEl = null;
    _this.state = {
      scrollTop: 0,
      wrapperWidth: 'auto',
      data: props.data,
      inputValue: props.inputValue,
      inputIndex: props.data.length,
      itemEditing: false,
      editingItemIndex: -1
    };
    return _this;
  }
  (0, _createClass2["default"])(DynamicRenderTagField, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      _Event["default"].addEvent(document, 'mousedown', this.handleMouseDown);
      this.wrapperEl = this.wrapper && this.wrapper.current;
      this.inputWrapperEl = this.inputWrapper && this.inputWrapper.current;
      this.inputEl = this.input && this.input.current;
      this.testEl = this.test && this.test.current;
      this.setState({
        wrapperWidth: this.wrapperEl ? this.wrapperEl.clientWidth : 'auto'
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousedown', this.handleMouseDown);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        valueField = _this$props2.valueField,
        displayField = _this$props2.displayField,
        disabled = _this$props2.disabled,
        placeholder = _this$props2.placeholder,
        isTagAutoWidth = _this$props2.isTagAutoWidth,
        tagRemoveIconCls = _this$props2.tagRemoveIconCls,
        itemHeight = _this$props2.itemHeight,
        column = _this$props2.column,
        _this$state2 = this.state,
        wrapperWidth = _this$state2.wrapperWidth,
        data = _this$state2.data,
        inputValue = _this$state2.inputValue,
        inputIndex = _this$state2.inputIndex,
        displayIndex = this.getIndex(),
        filteredData = data && displayIndex ? data.slice(displayIndex.startWithBuffer, displayIndex.stopWithBuffer + 1) : data,
        indexData = _Util["default"].genIndexArray(filteredData.length);
      indexData.splice(inputIndex, 0, this.inputSymbol);
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('dynamic-tag-field', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled,
        onScroll: this.handleScroll
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "dynamic-render-list-scroller",
        style: {
          height: Math.ceil(data.length / column) * itemHeight
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "dynamic-render-tag-field-transform",
        style: {
          transform: "translateY(".concat(displayIndex.startWithBuffer * itemHeight / column, "px)"),
          height: indexData.length > 1 ? 'auto' : '108px'
        }
      }, indexData && indexData.map(function (index) {
        return index === _this3.inputSymbol ? null : /*#__PURE__*/_react["default"].createElement("span", {
          key: index,
          "data-index": index,
          className: (0, _classnames["default"])('tag-field-item-wrapper', (0, _defineProperty2["default"])({}, filteredData[index].className, filteredData[index].className))
        }, /*#__PURE__*/_react["default"].createElement(_EditableField["default"], {
          className: "tag-field-item-field",
          value: _Util["default"].getTextByDisplayField(filteredData[index], displayField, valueField),
          autoWidth: isTagAutoWidth,
          onChange: function onChange(value) {
            return _this3.handleItemChange(value, index + displayIndex.startWithBuffer);
          },
          onEditStart: function onEditStart() {
            return _this3.handleItemEditStart(index + displayIndex.startWithBuffer);
          },
          onEditEnd: _this3.handleItemEditEnd
        }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
          className: "tag-field-item-field-delete-button",
          iconCls: tagRemoveIconCls,
          onClick: function onClick() {
            return _this3.removeItem(index + displayIndex.startWithBuffer);
          }
        })));
      }))), /*#__PURE__*/_react["default"].createElement("div", {
        key: "input",
        ref: this.inputWrapper,
        className: "tag-field-input-wrapper"
      }, /*#__PURE__*/_react["default"].createElement("textarea", {
        ref: this.input,
        className: "tag-field-input",
        style: {
          width: wrapperWidth
        },
        autoFocus: true,
        value: inputValue,
        placeholder: filteredData.length < 1 && placeholder ? placeholder : '',
        onChange: this.handleInputChange,
        onKeyDown: this.handleInputKeyDown
      })), /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.test,
        className: "tag-field-test-container"
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        data: _ComponentUtil["default"].getDerivedState(props, state, 'data'),
        inputValue: _ComponentUtil["default"].getDerivedState(props, state, 'inputValue')
      };
    }
  }]);
  return DynamicRenderTagField;
}(_react.Component);
(0, _defineProperty2["default"])(DynamicRenderTagField, "DEFAULT_SEPARATORS", [',']);
DynamicRenderTagField.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  listHeight: _propTypes["default"].number,
  itemHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  column: _propTypes["default"].number,
  data: _propTypes["default"].array,
  inputValue: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  valueField: _propTypes["default"].string,
  displayField: _propTypes["default"].string,
  separators: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  isTagAutoWidth: _propTypes["default"].bool,
  tagRemoveIconCls: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onInputChange: _propTypes["default"].func,
  onScroll: _propTypes["default"].func
};
DynamicRenderTagField.defaultProps = {
  data: [],
  inputValue: '',
  valueField: 'value',
  displayField: 'text',
  separators: DynamicRenderTagField.DEFAULT_SEPARATORS,
  disabled: false,
  placeholder: '',
  isTagAutoWidth: true,
  tagRemoveIconCls: 'fas fa-times',
  listHeight: 200,
  itemHeight: 34,
  scrollBuffer: 24,
  column: 4
};
var _default = DynamicRenderTagField;
exports["default"] = _default;