"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var FlashNumber = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(FlashNumber, _Component);
  var _super = _createSuper(FlashNumber);
  function FlashNumber(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, FlashNumber);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "init", function () {
      _this.animationFrameId && cancelAnimationFrame(_this.animationFrameId);
      _this.startTime = undefined;
      _this.initValue = _this.currentValue;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "step", function (timeStamp) {
      // first request
      if (!_this.startTime) {
        _this.startTime = timeStamp;
      } else {
        // non first
        if (_this.wrapperEl) {
          // calculate value
          var v = _this.initValue + Math.round((_this.props.value - _this.initValue) * (timeStamp - _this.startTime) / _this.flashDuration);

          // valid value
          if (_this.props.value < _this.initValue) {
            // target value < init value
            _this.wrapperEl.innerHTML = _this.currentValue = v > _this.props.value ? v : _this.props.value;
          } else if (_this.props.value > _this.initValue) {
            // target value > init value
            _this.wrapperEl.innerHTML = _this.currentValue = v < _this.props.value ? v : _this.props.value;
          }
        }
      }

      // request next animationFrame if not finish
      if (_this.currentValue != _this.props.value) {
        _this.animationFrameId = requestAnimationFrame(_this.step);
      } else {
        _this.animationFrameId = undefined;
      }
    });
    _this.flashDuration = props.flashDuration; // flash animate duration
    _this.startTime; // animationFrame start timestamp
    _this.initValue = props.initValue; // value when animate start
    _this.animationFrameId; // animationFrame id
    _this.currentValue = 0; // current display value

    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;
    return _this;
  }
  (0, _createClass2["default"])(FlashNumber, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.wrapperEl = this.wrapper && this.wrapper.current;

      // start flash animate when value is not equal init value
      if (this.props.value != this.initValue) {
        this.animationFrameId = requestAnimationFrame(this.step);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (prevProps.value !== this.props.value) {
        this.init();
        this.animationFrameId = requestAnimationFrame(this.step);
      }
      if (prevProps.flashDuration !== this.flashDuration) {
        this.flashDuration = this.props.flashDuration;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style;
      return /*#__PURE__*/_react["default"].createElement("span", {
        ref: this.wrapper,
        className: (0, _classnames["default"])('flash-number', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, this.currentValue);
    }
  }]);
  return FlashNumber;
}(_react.Component);
FlashNumber.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Initial result value.
   */
  initValue: _propTypes["default"].number,
  /**
   * Result value.
   */
  value: _propTypes["default"].number,
  /**
   * Animation execution time.
   */
  flashDuration: _propTypes["default"].number
};
FlashNumber.defaultProps = {
  initValue: 0,
  value: 0,
  flashDuration: 450
};
var _default = FlashNumber;
exports["default"] = _default;