"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _List = _interopRequireDefault(require("../List"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _ListSeparator = _interopRequireDefault(require("../_statics/ListSeparator"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "className", "style", "data", "disabled"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var GroupList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(GroupList, _Component);
  var _super = _createSuper(GroupList);
  function GroupList(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, GroupList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    _this.state = {
      value: _Calculation["default"].getInitValue(props)
    };
    return _this;
  }
  (0, _createClass2["default"])(GroupList, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        style = _this$props.style,
        data = _this$props.data,
        disabled = _this$props.disabled,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('group-list', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        disabled: disabled
      }, data && data.map(function (item, index) {
        return item === _ListSeparator["default"] ? /*#__PURE__*/_react["default"].createElement("div", {
          key: index,
          className: "list-separator"
        }) : /*#__PURE__*/_react["default"].createElement("div", {
          key: index
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "group-list-group-title"
        }, item.name), /*#__PURE__*/_react["default"].createElement(_List["default"], (0, _extends2["default"])({}, restProps, {
          data: item.children,
          value: value
        })));
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return GroupList;
}(_react.Component);
(0, _defineProperty2["default"])(GroupList, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(GroupList, "LIST_SEPARATOR", _ListSeparator["default"]);
(0, _defineProperty2["default"])(GroupList, "Theme", _Theme["default"]);
GroupList.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the list item select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * Children passed into the ListItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    // group name
    name: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    children: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
      /**
       * The CSS class name of the list button.
       */
      className: _propTypes["default"].string,
      /**
       * Override the styles of the list button.
       */
      style: _propTypes["default"].object,
      /**
       * The theme of the list button.
       */
      theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
      /**
       * The text value of the list button.Type can be string or number.
       */
      value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
      /**
       * The list item's display text. Type can be string, number or bool.
       */
      text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
      /**
       * The desc value of the list button. Type can be string or number.
       */
      desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
      /**
       * If true,the list item will be disabled.
       */
      disabled: _propTypes["default"].bool,
      /**
       * If true,the button will be have loading effect.
       */
      isLoading: _propTypes["default"].bool,
      /**
       * If true,the element's ripple effect will be disabled.
       */
      disableTouchRipple: _propTypes["default"].bool,
      /**
       * Use this property to display an icon. It will display on the left.
       */
      iconCls: _propTypes["default"].string,
      /**
       * Use this property to display an icon. It will display on the right.
       */
      rightIconCls: _propTypes["default"].string,
      /**
       * The message of tip.
       */
      tip: _propTypes["default"].string,
      /**
       * The position of tip.
       */
      tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Tip["default"].Position)),
      /**
       * If true,the item will have center displayed ripple effect.
       */
      rippleDisplayCenter: _propTypes["default"].bool,
      /**
       * You can create a complicated renderer callback instead of value and desc prop.
       */
      itemRenderer: _propTypes["default"].func,
      /**
       * Callback function fired when a list item touch-tapped.
       */
      onClick: _propTypes["default"].func
    }), _propTypes["default"].string, _propTypes["default"].number]))
  }), _propTypes["default"].symbol])).isRequired,
  /**
   * The id field name in data. (default: "id")
   */
  idField: _propTypes["default"].string,
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the list will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true, the list will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * The mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the list-item select.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when the list changed.
   */
  onChange: _propTypes["default"].func
};
GroupList.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  data: [],
  idField: 'id',
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  radioUncheckedIconCls: 'fas fa-check',
  radioCheckedIconCls: 'fas fa-check',
  checkboxUncheckedIconCls: 'far fa-square',
  checkboxCheckedIconCls: 'fas fa-check-square',
  checkboxIndeterminateIconCls: 'fas fa-minus-square'
};
var _default = GroupList;
exports["default"] = _default;