"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var HuePicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(HuePicker, _Component);
  var _super = _createSuper(HuePicker);
  function HuePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, HuePicker);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calcSliderLeft", function () {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state.value;
      if (!value || !_this.huePickerBarEl || !_this.huePickerSliderEl) {
        return 0;
      }
      var barWidth = _this.huePickerBarEl.offsetWidth,
        sliderWidth = _this.huePickerSliderEl.offsetWidth,
        width = barWidth - sliderWidth;
      return value / 360 * width;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseDown", function (e) {
      _this.activated = true;
      _this.handleChange(e.pageX);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      if (_this.activated) {
        _this.handleChange(e.pageX);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseUp", function () {
      _this.activated = false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (mouseX) {
      var _Dom$getOffset = _Dom["default"].getOffset(_this.huePickerBarEl),
        left = _Dom$getOffset.left,
        barWidth = _this.huePickerBarEl.offsetWidth,
        sliderWidth = _this.huePickerSliderEl.offsetWidth,
        halfSliderWidth = sliderWidth / 2,
        width = barWidth - sliderWidth,
        offsetX = _Valid["default"].range(mouseX - halfSliderWidth - left, 0, width),
        perCent = offsetX / width,
        value = Math.round(perCent * 360);
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.activated = false;
    _this.huePickerBar = /*#__PURE__*/(0, _react.createRef)();
    _this.huePickerBarEl = null;
    _this.huePickerSlider = /*#__PURE__*/(0, _react.createRef)();
    _this.huePickerSliderEl = null;
    _this.state = {
      value: props.value
    };
    return _this;
  }

  /**
   * get slider css left by hue value
   * @param value
   * @returns {number}
   */
  (0, _createClass2["default"])(HuePicker, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.huePickerBarEl = this.huePickerBar && this.huePickerBar.current;
      this.huePickerSliderEl = this.huePickerSlider && this.huePickerSlider.current;
      _Event["default"].addEvent(document, 'mousemove', this.handleMouseMove);
      _Event["default"].addEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(document, 'mousemove', this.handleMouseMove);
      _Event["default"].removeEvent(document, 'mouseup', this.handleMouseUp);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('hue-picker', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.huePickerBar,
        className: "hue-picker-bar",
        onMouseDown: this.handleMouseDown
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.huePickerSlider,
        className: "hue-picker-slider",
        style: {
          left: this.calcSliderLeft()
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: Math.round(_ComponentUtil["default"].getDerivedState(props, state, 'value'))
      };
    }
  }]);
  return HuePicker;
}(_react.Component);
HuePicker.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * hue value (deg).
   */
  value: _propTypes["default"].number,
  onChange: _propTypes["default"].func
};
HuePicker.defaultProps = {
  value: 0
};
var _default = HuePicker;
exports["default"] = _default;