"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _MaterialProvider = _interopRequireDefault(require("../MaterialProvider"));
var _Dropdown = _interopRequireDefault(require("../Dropdown"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["className", "style", "theme", "label", "isLabelAnimate", "disabled", "required"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialDropdown = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialDropdown, _Component);
  var _super = _createSuper(MaterialDropdown);
  function MaterialDropdown(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialDropdown);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdownInstance && _this.dropdownInstance.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdownInstance && _this.dropdownInstance.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.dropdownInstance && _this.dropdownInstance.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdownInstance && _this.dropdownInstance.closePopup();
    });
    _this.dropdown = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownInstance = null;
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(MaterialDropdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownInstance = this.dropdown && this.dropdown.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        label = _this$props.label,
        isLabelAnimate = _this$props.isLabelAnimate,
        disabled = _this$props.disabled,
        required = _this$props.required,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_MaterialProvider["default"], {
        className: (0, _classnames["default"])('material-dropdown', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        theme: theme,
        label: label,
        isLabelAnimate: isLabelAnimate,
        disabled: disabled,
        required: required
      }, /*#__PURE__*/_react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdown,
        className: "material-dropdown-content",
        disabled: disabled
      })));
    }
  }]);
  return MaterialDropdown;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialDropdown, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialDropdown, "Position", _Position["default"]);
(0, _defineProperty2["default"])(MaterialDropdown, "TipPosition", _Position["default"]);
MaterialDropdown.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The class name of the trigger element.
   */
  triggerClassName: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the trigger element.
   */
  triggerStyle: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The popup theme.
   */
  popupTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The label of the dropdown.
   */
  label: _propTypes["default"].any,
  /**
   * The animate of the dropdown.
   */
  isLabelAnimate: _propTypes["default"].bool,
  /**
   * The value of the dropDown trigger.
   */
  triggerValue: _propTypes["default"].any,
  /**
   * The placeholder of the dropDown trigger.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  /**
   * If true, the dropDown will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true, the dropDown will be loading.
   */
  isLoading: _propTypes["default"].bool,
  disableTouchRipple: _propTypes["default"].bool,
  /**
   * If true,the dropdown box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  /**
   * Callback function fired when the popup is closed.
   */
  onClosePopup: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onMouseOver: _propTypes["default"].func,
  onMouseOut: _propTypes["default"].func,
  onTriggerClick: _propTypes["default"].func
};
MaterialDropdown.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  popupTheme: _Theme["default"].DEFAULT,
  label: '',
  isLabelAnimate: true,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  disabled: false,
  isLoading: false,
  disableTouchRipple: false,
  autoClose: true,
  required: false,
  tipPosition: _Position["default"].BOTTOM,
  resetPopPositionWait: 250
};
var _default = MaterialDropdown;
exports["default"] = _default;