"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _DropdownSelect = _interopRequireDefault(require("../DropdownSelect"));
var _MaterialProvider = _interopRequireDefault(require("../MaterialProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "theme", "label", "isLabelAnimate", "disabled", "required", "selectMode"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialDropdownSelect = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialDropdownSelect, _Component);
  var _super = _createSuper(MaterialDropdownSelect);
  function MaterialDropdownSelect(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialDropdownSelect);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.startRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.endRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.triggerRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPopupPosition", function () {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "openPopup", function () {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.openPopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "closePopup", function () {
      _this.dropdownSelectInstance && _this.dropdownSelectInstance.closePopup();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerChange", function (value) {
      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(value);
      });
    });
    _this.dropdownSelect = /*#__PURE__*/(0, _react.createRef)();
    _this.dropdownSelectInstance = null;
    _this.state = {
      value: _props.value,
      isFocus: false
    };
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(MaterialDropdownSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.dropdownSelectInstance = this.dropdownSelect && this.dropdownSelect.current;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        label = _this$props.label,
        isLabelAnimate = _this$props.isLabelAnimate,
        disabled = _this$props.disabled,
        required = _this$props.required,
        selectMode = _this$props.selectMode,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement(_MaterialProvider["default"], {
        className: (0, _classnames["default"])('material-dropdown-select', (0, _defineProperty2["default"])({}, className, className)),
        style: style,
        theme: theme,
        label: label,
        isLabelAnimate: isLabelAnimate,
        hasValue: selectMode === _SelectMode["default"].MULTI_SELECT ? value && value.length > 0 : !!value,
        disabled: disabled,
        required: required
      }, /*#__PURE__*/_react["default"].createElement(_DropdownSelect["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.dropdownSelect,
        value: value,
        selectMode: selectMode,
        disabled: disabled,
        onChange: this.handleTriggerChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value')
      };
    }
  }]);
  return MaterialDropdownSelect;
}(_react.Component);
(0, _defineProperty2["default"])(MaterialDropdownSelect, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(MaterialDropdownSelect, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(MaterialDropdownSelect, "Position", _Position["default"]);
(0, _defineProperty2["default"])(MaterialDropdownSelect, "TipPosition", _Position["default"]);
MaterialDropdownSelect.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The class name of the popup element.
   */
  popupClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Override the styles of the popup element.
   */
  popupStyle: _propTypes["default"].object,
  /**
   * The theme.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * The name of the dropDownSelect.
   */
  name: _propTypes["default"].string,
  /**
   * The label of the text field.
   */
  label: _propTypes["default"].any,
  /**
   * The animate of the text field.
   */
  isLabelAnimate: _propTypes["default"].bool,
  /**
   * The value of the dropDownSelect.
   */
  value: _propTypes["default"].any,
  /**
   * The placeholder of the dropDownSelect.
   */
  placeholder: _propTypes["default"].string,
  title: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rightIconCls: _propTypes["default"].string,
  /**
   * The options data.
   */
  data: _propTypes["default"].oneOfType([
  // not grouped
  _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the list button.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the list button.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the list button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the list button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the list button. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the list button will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    renderer: _propTypes["default"].func,
    /**
     * Callback function fired when a list item touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].string, _propTypes["default"].number])),
  // grouped
  _propTypes["default"].array]),
  /**
   * The invalid message of dropDownSelect.
   */
  invalidMsg: _propTypes["default"].string,
  /**
   * If true,the dropDownSelect will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * If true,the dropDownSelect will be loading.
   */
  isLoading: _propTypes["default"].bool,
  /**
   * The mode of listItem.Can be normal,checkbox.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * The message of the dropDownSelect.
   */
  infoMsg: _propTypes["default"].string,
  /**
   * Use this function to format the options's text.
   */
  textFormat: _propTypes["default"].func,
  /**
   * If true,the drop-down box automatically closed after selection.
   */
  autoClose: _propTypes["default"].bool,
  /**
   * If true,the drop-down box will have search input.
   */
  useFilter: _propTypes["default"].bool,
  filterIconCls: _propTypes["default"].string,
  filterPlaceholder: _propTypes["default"].string,
  useSelectAll: _propTypes["default"].bool,
  selectAllText: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * The message of no matching option.
   */
  noMatchedMsg: _propTypes["default"].string,
  /**
   * If true,the drop-down box will be have group selection.
   */
  isGrouped: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  resetPopPositionWait: _propTypes["default"].number,
  /**
   * Callback function fired when the button is touch-tapped.
   */
  onItemClick: _propTypes["default"].func,
  /**
   * Callback function fired when the popup is closed.
   */
  onClosePopup: _propTypes["default"].func,
  /**
   * Callback function fired when a menu item is selected.
   */
  onChange: _propTypes["default"].func,
  onWheel: _propTypes["default"].func
};
MaterialDropdownSelect.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isLabelAnimate: true,
  placeholder: 'Please select ...',
  rightIconCls: 'fas fa-angle-down',
  data: [],
  disabled: false,
  isLoading: false,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  autoClose: true,
  useFilter: false,
  filterIconCls: 'fas fa-search',
  filterPlaceholder: 'Search ...',
  useSelectAll: false,
  selectAllText: 'Select All',
  isGrouped: false,
  required: false,
  tipPosition: _Position["default"].BOTTOM,
  resetPopPositionWait: 250
};
var _default = MaterialDropdownSelect;
exports["default"] = _default;