"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _MaterialFieldSeparator = _interopRequireDefault(require("../_MaterialFieldSeparator"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["children", "className", "theme", "label", "isLabelAnimate", "hasValue", "disabled", "required", "useSeparator"],
  _excluded2 = ["triggerClassName", "placeholderClassName"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var MaterialProvider = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(MaterialProvider, _Component);
  var _super = _createSuper(MaterialProvider);
  function MaterialProvider(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, MaterialProvider);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "focus", function () {
      _this.setState({
        isFocus: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "blur", function () {
      _this.setState({
        isFocus: false
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "setHovered", function (isHover) {
      _this.setState({
        isHover: isHover
      });
    });
    _this.state = {
      isHover: false,
      isFocus: false
    };
    return _this;
  }
  (0, _createClass2["default"])(MaterialProvider, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        theme = _this$props.theme,
        label = _this$props.label,
        isLabelAnimate = _this$props.isLabelAnimate,
        hasValue = _this$props.hasValue,
        disabled = _this$props.disabled,
        required = _this$props.required,
        useSeparator = _this$props.useSeparator,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        _this$state = this.state,
        isHover = _this$state.isHover,
        isFocus = _this$state.isFocus;
      return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('material-provider', "theme-".concat(theme), (0, _defineProperty2["default"])({
          'has-label': label,
          'has-value': hasValue,
          'has-separator': useSeparator,
          animated: isLabelAnimate,
          focused: isFocus
        }, className, className)),
        disabled: disabled
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "material-provider-label-wrapper"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "material-provider-label"
      }, label), required ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "material-provider-required-dot"
      }) : null), _react.Children.map(children, function (child) {
        var _child$props = child.props,
          triggerClassName = _child$props.triggerClassName,
          placeholderClassName = _child$props.placeholderClassName,
          restProps = (0, _objectWithoutProperties2["default"])(_child$props, _excluded2),
          props = _objectSpread(_objectSpread({}, restProps), {}, {
            className: (0, _classnames["default"])('material-provider-field', (0, _defineProperty2["default"])({}, restProps.className, restProps.className)),
            onFocus: function onFocus() {
              restProps.onFocus && restProps.onFocus.apply(restProps, arguments);
              _this2.focus();
            },
            onBlur: function onBlur() {
              restProps.onBlur && restProps.onBlur.apply(restProps, arguments);
              _this2.blur();
            },
            onMouseOver: function onMouseOver() {
              restProps.onMouseOver && restProps.onMouseOver.apply(restProps, arguments);
              _this2.setHovered(true);
            },
            onMouseOut: function onMouseOut() {
              restProps.onMouseOut && restProps.onMouseOut.apply(restProps, arguments);
              _this2.setHovered(false);
            }
          });

        // react component element
        if (typeof child.type !== 'string') {
          props.triggerClassName = (0, _classnames["default"])('material-provider-field-trigger', (0, _defineProperty2["default"])({}, triggerClassName, triggerClassName));
          props.placeholderClassName = (0, _classnames["default"])('material-provider-field-placeholder', (0, _defineProperty2["default"])({}, placeholderClassName, placeholderClassName));
        }
        return /*#__PURE__*/(0, _react.cloneElement)(child, props);
      }), useSeparator ? /*#__PURE__*/_react["default"].createElement(_MaterialFieldSeparator["default"], {
        theme: theme,
        isHover: isHover,
        isFocus: isFocus,
        disabled: disabled
      }) : null);
    }
  }]);
  return MaterialProvider;
}(_react.Component);
MaterialProvider.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  label: _propTypes["default"].any,
  isLabelAnimate: _propTypes["default"].bool,
  hasValue: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  useSeparator: _propTypes["default"].bool
};
MaterialProvider.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isLabelAnimate: true,
  hasValue: false,
  disabled: false,
  required: false,
  useSeparator: true
};
var _default = MaterialProvider;
exports["default"] = _default;