"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TriggerPop = _interopRequireDefault(require("../_TriggerPop"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["className", "contentClassName", "closeWait", "onRequestClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Popover = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Popover, _Component);
  var _super = _createSuper(Popover);
  function Popover(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Popover);
    for (var _len = arguments.length, _restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      _restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(_restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var _this$popInstance, _this$popInstance$res;
      (_this$popInstance = _this.popInstance) === null || _this$popInstance === void 0 ? void 0 : (_this$popInstance$res = _this$popInstance.resetPosition) === null || _this$popInstance$res === void 0 ? void 0 : _this$popInstance$res.call(_this$popInstance);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearCloseTimeout", function () {
      if (_this.closeTimeout) {
        clearTimeout(_this.closeTimeout);
        _this.closeTimeout = null;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function () {
      _this.clearCloseTimeout();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      _this.clearCloseTimeout();
      _this.closeTimeout = setTimeout(function () {
        var _this$props$onRequest, _this$props;
        return (_this$props$onRequest = (_this$props = _this.props).onRequestClose) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call(_this$props, e);
      }, _this.props.closeWait);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function (el) {
      var _this$props$onRender, _this$props2;
      var triggerEl = _this.props.triggerEl;
      for (var _len2 = arguments.length, restArgs = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        restArgs[_key2 - 1] = arguments[_key2];
      }
      (_this$props$onRender = (_this$props2 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call.apply(_this$props$onRender, [_this$props2, el].concat(restArgs));
      _Event["default"].addEvent(triggerEl, 'mouseover', _this.handleMouseOver);
      _Event["default"].addEvent(triggerEl, 'mouseout', _this.handleMouseOut);
      _Event["default"].addEvent(el, 'mouseover', _this.handleMouseOver);
      _Event["default"].addEvent(el, 'mouseout', _this.handleMouseOut);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function (el) {
      var _this$props$onDestroy, _this$props3;
      var triggerEl = _this.props.triggerEl;
      for (var _len3 = arguments.length, restArgs = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        restArgs[_key3 - 1] = arguments[_key3];
      }
      (_this$props$onDestroy = (_this$props3 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call.apply(_this$props$onDestroy, [_this$props3, el].concat(restArgs));
      _Event["default"].removeEvent(triggerEl, 'mouseover', _this.handleMouseOver);
      _Event["default"].removeEvent(triggerEl, 'mouseout', _this.handleMouseOut);
      _Event["default"].removeEvent(el, 'mouseover', _this.handleMouseOver);
      _Event["default"].removeEvent(el, 'mousemove', _this.handleMouseOut);
    });
    _this.closeTimeout = null;
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    _this.popInstance = null;
    return _this;
  }
  (0, _createClass2["default"])(Popover, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$pop;
      this.popInstance = (_this$pop = this.pop) === null || _this$pop === void 0 ? void 0 : _this$pop.current;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.clearCloseTimeout();
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
        className = _this$props4.className,
        contentClassName = _this$props4.contentClassName,
        closeWait = _this$props4.closeWait,
        onRequestClose = _this$props4.onRequestClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props4, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_TriggerPop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('popover', (0, _defineProperty2["default"])({}, className, className)),
        contentClassName: (0, _classnames["default"])('popover-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName)),
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }));
    }
  }]);
  return Popover;
}(_react.Component);
(0, _defineProperty2["default"])(Popover, "Position", _Position["default"]);
(0, _defineProperty2["default"])(Popover, "Theme", _Theme["default"]);
Popover.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  container: _propTypes["default"].element,
  triangle: _propTypes["default"].element,
  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The popover alignment.The value can be Popover.Position.LEFT or Popover.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, popover will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  isBlurClose: _propTypes["default"].bool,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  closeWait: _propTypes["default"].number,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,
  /**
   * The function of popover render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of popover rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of popover destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of popover destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when the popover is requested to be closed.
   */
  onRequestClose: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func
};
Popover.defaultProps = {
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  theme: _Theme["default"].DEFAULT,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  isBlurClose: true,
  shouldFollowScroll: false,
  closeWait: 1000 / 6,
  resetPositionWait: 250,
  showModal: false
};
var _default = Popover;
exports["default"] = _default;