"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TableContent = _interopRequireDefault(require("../_TableContent"));
var _TablePagination = _interopRequireDefault(require("../_TablePagination"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _excluded = ["className", "style", "selectMode", "data", "footData", "isHeadFixed", "isFootFixed", "pageSizeClassName", "pageSizeTriggerClassName", "pageSizePopupClassName", "isPaginated", "pageSizes", "useFullPagination", "pageSizeValueField", "pageSizeDisplayField", "paginationSelectionVisible", "paginationTotalVisible", "paginationPageVisible", "paginationPageSizeVisible", "paginationParentEl", "paginationPageSizeRightIconCls", "paginationPrevIconCls", "paginationNextIconCls", "paginationFirstIconCls", "paginationLastIconCls", "paginationSelectionRenderer", "paginationTotalRenderer", "onPageChange", "onPageSizeChange", "columns", "pageSize", "disableScrollingRender", "onPaginationChange", "onScrollStart", "onScrollEnd"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Table = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Table, _Component);
  var _super = _createSuper(Table);
  function Table(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Table);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "collapseAllRows", function () {
      _this.setState({
        expandRows: []
      }, function () {
        var _this$props$onExpandC, _this$props;
        return (_this$props$onExpandC = (_this$props = _this.props).onExpandChange) === null || _this$props$onExpandC === void 0 ? void 0 : _this$props$onExpandC.call(_this$props, []);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (value, rowIndex) {
      _this.setState({
        value: (0, _toConsumableArray2["default"])(value)
      }, function () {
        var _this$props$onChange, _this$props2;
        return (_this$props$onChange = (_this$props2 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props2, value, rowIndex);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSortChange", function (sorting) {
      if (!_this.props.isClickSorting) {
        return;
      }
      _this.setState({
        sorting: sorting
      }, function () {
        var _this$props$onSortCha, _this$props3;
        return (_this$props$onSortCha = (_this$props3 = _this.props).onSortChange) === null || _this$props$onSortCha === void 0 ? void 0 : _this$props$onSortCha.call(_this$props3, sorting);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePaginationChange", function (pagination) {
      _this.setState(pagination, function () {
        var _this$props$onPaginat, _this$props4;
        return (_this$props$onPaginat = (_this$props4 = _this.props).onPaginationChange) === null || _this$props$onPaginat === void 0 ? void 0 : _this$props$onPaginat.call(_this$props4, pagination);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExpandChange", function (expandRows, callback) {
      _this.setState({
        expandRows: expandRows
      }, function () {
        var _this$props$onExpandC2, _this$props5;
        (_this$props$onExpandC2 = (_this$props5 = _this.props).onExpandChange) === null || _this$props$onExpandC2 === void 0 ? void 0 : _this$props$onExpandC2.call(_this$props5, expandRows);
        callback === null || callback === void 0 ? void 0 : callback();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePingLeftChange", function (isPingLeft) {
      _this.setState({
        isPingLeft: isPingLeft
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePingRightChange", function (isPingRight) {
      _this.setState({
        isPingRight: isPingRight
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollTopChange", function (scrollTop) {
      if (_this.props.useDynamicRender) {
        _this.setState({
          scrollTop: scrollTop
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDebounceScrollChange", (0, _debounce["default"])(function (e) {
      var scrolling = _this.state.scrolling;
      if (!scrolling) {
        _this.handleScrollStart(e);
      } else {
        _this.handleScrollEnd(e);
      }
    }, 150, {
      leading: true
    }));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollStart", function (e) {
      _this.setState({
        scrolling: true
      }, function () {
        var _this$props$onScrollS, _this$props6, _this$props$onScrollC, _this$props7;
        (_this$props$onScrollS = (_this$props6 = _this.props).onScrollStart) === null || _this$props$onScrollS === void 0 ? void 0 : _this$props$onScrollS.call(_this$props6, e);
        (_this$props$onScrollC = (_this$props7 = _this.props).onScrollChange) === null || _this$props$onScrollC === void 0 ? void 0 : _this$props$onScrollC.call(_this$props7, true);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollEnd", function (e) {
      _this.setState({
        scrolling: false
      }, function () {
        var _this$props$onScrollE, _this$props8, _this$props$onScrollC2, _this$props9;
        (_this$props$onScrollE = (_this$props8 = _this.props).onScrollEnd) === null || _this$props$onScrollE === void 0 ? void 0 : _this$props$onScrollE.call(_this$props8, e);
        (_this$props$onScrollC2 = (_this$props9 = _this.props).onScrollChange) === null || _this$props$onScrollC2 === void 0 ? void 0 : _this$props$onScrollC2.call(_this$props9, false);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeStart", function (e) {
      _this.setState({
        resizing: true
      }, function () {
        var _this$props$onResizeS, _this$props10, _this$props$onResizeC, _this$props11;
        (_this$props$onResizeS = (_this$props10 = _this.props).onResizeStart) === null || _this$props$onResizeS === void 0 ? void 0 : _this$props$onResizeS.call(_this$props10, e);
        (_this$props$onResizeC = (_this$props11 = _this.props).onResizeChange) === null || _this$props$onResizeC === void 0 ? void 0 : _this$props$onResizeC.call(_this$props11, true);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeEnd", function (e) {
      _this.setState({
        resizing: false
      }, function () {
        var _this$props$onResizeE, _this$props12, _this$props$onResizeC2, _this$props13;
        (_this$props$onResizeE = (_this$props12 = _this.props).onResizeEnd) === null || _this$props$onResizeE === void 0 ? void 0 : _this$props$onResizeE.call(_this$props12, e);
        (_this$props$onResizeC2 = (_this$props13 = _this.props).onResizeChange) === null || _this$props$onResizeC2 === void 0 ? void 0 : _this$props$onResizeC2.call(_this$props13, false);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleColumnsWidthChange", function (resizingColumn, width, e) {
      var columnKeyField = _this.props.columnKeyField;
      var _this$state = _this.state,
        columns = _this$state.columns,
        columnsWidth = _this$state.columnsWidth;
      if (!columns || columns.length < 1 || !resizingColumn) {
        return;
      }
      var key = _TableCalculation["default"].getColumnKey(resizingColumn, columnKeyField);
      var nextColumns = (0, _cloneDeep["default"])(columns);

      // find the column in columns
      var column = null;
      _Util["default"].preOrderTraverse({
        children: nextColumns
      }, function (node) {
        if (node && _TableCalculation["default"].getColumnKey(node, columnKeyField) === key) {
          column = node;
          return false;
        }
      });
      if (!column) {
        return;
      }

      // update column width
      column.width = width;
      columnsWidth.set(key, width);
      _this.setState({
        columns: nextColumns,
        columnsWidth: columnsWidth
      }, function () {
        var _this$props$onColumns, _this$props14;
        return (_this$props$onColumns = (_this$props14 = _this.props).onColumnsWidthChange) === null || _this$props$onColumns === void 0 ? void 0 : _this$props$onColumns.call(_this$props14, resizingColumn, width, nextColumns, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleColumnResizeStart", function (resizingColumn, width, e) {
      _this.setState({
        resizingColumn: resizingColumn
      }, function () {
        var _this$props$onColumnR, _this$props15;
        return (_this$props$onColumnR = (_this$props15 = _this.props).onColumnResizeStart) === null || _this$props$onColumnR === void 0 ? void 0 : _this$props$onColumnR.call(_this$props15, resizingColumn, width, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleColumnResizeEnd", function (resizingColumn, width, e) {
      setTimeout(function () {
        _this.setState({
          resizingColumn: null
        }, function () {
          var _this$props$onColumnR2, _this$props16;
          return (_this$props$onColumnR2 = (_this$props16 = _this.props).onColumnResizeEnd) === null || _this$props$onColumnR2 === void 0 ? void 0 : _this$props$onColumnR2.call(_this$props16, resizingColumn, width, e);
        });
      }, 0);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleColumnMeasure", function (column, width) {
      var columnKeyField = _this.props.columnKeyField;
      var _this$state2 = _this.state,
        resizingColumn = _this$state2.resizingColumn,
        columnsWidth = _this$state2.columnsWidth;
      var columnKey = _TableCalculation["default"].getColumnKey(column, columnKeyField);

      // ignore resizing Column
      if (columnKey === _TableCalculation["default"].getColumnKey(resizingColumn, columnKeyField)) {
        return;
      }

      // update column width
      columnsWidth.set(columnKey, width);
      _this.setState({
        columnsWidth: _Util["default"].shallowCloneMap(columnsWidth)
      });
    });
    _this.content = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      columns: [],
      columnsWidth: new Map(),
      sorting: props.sorting,
      page: props.page,
      pageSize: props.pageSize,
      expandRows: props.expandRows,
      value: props.value || [],
      scrolling: false,
      isPingLeft: false,
      isPingRight: false,
      scrollTop: 0,
      resizing: false,
      resizingColumn: null
    };
    return _this;
  }
  (0, _createClass2["default"])(Table, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
      return !nextProps.disableScrollingRender || !nextState.scrolling;
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props17 = this.props,
        className = _this$props17.className,
        style = _this$props17.style,
        selectMode = _this$props17.selectMode,
        data = _this$props17.data,
        footData = _this$props17.footData,
        isHeadFixed = _this$props17.isHeadFixed,
        isFootFixed = _this$props17.isFootFixed,
        pageSizeClassName = _this$props17.pageSizeClassName,
        pageSizeTriggerClassName = _this$props17.pageSizeTriggerClassName,
        pageSizePopupClassName = _this$props17.pageSizePopupClassName,
        isPaginated = _this$props17.isPaginated,
        pageSizes = _this$props17.pageSizes,
        useFullPagination = _this$props17.useFullPagination,
        pageSizeValueField = _this$props17.pageSizeValueField,
        pageSizeDisplayField = _this$props17.pageSizeDisplayField,
        paginationSelectionVisible = _this$props17.paginationSelectionVisible,
        paginationTotalVisible = _this$props17.paginationTotalVisible,
        paginationPageVisible = _this$props17.paginationPageVisible,
        paginationPageSizeVisible = _this$props17.paginationPageSizeVisible,
        paginationParentEl = _this$props17.paginationParentEl,
        paginationPageSizeRightIconCls = _this$props17.paginationPageSizeRightIconCls,
        paginationPrevIconCls = _this$props17.paginationPrevIconCls,
        paginationNextIconCls = _this$props17.paginationNextIconCls,
        paginationFirstIconCls = _this$props17.paginationFirstIconCls,
        paginationLastIconCls = _this$props17.paginationLastIconCls,
        paginationSelectionRenderer = _this$props17.paginationSelectionRenderer,
        paginationTotalRenderer = _this$props17.paginationTotalRenderer,
        onPageChange = _this$props17.onPageChange,
        onPageSizeChange = _this$props17.onPageSizeChange,
        cols = _this$props17.columns,
        propsPageSize = _this$props17.pageSize,
        disableScrollingRender = _this$props17.disableScrollingRender,
        onPaginationChange = _this$props17.onPaginationChange,
        onScrollStart = _this$props17.onScrollStart,
        onScrollEnd = _this$props17.onScrollEnd,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props17, _excluded);
      var _this$state3 = this.state,
        columns = _this$state3.columns,
        columnsWidth = _this$state3.columnsWidth,
        sorting = _this$state3.sorting,
        page = _this$state3.page,
        pageSize = _this$state3.pageSize,
        expandRows = _this$state3.expandRows,
        value = _this$state3.value,
        isPingLeft = _this$state3.isPingLeft,
        isPingRight = _this$state3.isPingRight,
        scrollTop = _this$state3.scrollTop,
        resizing = _this$state3.resizing,
        resizingColumn = _this$state3.resizingColumn;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('table', (0, _defineProperty2["default"])({
          'head-fixed': isHeadFixed,
          'foot-fixed': isFootFixed,
          'ping-left': isPingLeft,
          'ping-right': isPingRight
        }, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_TableContent["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.content,
        columns: columns,
        data: data,
        footData: footData,
        sorting: sorting,
        isHeadFixed: isHeadFixed,
        isFootFixed: isFootFixed,
        isPaginated: isPaginated,
        page: page,
        pageSize: pageSize,
        expandRows: expandRows,
        value: value,
        scrollTop: scrollTop,
        columnsWidth: columnsWidth,
        resizing: resizing,
        resizingColumn: resizingColumn,
        selectMode: selectMode,
        onChange: this.handleChange,
        onSortChange: this.handleSortChange,
        onExpandChange: this.handleExpandChange,
        onPingLeftChange: this.handlePingLeftChange,
        onPingRightChange: this.handlePingRightChange,
        onScrollTopChange: this.handleScrollTopChange,
        onScroll: this.handleDebounceScrollChange,
        onResizeStart: this.handleResizeStart,
        onResizeEnd: this.handleResizeEnd,
        onColumnsWidthChange: this.handleColumnsWidthChange,
        onColumnResizeStart: this.handleColumnResizeStart,
        onColumnResizeEnd: this.handleColumnResizeEnd,
        onColumnMeasure: this.handleColumnMeasure
      })), isPaginated ? /*#__PURE__*/_react["default"].createElement(_TablePagination["default"], {
        pageSizeClassName: pageSizeClassName,
        pageSizeTriggerClassName: pageSizeTriggerClassName,
        pageSizePopupClassName: pageSizePopupClassName,
        selectMode: selectMode,
        data: data,
        page: page,
        pageSize: pageSize,
        pageSizes: pageSizes,
        value: value,
        parentEl: paginationParentEl,
        useFullPagination: useFullPagination,
        pageSizeValueField: pageSizeValueField,
        pageSizeDisplayField: pageSizeDisplayField,
        paginationSelectionVisible: paginationSelectionVisible,
        paginationTotalVisible: paginationTotalVisible,
        paginationPageVisible: paginationPageVisible,
        paginationPageSizeVisible: paginationPageSizeVisible,
        paginationPageSizeRightIconCls: paginationPageSizeRightIconCls,
        paginationPrevIconCls: paginationPrevIconCls,
        paginationNextIconCls: paginationNextIconCls,
        paginationFirstIconCls: paginationFirstIconCls,
        paginationLastIconCls: paginationLastIconCls,
        paginationSelectionRenderer: paginationSelectionRenderer,
        paginationTotalRenderer: paginationTotalRenderer,
        onPageChange: onPageChange,
        onPageSizeChange: onPageSizeChange,
        onPaginationChange: this.handlePaginationChange
      }) : null);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var page = _ComponentUtil["default"].getDerivedState(props, state, 'page');
      var pageSize = _ComponentUtil["default"].getDerivedState(props, state, 'pageSize');
      return {
        prevProps: props,
        columns: _ComponentUtil["default"].getDerivedState(props, state, 'columns') || [],
        sorting: _ComponentUtil["default"].getDerivedState(props, state, 'sorting'),
        page: _TableCalculation["default"].handlePage(page, pageSize, props.data),
        pageSize: pageSize,
        expandRows: _ComponentUtil["default"].getDerivedState(props, state, 'expandRows'),
        value: _ComponentUtil["default"].getDerivedState(props, state, 'value') || []
      };
    }
  }]);
  return Table;
}(_react.Component);
(0, _defineProperty2["default"])(Table, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(Table, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Table, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Table, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Table, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Table, "SortingType", _SortingType["default"]);
(0, _defineProperty2["default"])(Table, "TipPosition", _Position["default"]);
Table.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  data: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  value: _propTypes["default"].array,
  idField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isRowDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  noDataText: _propTypes["default"].any,
  /**
   * expand
   */
  canBeExpanded: _propTypes["default"].bool,
  expandRows: _propTypes["default"].array,
  expandIconCls: _propTypes["default"].string,
  /**
   * multi select
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  selectColumn: _propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' )
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any
  }),
  isSelectAllDisabled: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  selectUncheckedIconCls: _propTypes["default"].string,
  selectCheckedIconCls: _propTypes["default"].string,
  selectIndeterminateIconCls: _propTypes["default"].string,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  autoSorting: _propTypes["default"].bool,
  isClickSorting: _propTypes["default"].bool,
  sortingFunc: _propTypes["default"].func,
  /**
   * pagination
   */
  pageSizeClassName: _propTypes["default"].string,
  pageSizeTriggerClassName: _propTypes["default"].string,
  pageSizePopupClassName: _propTypes["default"].string,
  isPaginated: _propTypes["default"].bool,
  page: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  pageSizes: _propTypes["default"].array,
  pageSizeValueField: _propTypes["default"].string,
  pageSizeDisplayField: _propTypes["default"].string,
  paginationParentEl: _propTypes["default"].object,
  useFullPagination: _propTypes["default"].bool,
  paginationSelectionVisible: _propTypes["default"].bool,
  paginationTotalVisible: _propTypes["default"].bool,
  paginationPageVisible: _propTypes["default"].bool,
  paginationPageSizeVisible: _propTypes["default"].bool,
  paginationPageSizeRightIconCls: _propTypes["default"].string,
  paginationPrevIconCls: _propTypes["default"].string,
  paginationNextIconCls: _propTypes["default"].string,
  paginationFirstIconCls: _propTypes["default"].string,
  paginationLastIconCls: _propTypes["default"].string,
  paginationSelectionRenderer: _propTypes["default"].func,
  paginationTotalRenderer: _propTypes["default"].func,
  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,
  /**
   * fixed
   */
  isLayoutFixed: _propTypes["default"].bool,
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,
  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),
  disableScrollingRender: _propTypes["default"].bool,
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  maxColumnWidth: _propTypes["default"].number,
  /**
   * callback
   */
  onChange: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onSelectAll: _propTypes["default"].func,
  onDeselectAll: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onDataUpdate: _propTypes["default"].func,
  onPaginationChange: _propTypes["default"].func,
  onPageChange: _propTypes["default"].func,
  onPageSizeChange: _propTypes["default"].func,
  onScrollStart: _propTypes["default"].func,
  onScrollEnd: _propTypes["default"].func,
  onScrollChange: _propTypes["default"].func,
  onResizeStart: _propTypes["default"].func,
  onResizeEnd: _propTypes["default"].func,
  onResizeChange: _propTypes["default"].func,
  onColumnsWidthChange: _propTypes["default"].func,
  onColumnResizeStart: _propTypes["default"].func,
  onColumnResizeEnd: _propTypes["default"].func
};
Table.defaultProps = {
  columnKeyField: 'key',
  idField: 'id',
  disabled: false,
  noDataText: 'No Data',
  /**
   * expand
   */
  expandRows: [],
  expandIconCls: 'fas fa-chevron-right',
  /**
   * multi select
   */
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  isSelectRecursive: false,
  selectUncheckedIconCls: 'far fa-square',
  selectCheckedIconCls: 'fas fa-check-square',
  selectIndeterminateIconCls: 'fas fa-minus-square',
  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  autoSorting: true,
  isClickSorting: true,
  /**
   * pagination
   */
  isPaginated: true,
  page: 0,
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  useFullPagination: false,
  pageSizeValueField: 'value',
  pageSizeDisplayField: 'text',
  paginationSelectionVisible: false,
  paginationTotalVisible: true,
  paginationPageVisible: true,
  paginationPageSizeVisible: true,
  paginationPageSizeRightIconCls: 'fas fa-angle-down',
  paginationPrevIconCls: 'fas fa-angle-left',
  paginationNextIconCls: 'fas fa-angle-right',
  paginationFirstIconCls: 'fas fa-angle-double-left',
  paginationLastIconCls: 'fas fa-angle-double-right',
  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,
  /**
   * fixed
   */
  isLayoutFixed: true,
  isHeadFixed: false,
  isFootFixed: false,
  /**
   * scroll
   */
  disableScrollingRender: false,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8,
  /**
   * column resizable
   */
  defaultColumnWidth: 100,
  minColumnWidth: 64,
  maxColumnWidth: Infinity
};
var _default = Table;
exports["default"] = _default;