"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Tip = _interopRequireDefault(require("../Tip"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _reactDom = require("react-dom");
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["children", "tipContent", "parentEl", "onRequestOpen", "onRequestClose"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TipProvider = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TipProvider, _Component);
  var _super = _createSuper(TipProvider);
  function TipProvider(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TipProvider);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "show", function () {
      if (_this.state.visible) {
        return;
      }
      _this.setState({
        visible: true
      }, function () {
        var onRequestOpen = _this.props.onRequestOpen;
        onRequestOpen && onRequestOpen();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hide", function () {
      if (!_this.state.visible) {
        return;
      }
      _this.setState({
        visible: false
      }, function () {
        var onRequestClose = _this.props.onRequestClose;
        onRequestClose && onRequestClose();
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggle", function () {
      _this.setState({
        visible: !_this.state.visible
      }, function () {
        if (!_this.state.visible) {
          var onRequestClose = _this.props.onRequestClose;
          onRequestClose && onRequestClose();
        } else {
          var onRequestOpen = _this.props.onRequestOpen;
          onRequestOpen && onRequestOpen();
        }
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var _this$tip, _this$tip$current, _this$tip$current$res;
      (_this$tip = _this.tip) === null || _this$tip === void 0 ? void 0 : (_this$tip$current = _this$tip.current) === null || _this$tip$current === void 0 ? void 0 : (_this$tip$current$res = _this$tip$current.resetPosition) === null || _this$tip$current$res === void 0 ? void 0 : _this$tip$current$res.call(_this$tip$current);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTriggerEl", function () {
      var _this$trigger;
      _this.triggerEl = (0, _reactDom.findDOMNode)((_this$trigger = _this.trigger) === null || _this$trigger === void 0 ? void 0 : _this$trigger.current);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOver", function (e) {
      var children = _this.props.children;
      if (children && children.props && children.props.onMouseOver && typeof children.props.onMouseOver === 'function') {
        children.props.onMouseOver(e);
      }
      _this.show();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseOut", function (e) {
      var children = _this.props.children;
      if (children && children.props && children.props.onMouseOut && typeof children.props.onMouseOut === 'function') {
        children.props.onMouseOut(e);
      }
      _this.hide();
    });
    _this.trigger = /*#__PURE__*/(0, _react.createRef)();
    _this.triggerEl = null;
    _this.tip = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      visible: props.visible
    };
    return _this;
  }
  (0, _createClass2["default"])(TipProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.handleTriggerEl();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.handleTriggerEl();
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        tipContent = _this$props.tipContent,
        parentEl = _this$props.parentEl,
        onRequestOpen = _this$props.onRequestOpen,
        onRequestClose = _this$props.onRequestClose,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        visible = this.state.visible;
      if (!tipContent) {
        return children;
      }
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/(0, _react.cloneElement)(children, {
        ref: this.trigger,
        onMouseOver: this.handleMouseOver,
        onMouseOut: this.handleMouseOut
      }), /*#__PURE__*/_react["default"].createElement(_Tip["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.tip,
        triggerEl: this.triggerEl,
        parentEl: parentEl,
        visible: visible
      }), tipContent));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        visible: _ComponentUtil["default"].getDerivedState(props, state, 'visible')
      };
    }
  }]);
  return TipProvider;
}(_react.Component);
(0, _defineProperty2["default"])(TipProvider, "Position", _Position["default"]);
(0, _defineProperty2["default"])(TipProvider, "Theme", _Theme["default"]);
TipProvider.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The popover theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the popover.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the popover is visible.
   */
  visible: _propTypes["default"].bool,
  /**
   * If true,the popover will have a triangle on the top of the DOM element.
   */
  hasTriangle: _propTypes["default"].bool,
  triangle: _propTypes["default"].element,
  /**
   * The popover alignment.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true, menu will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  showModal: _propTypes["default"].bool,
  /**
   * The function of tip render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of tip rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of tip destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of tip destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  onRequestOpen: _propTypes["default"].func,
  onRequestClose: _propTypes["default"].func,
  tipContent: _propTypes["default"].any
};
TipProvider.defaultProps = {
  theme: _Theme["default"].DARK,
  parentEl: document.body,
  visible: false,
  hasTriangle: true,
  position: _Position["default"].BOTTOM,
  isAnimated: true,
  shouldFollowScroll: false,
  resetPositionWait: 250,
  showModal: false
};
var _default = TipProvider;
exports["default"] = _default;