"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TreeNode = _interopRequireDefault(require("../_TreeNode"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _TreeCalculation = _interopRequireDefault(require("../_vendors/TreeCalculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tree = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tree, _Component);
  var _super = _createSuper(Tree);
  function Tree(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tree);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTreeNodeSelect", function (node, path, e) {
      if (!node) {
        return;
      }
      var _this$props = _this.props,
        selectMode = _this$props.selectMode,
        isSelectRecursive = _this$props.isSelectRecursive,
        value = _this.state.value,
        state = {};
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var result = value && (0, _isArray["default"])(value) ? value.slice() : [];
        if (isSelectRecursive) {
          _TreeCalculation["default"].addRecursiveValue(node, result, _this.props);
          result = _TreeCalculation["default"].updateValue(result, _this.props);
        } else {
          result.push(node);
        }
        state.value = result;
      } else if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
        state.value = node;
      }
      _this.setState(state, function () {
        var _this$props2 = _this.props,
          onNodeSelect = _this$props2.onNodeSelect,
          onChange = _this$props2.onChange;
        onNodeSelect && onNodeSelect(node, path, e);
        onChange && onChange(state.value, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTreeNodeDeselect", function (node, path, e) {
      var selectMode = _this.props.selectMode;
      if (!node || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var isSelectRecursive = _this.props.isSelectRecursive,
        stateValue = _this.state.value;
      var value = stateValue ? stateValue.slice() : stateValue;
      if (!value || !(0, _isArray["default"])(value)) {
        value = [];
      } else {
        if (isSelectRecursive) {
          _TreeCalculation["default"].removeRecursiveValue(node, value, _this.props);
          value = _TreeCalculation["default"].updateValue(value, _this.props);
        } else {
          var index = _Calculation["default"].getMultiSelectItemIndex(node, value, _this.props);
          if (index > -1) {
            value.splice(index, 1);
          }
        }
      }
      _this.setState({
        value: value
      }, function () {
        var _this$props3 = _this.props,
          onNodeDeselect = _this$props3.onNodeDeselect,
          onChange = _this$props3.onChange;
        onNodeDeselect && onNodeDeselect(node, path, e);
        onChange && onChange(value, e);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeToggleStart", function () {
      var beforeNodeToggle = _this.props.beforeNodeToggle;
      if (beforeNodeToggle && beforeNodeToggle() === false) {
        return;
      }
      _this.setState({
        isNodeToggling: true
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleNodeToggleEnd", function () {
      _this.setState({
        isNodeToggling: false
      });
    });
    _this.state = {
      value: _Calculation["default"].getInitValue(props),
      isNodeToggling: false
    };
    return _this;
  }
  (0, _createClass2["default"])(Tree, [{
    key: "render",
    value: function render() {
      var _ref;
      var _this$props4 = this.props,
        children = _this$props4.children,
        className = _this$props4.className,
        style = _this$props4.style,
        theme = _this$props4.theme,
        data = _this$props4.data,
        allowCollapse = _this$props4.allowCollapse,
        collapsed = _this$props4.collapsed,
        indentWidth = _this$props4.indentWidth,
        collapsedIconCls = _this$props4.collapsedIconCls,
        expandedIconCls = _this$props4.expandedIconCls,
        radioUncheckedIconCls = _this$props4.radioUncheckedIconCls,
        radioCheckedIconCls = _this$props4.radioCheckedIconCls,
        checkboxUncheckedIconCls = _this$props4.checkboxUncheckedIconCls,
        checkboxCheckedIconCls = _this$props4.checkboxCheckedIconCls,
        checkboxIndeterminateIconCls = _this$props4.checkboxIndeterminateIconCls,
        valueField = _this$props4.valueField,
        displayField = _this$props4.displayField,
        descriptionField = _this$props4.descriptionField,
        disabled = _this$props4.disabled,
        nodeDisabled = _this$props4.nodeDisabled,
        isLoading = _this$props4.isLoading,
        readOnly = _this$props4.readOnly,
        selectMode = _this$props4.selectMode,
        isSelectRecursive = _this$props4.isSelectRecursive,
        renderer = _this$props4.renderer,
        onNodeClick = _this$props4.onNodeClick,
        isNodeCollapsed = _this$props4.isNodeCollapsed,
        _this$state = this.state,
        value = _this$state.value,
        isNodeToggling = _this$state.isNodeToggling,
        treeData = (0, _isArray["default"])(data) ? (_ref = {}, (0, _defineProperty2["default"])(_ref, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref, "children", data), _ref) : data;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('tree', (0, _defineProperty2["default"])({}, className, className)),
        disabled: disabled,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_TreeNode["default"], {
        data: treeData,
        treeData: treeData,
        value: value,
        theme: theme,
        valueField: valueField,
        displayField: displayField,
        descriptionField: descriptionField,
        disabled: disabled,
        nodeDisabled: nodeDisabled,
        isLoading: isLoading,
        readOnly: readOnly,
        selectMode: selectMode,
        renderer: renderer,
        allowCollapse: allowCollapse,
        collapsed: collapsed,
        indentWidth: indentWidth,
        collapsedIconCls: collapsedIconCls,
        expandedIconCls: expandedIconCls,
        radioUncheckedIconCls: radioUncheckedIconCls,
        radioCheckedIconCls: radioCheckedIconCls,
        checkboxUncheckedIconCls: checkboxUncheckedIconCls,
        checkboxCheckedIconCls: checkboxCheckedIconCls,
        checkboxIndeterminateIconCls: checkboxIndeterminateIconCls,
        isNodeToggling: isNodeToggling,
        isSelectRecursive: isSelectRecursive,
        onClick: function onClick() {
          return onNodeClick && onNodeClick.apply(void 0, arguments);
        },
        onNodeToggleStart: this.handleNodeToggleStart,
        onNodeToggleEnd: this.handleNodeToggleEnd,
        onSelect: this.handleTreeNodeSelect,
        onDeselect: this.handleTreeNodeDeselect,
        isNodeCollapsed: isNodeCollapsed
      }), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        value: _Calculation["default"].getInitValue({
          value: _ComponentUtil["default"].getDerivedState(props, state, 'value'),
          selectMode: props.selectMode
        })
      };
    }
  }]);
  return Tree;
}(_react.Component);
(0, _defineProperty2["default"])(Tree, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tree, "Theme", _Theme["default"]);
Tree.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The theme of the tree node.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The theme of the tree node select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The mode of tree node.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * Children passed into the tree node.
   */
  data: _propTypes["default"].oneOfType([_propTypes["default"].shape({
    /**
     * The CSS class name of the tree node.
     */
    className: _propTypes["default"].string,
    /**
     * Override the styles of the tree node.
     */
    style: _propTypes["default"].object,
    /**
     * The theme of the tree button.
     */
    theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
    /**
     * The text value of the tree button.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The tree node's display text. Type can be string, number or bool.
     */
    text: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * The desc value of the tree node. Type can be string or number.
     */
    desc: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true,the tree node will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the button will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * Use this property to display an icon. It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * Use this property to display an icon. It will display on the right.
     */
    rightIconCls: _propTypes["default"].string,
    /**
     * The message of tip.
     */
    title: _propTypes["default"].string,
    children: _propTypes["default"].array,
    /**
     * You can create a complicated renderer callback instead of value and desc prop.
     */
    itemRenderer: _propTypes["default"].func,
    /**
     * Callback function fired when a tree node touch-tapped.
     */
    onClick: _propTypes["default"].func
  }), _propTypes["default"].array]),
  /**
   * The value field name in data. (default: "value")
   */
  valueField: _propTypes["default"].string,
  /**
   * The display field name in data. (default: "text")
   */
  displayField: _propTypes["default"].string,
  /**
   * The description field name in data. (default: "desc")
   */
  descriptionField: _propTypes["default"].string,
  /**
   * If true, the tree will be disabled.
   */
  disabled: _propTypes["default"].bool,
  /**
   * Tree node disabled callback.
   */
  nodeDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  /**
   * If true, the tree will be at loading status.
   */
  isLoading: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  allowCollapse: _propTypes["default"].bool,
  collapsed: _propTypes["default"].bool,
  indentWidth: _propTypes["default"].number,
  collapsedIconCls: _propTypes["default"].string,
  expandedIconCls: _propTypes["default"].string,
  radioUncheckedIconCls: _propTypes["default"].string,
  radioCheckedIconCls: _propTypes["default"].string,
  checkboxUncheckedIconCls: _propTypes["default"].string,
  checkboxCheckedIconCls: _propTypes["default"].string,
  checkboxIndeterminateIconCls: _propTypes["default"].string,
  /**
   * You can create a complicated renderer callback instead of value and desc prop.
   */
  renderer: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node touch tap.
   */
  onNodeClick: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node selected.
   */
  onNodeSelect: _propTypes["default"].func,
  /**
   * Callback function fired when the tree node deselected.
   */
  onNodeDeselect: _propTypes["default"].func,
  /**
   * Callback function fired when the tree changed.
   */
  onChange: _propTypes["default"].func,
  isNodeCollapsed: _propTypes["default"].func,
  beforeNodeToggle: _propTypes["default"].func
};
Tree.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  selectTheme: _Theme["default"].DEFAULT,
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  valueField: 'value',
  displayField: 'text',
  descriptionField: 'desc',
  disabled: false,
  isLoading: false,
  readOnly: false,
  isSelectRecursive: false,
  allowCollapse: true,
  collapsed: false,
  indentWidth: 20
};
var _default = Tree;
exports["default"] = _default;