"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _CircularLoading = _interopRequireDefault(require("../CircularLoading"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _TouchRipple = _interopRequireDefault(require("../TouchRipple"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _excluded = ["children", "className", "style", "theme", "isRounded", "isCircular", "disableTouchRipple", "iconCls", "rightIconCls", "type", "value", "disabled", "readOnly", "isLoading", "rippleDisplayCenter", "tip", "tipPosition", "renderer", "parentEl", "triggerEl", "container"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var BaseButton = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(BaseButton, _Component);
  var _super = _createSuper(BaseButton);
  function BaseButton(_props) {
    var _this;
    (0, _classCallCheck2["default"])(this, BaseButton);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, _props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "startRipple", function (e, props) {
      !_this.props.disableTouchRipple && _this.touchRipple && _this.touchRipple.current && _this.touchRipple.current.addRipple(e, props);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "endRipple", function () {
      !_this.props.disableTouchRipple && _this.touchRipple && _this.touchRipple.current && _this.touchRipple.current.removeRipple();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "triggerRipple", function (e, props) {
      _this.startRipple(e, props);
      setTimeout(function () {
        _this.endRipple();
      }, 250);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        isLoading = _this$props.isLoading,
        onClick = _this$props.onClick;
      !disabled && !isLoading && onClick && onClick(e);
    });
    _this.touchRipple = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }

  /**
   * public
   */
  (0, _createClass2["default"])(BaseButton, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        children = _this$props2.children,
        className = _this$props2.className,
        style = _this$props2.style,
        theme = _this$props2.theme,
        isRounded = _this$props2.isRounded,
        isCircular = _this$props2.isCircular,
        disableTouchRipple = _this$props2.disableTouchRipple,
        iconCls = _this$props2.iconCls,
        rightIconCls = _this$props2.rightIconCls,
        type = _this$props2.type,
        value = _this$props2.value,
        disabled = _this$props2.disabled,
        readOnly = _this$props2.readOnly,
        isLoading = _this$props2.isLoading,
        rippleDisplayCenter = _this$props2.rippleDisplayCenter,
        tip = _this$props2.tip,
        tipPosition = _this$props2.tipPosition,
        renderer = _this$props2.renderer,
        parentEl = _this$props2.parentEl,
        triggerEl = _this$props2.triggerEl,
        container = _this$props2.container,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded),
        loadingIconPosition = rightIconCls && !iconCls ? 'right' : 'left';
      return /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        tipContent: tip,
        triggerEl: triggerEl,
        parentEl: parentEl,
        position: tipPosition
      }, /*#__PURE__*/(0, _react.cloneElement)(container, _objectSpread(_objectSpread({}, restProps), {}, {
        className: (0, _classnames["default"])('base-button', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, 'button-circular', isCircular), (0, _defineProperty2["default"])(_classNames, 'button-rounded', isRounded), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        type: type,
        disabled: disabled || isLoading,
        readOnly: readOnly,
        onClick: this.handleClick,
        children: /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, isLoading && loadingIconPosition === 'left' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-icon button-icon-left button-loading-icon",
          size: "small"
        }) : iconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-left ".concat(iconCls),
          "aria-hidden": "true"
        }) : null, renderer && typeof renderer === 'function' ? renderer(this.props) : value ? /*#__PURE__*/_react["default"].createElement("span", {
          className: "base-button-value"
        }, value) : null, isLoading && loadingIconPosition === 'right' ? /*#__PURE__*/_react["default"].createElement(_CircularLoading["default"], {
          className: "button-icon button-icon-right button-loading-icon",
          size: "small"
        }) : rightIconCls ? /*#__PURE__*/_react["default"].createElement("i", {
          className: "button-icon button-icon-right ".concat(rightIconCls),
          "aria-hidden": "true"
        }) : null, children, disableTouchRipple ? null : /*#__PURE__*/_react["default"].createElement(_TouchRipple["default"], {
          ref: this.touchRipple,
          className: disabled || isLoading ? 'hidden' : '',
          displayCenter: rippleDisplayCenter
        }))
      })));
    }
  }]);
  return BaseButton;
}(_react.Component);
(0, _defineProperty2["default"])(BaseButton, "Theme", _Theme["default"]);
(0, _defineProperty2["default"])(BaseButton, "TipPosition", _Position["default"]);
BaseButton.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  isRounded: _propTypes["default"].bool,
  isCircular: _propTypes["default"].bool,
  title: _propTypes["default"].string,
  value: _propTypes["default"].any,
  type: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  isLoading: _propTypes["default"].bool,
  disableTouchRipple: _propTypes["default"].bool,
  iconCls: _propTypes["default"].string,
  rightIconCls: _propTypes["default"].string,
  tip: _propTypes["default"].string,
  tipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  rippleDisplayCenter: _propTypes["default"].bool,
  parentEl: _propTypes["default"].object,
  triggerEl: _propTypes["default"].object,
  container: _propTypes["default"].object,
  renderer: _propTypes["default"].func,
  onClick: _propTypes["default"].func
};
BaseButton.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  isRounded: false,
  isCircular: false,
  disabled: false,
  readOnly: false,
  type: 'button',
  isLoading: false,
  disableTouchRipple: false,
  rippleDisplayCenter: false,
  tipPosition: _Position["default"].BOTTOM,
  container: /*#__PURE__*/_react["default"].createElement("button", null)
};
var _default = BaseButton;
exports["default"] = _default;