"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ColGroup = _interopRequireDefault(require("../_ColGroup"));
var _Thead = _interopRequireDefault(require("../_Thead"));
var _Tbody = _interopRequireDefault(require("../_Tbody"));
var _Tfoot = _interopRequireDefault(require("../_Tfoot"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _excluded = ["className", "style", "data", "footData", "dynamicRenderData", "value", "idField", "scrollEl", "hasVerticalScroll", "headColumns", "bodyColumns", "columnKeyField", "columnsWidth", "selectMode", "useColumnsWidth", "expandRows", "resizingColumn", "useDynamicRender", "scrollHeight", "rowHeight", "scrollBuffer", "isRowDisabled", "defaultColumnWidth", "minColumnWidth", "maxColumnWidth", "isHeadHidden", "isBodyHidden", "isFootHidden", "isLayoutFixed", "hasFixedRightColumn", "ignoreColumnSpan", "hasHeadRenderer", "hasBodyRenderer", "hasFootRenderer", "sorting", "defaultSortingType", "sortingAscIconCls", "sortingDescIconCls", "isClickSorting", "onSortChange", "onExpandChange", "onRequestColumnsSpan", "onHeadClick", "onFootClick", "onColumnsWidthChange", "onColumnResizeStart", "onColumnResizeEnd", "onColumnMeasure", "columns", "fragment", "selectAllMode", "isHeadFixed", "isFootFixed", "hasFixedLeftColumn"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var BaseTable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(BaseTable, _Component);
  var _super = _createSuper(BaseTable);
  function BaseTable(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, BaseTable);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumns", function () {
      var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.columns;
      return columns ? columns.map(function (column, index) {
        return {
          column: column,
          path: [index]
        };
      }) : columns;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumnsSpan", function () {
      var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getColumns();
      var _this$props = _this.props,
        fragment = _this$props.fragment,
        bodyColumns = _this$props.bodyColumns,
        onRequestColumnsSpan = _this$props.onRequestColumnsSpan;
      return onRequestColumnsSpan ? onRequestColumnsSpan(fragment, bodyColumns || columns) : _TableCalculation["default"].getColumnsSpan(fragment, bodyColumns || columns);
    });
    return _this;
  }
  (0, _createClass2["default"])(BaseTable, [{
    key: "render",
    value: /* eslint-disable complexity */
    function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        data = _this$props2.data,
        footData = _this$props2.footData,
        dynamicRenderData = _this$props2.dynamicRenderData,
        value = _this$props2.value,
        idField = _this$props2.idField,
        scrollEl = _this$props2.scrollEl,
        hasVerticalScroll = _this$props2.hasVerticalScroll,
        headColumns = _this$props2.headColumns,
        bodyColumns = _this$props2.bodyColumns,
        columnKeyField = _this$props2.columnKeyField,
        columnsWidth = _this$props2.columnsWidth,
        selectMode = _this$props2.selectMode,
        useColumnsWidth = _this$props2.useColumnsWidth,
        expandRows = _this$props2.expandRows,
        resizingColumn = _this$props2.resizingColumn,
        useDynamicRender = _this$props2.useDynamicRender,
        scrollHeight = _this$props2.scrollHeight,
        rowHeight = _this$props2.rowHeight,
        scrollBuffer = _this$props2.scrollBuffer,
        isRowDisabled = _this$props2.isRowDisabled,
        defaultColumnWidth = _this$props2.defaultColumnWidth,
        minColumnWidth = _this$props2.minColumnWidth,
        maxColumnWidth = _this$props2.maxColumnWidth,
        isHeadHidden = _this$props2.isHeadHidden,
        isBodyHidden = _this$props2.isBodyHidden,
        isFootHidden = _this$props2.isFootHidden,
        isLayoutFixed = _this$props2.isLayoutFixed,
        hasFixedRightColumn = _this$props2.hasFixedRightColumn,
        ignoreColumnSpan = _this$props2.ignoreColumnSpan,
        hasHeadRenderer = _this$props2.hasHeadRenderer,
        hasBodyRenderer = _this$props2.hasBodyRenderer,
        hasFootRenderer = _this$props2.hasFootRenderer,
        sorting = _this$props2.sorting,
        defaultSortingType = _this$props2.defaultSortingType,
        sortingAscIconCls = _this$props2.sortingAscIconCls,
        sortingDescIconCls = _this$props2.sortingDescIconCls,
        isClickSorting = _this$props2.isClickSorting,
        onSortChange = _this$props2.onSortChange,
        onExpandChange = _this$props2.onExpandChange,
        onRequestColumnsSpan = _this$props2.onRequestColumnsSpan,
        onHeadClick = _this$props2.onHeadClick,
        onFootClick = _this$props2.onFootClick,
        onColumnsWidthChange = _this$props2.onColumnsWidthChange,
        onColumnResizeStart = _this$props2.onColumnResizeStart,
        onColumnResizeEnd = _this$props2.onColumnResizeEnd,
        onColumnMeasure = _this$props2.onColumnMeasure,
        cols = _this$props2.columns,
        fragment = _this$props2.fragment,
        selectAllMode = _this$props2.selectAllMode,
        isHeadFixed = _this$props2.isHeadFixed,
        isFootFixed = _this$props2.isFootFixed,
        hasFixedLeftColumn = _this$props2.hasFixedLeftColumn,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props2, _excluded);
      var columns = this.getColumns();
      return /*#__PURE__*/_react["default"].createElement("table", (0, _extends2["default"])({}, restProps, {
        className: (0, _classnames["default"])('base-table', (0, _defineProperty2["default"])({}, className, className)),
        style: _objectSpread(_objectSpread({}, style), {}, {
          tableLayout: isLayoutFixed ? 'fixed' : null
        })
      }), /*#__PURE__*/_react["default"].createElement(_ColGroup["default"], {
        columns: this.getColumnsSpan(columns),
        columnKeyField: columnKeyField,
        columnsWidth: columnsWidth,
        data: dynamicRenderData || data,
        defaultColumnWidth: defaultColumnWidth,
        minColumnWidth: minColumnWidth,
        ignoreColumnSpan: ignoreColumnSpan,
        useColumnsWidth: useColumnsWidth
      }), !isHeadHidden && hasHeadRenderer ? /*#__PURE__*/_react["default"].createElement(_Thead["default"], (0, _extends2["default"])({}, restProps, {
        columns: headColumns || columns,
        columnKeyField: columnKeyField,
        columnsWidth: columnsWidth,
        hasFixedRightColumn: hasFixedRightColumn,
        tableData: data,
        dynamicRenderData: dynamicRenderData,
        sorting: sorting,
        defaultSortingType: defaultSortingType,
        sortingAscIconCls: sortingAscIconCls,
        sortingDescIconCls: sortingDescIconCls,
        isClickSorting: isClickSorting,
        ignoreColumnSpan: ignoreColumnSpan,
        scrollEl: scrollEl,
        hasVerticalScroll: hasVerticalScroll,
        defaultColumnWidth: defaultColumnWidth,
        minColumnWidth: minColumnWidth,
        maxColumnWidth: maxColumnWidth,
        resizingColumn: resizingColumn,
        onHeadClick: onHeadClick,
        onSortChange: onSortChange,
        onRequestColumnsSpan: onRequestColumnsSpan,
        onColumnsWidthChange: onColumnsWidthChange,
        onColumnResizeStart: onColumnResizeStart,
        onColumnResizeEnd: onColumnResizeEnd
      })) : null, !isBodyHidden && hasBodyRenderer ? /*#__PURE__*/_react["default"].createElement(_Tbody["default"], (0, _extends2["default"])({}, restProps, {
        columns: bodyColumns || columns,
        columnKeyField: columnKeyField,
        columnsWidth: columnsWidth,
        tableData: data,
        dynamicRenderData: dynamicRenderData,
        value: value,
        selectMode: selectMode,
        expandRows: expandRows,
        idField: idField,
        sorting: sorting,
        ignoreColumnSpan: ignoreColumnSpan,
        scrollEl: scrollEl,
        defaultColumnWidth: defaultColumnWidth,
        useDynamicRender: useDynamicRender,
        scrollHeight: scrollHeight,
        rowHeight: rowHeight,
        scrollBuffer: scrollBuffer,
        resizingColumn: resizingColumn,
        isRowDisabled: isRowDisabled,
        onExpandChange: onExpandChange,
        onRequestColumnsSpan: onRequestColumnsSpan,
        onColumnMeasure: onColumnMeasure
      })) : null, !isFootHidden && hasFootRenderer ? /*#__PURE__*/_react["default"].createElement(_Tfoot["default"], (0, _extends2["default"])({}, restProps, {
        columns: bodyColumns || columns,
        columnKeyField: columnKeyField,
        columnsWidth: columnsWidth,
        hasFixedRightColumn: hasFixedRightColumn,
        data: data,
        footData: footData,
        dynamicRenderData: dynamicRenderData,
        ignoreColumnSpan: ignoreColumnSpan,
        scrollEl: scrollEl,
        hasVerticalScroll: hasVerticalScroll,
        defaultColumnWidth: defaultColumnWidth,
        resizingColumn: resizingColumn,
        onRequestColumnsSpan: onRequestColumnsSpan,
        onFootClick: onFootClick
      })) : null);
    }
  }]);
  return BaseTable;
}(_react.Component);
(0, _defineProperty2["default"])(BaseTable, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(BaseTable, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(BaseTable, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(BaseTable, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(BaseTable, "SortingType", _SortingType["default"]);
BaseTable.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The select all mode of table, all or current page.
   */
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  fragment: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TableFragment["default"])),
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })),
  headColumns: _propTypes["default"].array,
  bodyColumns: _propTypes["default"].array,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  useColumnsWidth: _propTypes["default"].bool,
  data: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  dynamicRenderData: _propTypes["default"].array,
  value: _propTypes["default"].array,
  idField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isRowDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  expandRows: _propTypes["default"].array,
  ignoreColumnSpan: _propTypes["default"].bool,
  /**
   * scroll
   */
  hasVerticalScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  /**
   * fixed
   */
  isLayoutFixed: _propTypes["default"].bool,
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,
  hasFixedLeftColumn: _propTypes["default"].bool,
  hasFixedRightColumn: _propTypes["default"].bool,
  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isBodyHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,
  /**
   * has renderer
   */
  hasHeadRenderer: _propTypes["default"].bool,
  hasBodyRenderer: _propTypes["default"].bool,
  hasFootRenderer: _propTypes["default"].bool,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  isClickSorting: _propTypes["default"].bool,
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  maxColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  /**
   * callback
   */
  onSortChange: _propTypes["default"].func,
  onHeadClick: _propTypes["default"].func,
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onFootClick: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onRequestColumnsSpan: _propTypes["default"].func,
  onColumnsWidthChange: _propTypes["default"].func,
  onColumnResizeStart: _propTypes["default"].func,
  onColumnResizeEnd: _propTypes["default"].func,
  onColumnMeasure: _propTypes["default"].func
};
BaseTable.defaultProps = {
  columnKeyField: 'key',
  useColumnsWidth: false,
  disabled: false,
  expandRows: [],
  idField: 'id',
  ignoreColumnSpan: false,
  /**
   * scroll
   */
  hasVerticalScroll: false,
  /**
   * fixed
   */
  isLayoutFixed: true,
  isHeadFixed: false,
  isFootFixed: false,
  hasFixedLeftColumn: false,
  hasFixedRightColumn: false,
  /**
   * hidden
   */
  isHeadHidden: false,
  isBodyHidden: false,
  isFootHidden: false,
  /**
   * has renderer
   */
  hasHeadRenderer: true,
  hasBodyRenderer: true,
  hasFootRenderer: true,
  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  isClickSorting: true,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8,
  /**
   * column resizable
   */
  defaultColumnWidth: 100,
  minColumnWidth: 64,
  maxColumnWidth: Infinity
};
var _default = BaseTable;
exports["default"] = _default;