"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ColGroup = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ColGroup, _Component);
  var _super = _createSuper(ColGroup);
  function ColGroup(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ColGroup);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumnWidth", function (column) {
      var _this$props = _this.props,
        columnKeyField = _this$props.columnKeyField,
        columnsWidth = _this$props.columnsWidth,
        useColumnsWidth = _this$props.useColumnsWidth,
        data = _this$props.data;
      if (useColumnsWidth && columnKeyField && columnsWidth) {
        var width = columnsWidth.get(_TableCalculation["default"].getColumnKey(column, columnKeyField));
        if (width) {
          return width;
        }
      }
      if (typeof column.width === 'function') {
        var _width = column.width(data);
        if (_width) {
          return _width;
        }
      }
      return column.width || null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColStyle", function (column) {
      var result = {
        width: _this.getColumnWidth(column)
      };

      // min width
      result.minWidth = column.minWidth ? column.minWidth : result.width;
      return !result.width && !result.minWidth ? null : result;
    });
    return _this;
  }
  (0, _createClass2["default"])(ColGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        columns = _this$props2.columns,
        ignoreColumnSpan = _this$props2.ignoreColumnSpan;
      return columns ? /*#__PURE__*/_react["default"].createElement("colgroup", null, columns.map(function (_ref, index) {
        var column = _ref.column,
          span = _ref.span;
        return column ? /*#__PURE__*/_react["default"].createElement("col", {
          key: index,
          style: _this2.getColStyle(column),
          span: ignoreColumnSpan ? null : span && span > 1 ? span : null
        }) : null;
      })) : null;
    }
  }]);
  return ColGroup;
}(_react.Component);
(0, _defineProperty2["default"])(ColGroup, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(ColGroup, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ColGroup, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(ColGroup, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(ColGroup, "SortingType", _SortingType["default"]);
ColGroup.propTypes = {
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  useColumnsWidth: _propTypes["default"].bool,
  data: _propTypes["default"].array,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  ignoreColumnSpan: _propTypes["default"].bool
};
ColGroup.defaultProps = {
  columnKeyField: 'key',
  /**
   * column resizable
   */
  defaultColumnWidth: 100,
  minColumnWidth: 64,
  useColumnsWidth: false,
  ignoreColumnSpan: false
};
var _default = ColGroup;
exports["default"] = _default;