"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Pop = _interopRequireDefault(require("../_Pop"));
var _Paper = _interopRequireDefault(require("../Paper"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _CursorPopCalculation = _interopRequireDefault(require("../_vendors/CursorPopCalculation"));
var _Dom = _interopRequireDefault(require("../_vendors/Dom"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _excluded = ["children", "className", "contentClassName", "theme", "container", "position", "isAnimated", "enterable", "shouldFollowScroll", "scrollEl", "onCursorMove", "onTargetChange"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var CursorPop = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CursorPop, _Component);
  var _super = _createSuper(CursorPop);
  function CursorPop(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, CursorPop);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));

    // Closest scrollable element of cursor
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getEl", function () {
      var _this$pop, _this$pop$current, _this$pop$current$get;
      return (_this$pop = _this.pop) === null || _this$pop === void 0 ? void 0 : (_this$pop$current = _this$pop.current) === null || _this$pop$current === void 0 ? void 0 : (_this$pop$current$get = _this$pop$current.getEl) === null || _this$pop$current$get === void 0 ? void 0 : _this$pop$current$get.call(_this$pop$current);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "resetPosition", function () {
      var transitionEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getEl();
      var _this$props = _this.props,
        parentEl = _this$props.parentEl,
        triggerEl = _this$props.triggerEl,
        position = _this$props.position;
      _CursorPopCalculation["default"].setStyle(parentEl, triggerEl, transitionEl, _this.getScrollEl(), position, _this.cursorOffset);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMouseMove", function (e) {
      var _this$props$onCursorM, _this$props2;
      var triggerEl = _this.props.triggerEl;
      _this.cursorOffset.left = (e === null || e === void 0 ? void 0 : e.clientX) || 0;
      _this.cursorOffset.top = (e === null || e === void 0 ? void 0 : e.clientY) || 0;
      _this.resetPosition();
      (_this$props$onCursorM = (_this$props2 = _this.props).onCursorMove) === null || _this$props$onCursorM === void 0 ? void 0 : _this$props$onCursorM.call(_this$props2, e, triggerEl, _this.getEl());
      if (e.target !== _this.lastTarget) {
        var _this$props$onTargetC, _this$props3;
        (_this$props$onTargetC = (_this$props3 = _this.props).onTargetChange) === null || _this$props$onTargetC === void 0 ? void 0 : _this$props$onTargetC.call(_this$props3, e.target, triggerEl, _this.getEl(), e);
        _this.lastTarget = e.target;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRender", function (el, triggerEl) {
      var _this$props$onRender, _this$props4;
      _Event["default"].addEvent(triggerEl, 'mousemove', _this.handleMouseMove);
      (_this$props$onRender = (_this$props4 = _this.props).onRender) === null || _this$props$onRender === void 0 ? void 0 : _this$props$onRender.call(_this$props4, el, triggerEl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDestroy", function (el, triggerEl) {
      var _this$props$onDestroy, _this$props5;
      _Event["default"].removeEvent(triggerEl, 'mousemove', _this.handleMouseMove);
      (_this$props$onDestroy = (_this$props5 = _this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call(_this$props5, el, triggerEl);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollEl", function () {
      var triggerEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.triggerEl;
      if (_this.props.scrollEl) {
        return _this.props.scrollEl;
      }
      if (_this.scrollEl) {
        return _this.scrollEl;
      }
      var scrollEl = _Dom["default"].getClosestScrollable(triggerEl);
      return _this.scrollEl = scrollEl || document.body;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function () {
      _this.resetPosition();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addWatchScroll", function () {
      var scrollEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getScrollEl();
      var triggerEl = _this.props.triggerEl;
      if (!triggerEl) {
        return;
      }
      scrollEl && _Event["default"].addEvent(scrollEl, 'scroll', _this.handleScroll);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "removeWatchScroll", function () {
      var scrollEl = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.getScrollEl();
      scrollEl && _Event["default"].removeEvent(scrollEl, 'scroll', _this.handleScroll);
    });
    _this.scrollEl = null;

    // Last cursor move target
    _this.lastTarget = null;
    _this.cursorOffset = {
      left: 0,
      top: 0
    };
    _this.pop = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }
  (0, _createClass2["default"])(CursorPop, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this.props.shouldFollowScroll && !prevProps.visible && this.props.visible) {
        this.addWatchScroll();
      } else if (prevProps.visible && !this.props.visible) {
        this.removeWatchScroll();
      }
    }

    /**
     * public
     */
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props6 = this.props,
        children = _this$props6.children,
        className = _this$props6.className,
        contentClassName = _this$props6.contentClassName,
        theme = _this$props6.theme,
        container = _this$props6.container,
        position = _this$props6.position,
        isAnimated = _this$props6.isAnimated,
        enterable = _this$props6.enterable,
        shouldFollowScroll = _this$props6.shouldFollowScroll,
        scrollEl = _this$props6.scrollEl,
        onCursorMove = _this$props6.onCursorMove,
        onTargetChange = _this$props6.onTargetChange,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props6, _excluded);
      return /*#__PURE__*/_react["default"].createElement(_Pop["default"], (0, _extends2["default"])({}, restProps, {
        ref: this.pop,
        className: (0, _classnames["default"])('cursor-pop', (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "theme-".concat(theme), theme), (0, _defineProperty2["default"])(_classNames, "cursor-pop-".concat(position), position), (0, _defineProperty2["default"])(_classNames, 'cursor-pop-animated', isAnimated), (0, _defineProperty2["default"])(_classNames, 'cursor-pop-enterable', enterable), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        position: position,
        container: container,
        isAnimated: isAnimated,
        resetPosition: this.resetPosition,
        onRender: this.handleRender,
        onDestroy: this.handleDestroy
      }), function (popEl) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('cursor-pop-content', (0, _defineProperty2["default"])({}, contentClassName, contentClassName))
        }, typeof children === 'function' ? children(popEl) : children);
      });
    }
  }]);
  return CursorPop;
}(_react.Component);
(0, _defineProperty2["default"])(CursorPop, "Position", _Position["default"]);
(0, _defineProperty2["default"])(CursorPop, "Theme", _Theme["default"]);
CursorPop.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * The CSS class name of the content element.
   */
  contentClassName: _propTypes["default"].string,
  modalClassName: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The cursor pop theme.Can be primary,highlight,success,warning,error.
   */
  theme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  parentEl: _propTypes["default"].object,
  /**
   * This is the DOM element that will be used to set the position of the cursor pop.
   */
  triggerEl: _propTypes["default"].object,
  /**
   * If true,the cursor pop is visible.
   */
  visible: _propTypes["default"].bool,
  container: _propTypes["default"].element,
  /**
   * The cursor pop alignment.The value can be Popup.Position.LEFT or Popup.Position.RIGHT.
   */
  position: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Position["default"])),
  /**
   * If true,popup will have animation effects.
   */
  isAnimated: _propTypes["default"].bool,
  enterable: _propTypes["default"].bool,
  /**
   * The depth of Paper component.
   */
  depth: _propTypes["default"].number,
  shouldFollowScroll: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  resetPositionWait: _propTypes["default"].number,
  /**
   * The function of popup render.
   */
  onRender: _propTypes["default"].func,
  /**
   * The function of popup rendered.
   */
  onRendered: _propTypes["default"].func,
  /**
   * The function of popup destroy.
   */
  onDestroy: _propTypes["default"].func,
  /**
   * The function of popup destroyed.
   */
  onDestroyed: _propTypes["default"].func,
  /**
   * Callback function fired when wrapper wheeled.
   */
  onWheel: _propTypes["default"].func,
  onCursorMove: _propTypes["default"].func,
  onTargetChange: _propTypes["default"].func
};
CursorPop.defaultProps = {
  theme: _Theme["default"].DEFAULT,
  parentEl: document.body,
  depth: 2,
  visible: false,
  container: /*#__PURE__*/_react["default"].createElement(_Paper["default"], null),
  position: _Position["default"].BOTTOM_LEFT,
  isAnimated: true,
  enterable: false,
  shouldFollowScroll: false,
  resetPositionWait: 250
};
var _default = CursorPop;
exports["default"] = _default;