"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _AnchorButton = _interopRequireDefault(require("../AnchorButton"));
var _MsgType = _interopRequireDefault(require("../_statics/MsgType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Notification = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Notification, _Component);
  var _super = _createSuper(Notification);
  function Notification(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Notification);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIconCls", function () {
      switch (_this.props.type) {
        case _MsgType["default"].SUCCESS:
          return 'fas fa-check-circle';
        case _MsgType["default"].WARNING:
          return 'fas fa-exclamation-triangle';
        case _MsgType["default"].ERROR:
          return 'fas fa-times-circle';
        default:
          return 'fas fa-info-circle';
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      _this.setState({
        hidden: true,
        leave: true
      }, function () {
        return setTimeout(function () {
          var _this$props$onRequest, _this$props;
          return (_this$props$onRequest = (_this$props = _this.props).onRequestClose) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call(_this$props, _this.props.notificationId);
        }, 500);
      });
    });
    _this.notification = /*#__PURE__*/(0, _react.createRef)();
    _this.unrenderTimeout = null;
    _this.state = {
      hidden: true,
      leave: false
    };
    return _this;
  }
  (0, _createClass2["default"])(Notification, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var duration = this.props.duration;
      var notificationEl = this.notification && this.notification.current;
      notificationEl.style.height = notificationEl.clientHeight + 'px';
      notificationEl.style.width = notificationEl.clientWidth + 'px';
      if (duration > 0) {
        this.unrenderTimeout = setTimeout(function () {
          _this2.setState({
            hidden: true,
            leave: true
          }, function () {
            return setTimeout(function () {
              var _this2$props$onReques, _this2$props;
              return (_this2$props$onReques = (_this2$props = _this2.props).onRequestClose) === null || _this2$props$onReques === void 0 ? void 0 : _this2$props$onReques.call(_this2$props, _this2.props.notificationId);
            }, 500);
          });
        }, duration);
      }
      setTimeout(function () {
        _this2.setState({
          hidden: false
        });
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unrenderTimeout && clearTimeout(this.unrenderTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        className = _this$props2.className,
        style = _this$props2.style,
        type = _this$props2.type,
        title = _this$props2.title,
        message = _this$props2.message,
        iconCls = _this$props2.iconCls,
        closeIconCls = _this$props2.closeIconCls,
        closeIconVisible = _this$props2.closeIconVisible,
        closeButtonVisible = _this$props2.closeButtonVisible,
        closeButtonValue = _this$props2.closeButtonValue;
      var _this$state = this.state,
        hidden = _this$state.hidden,
        leave = _this$state.leave;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.notification,
        className: (0, _classnames["default"])('notification', (_classNames = {
          'theme-default': type === _MsgType["default"].DEFAULT
        }, (0, _defineProperty2["default"])(_classNames, "theme-".concat(type), type !== _MsgType["default"].DEFAULT), (0, _defineProperty2["default"])(_classNames, "hidden", hidden), (0, _defineProperty2["default"])(_classNames, "leave", leave), (0, _defineProperty2["default"])(_classNames, 'has-close-button', closeButtonVisible), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style
      }, type === _MsgType["default"].DEFAULT ? null : /*#__PURE__*/_react["default"].createElement("i", {
        className: "".concat(iconCls ? iconCls : this.getIconCls(), " notification-icon")
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "notification-title"
      }, title), /*#__PURE__*/_react["default"].createElement("div", {
        className: "notification-message"
      }, message), closeIconVisible ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        className: "notification-close-icon",
        iconCls: closeIconCls,
        onClick: this.handleClick
      }) : null, closeButtonVisible ? /*#__PURE__*/_react["default"].createElement(_AnchorButton["default"], {
        className: "notification-close-Button",
        value: closeButtonValue,
        onClick: this.handleClick
      }) : null);
    }
  }]);
  return Notification;
}(_react.Component);
(0, _defineProperty2["default"])(Notification, "Type", _MsgType["default"]);
Notification.propTypes = {
  /**
   * The CSS class name of notification.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the notification.
   */
  style: _propTypes["default"].object,
  notificationId: _propTypes["default"].number,
  /**
   * The type of notification.
   */
  type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_MsgType["default"])),
  /**
   * The title of notification.
   */
  title: _propTypes["default"].any,
  /**
   * The message of notification.
   */
  message: _propTypes["default"].any,
  /**
   * The icon class name of notification.
   */
  iconCls: _propTypes["default"].string,
  /**
   * The close icon class name of notification.
   */
  closeIconCls: _propTypes["default"].string,
  closeIconVisible: _propTypes["default"].bool,
  closeButtonVisible: _propTypes["default"].bool,
  closeButtonValue: _propTypes["default"].string,
  /**
   * The duration of notification.
   */
  duration: _propTypes["default"].number,
  onRequestClose: _propTypes["default"].func
};
Notification.defaultProps = {
  notificationId: 0,
  type: _MsgType["default"].INFO,
  title: 'message',
  message: '',
  iconCls: '',
  closeIconCls: 'fas fa-times',
  closeIconVisible: false,
  closeButtonVisible: true,
  closeButtonValue: 'Close',
  duration: 0
};
var _default = Notification;
exports["default"] = _default;