"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactResizable = require("react-resizable");
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ResizableTh = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ResizableTh, _Component);
  var _super = _createSuper(ResizableTh);
  function ResizableTh(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ResizableTh);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResize", function (e, _ref) {
      var size = _ref.size;
      var onResize = _this.props.onResize;
      onResize && onResize(size === null || size === void 0 ? void 0 : size.width, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeStart", function (e, _ref2) {
      var size = _ref2.size;
      var onResizeStart = _this.props.onResizeStart;
      onResizeStart && onResizeStart(size === null || size === void 0 ? void 0 : size.width, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResizeStop", function (e, _ref3) {
      var size = _ref3.size;
      var onResizeStop = _this.props.onResizeStop;
      onResizeStop && onResizeStop(size === null || size === void 0 ? void 0 : size.width, e);
    });
    return _this;
  }
  (0, _createClass2["default"])(ResizableTh, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        resizable = _this$props.resizable,
        activated = _this$props.activated,
        deactivated = _this$props.deactivated,
        width = _this$props.width,
        minWidth = _this$props.minWidth,
        maxWidth = _this$props.maxWidth;
      return resizable ? /*#__PURE__*/_react["default"].createElement(_reactResizable.Resizable, {
        className: (0, _classnames["default"])('resizable-th', {
          activated: activated,
          deactivated: deactivated
        }),
        width: width,
        height: 0,
        minConstraints: [minWidth, null],
        maxConstraints: [maxWidth, null],
        onResize: this.handleResize,
        onResizeStart: this.handleResizeStart,
        onResizeStop: this.handleResizeStop
      }, children) : children;
    }
  }]);
  return ResizableTh;
}(_react.Component);
ResizableTh.propTypes = {
  children: _propTypes["default"].any,
  resizable: _propTypes["default"].bool,
  activated: _propTypes["default"].bool,
  deactivated: _propTypes["default"].bool,
  width: _propTypes["default"].number,
  minWidth: _propTypes["default"].number,
  maxWidth: _propTypes["default"].number,
  onResize: _propTypes["default"].func,
  onResizeStart: _propTypes["default"].func,
  onResizeStop: _propTypes["default"].func
};
ResizableTh.defaultProps = {
  minWidth: 40,
  maxWidth: Infinity
};
var _default = ResizableTh;
exports["default"] = _default;