"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BaseTable = _interopRequireDefault(require("../_BaseTable"));
var _ScrollableTable = _interopRequireDefault(require("../_ScrollableTable"));
var _DynamicRenderTableProvider = _interopRequireDefault(require("../_DynamicRenderTableProvider"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _reactDom = require("react-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ScrollBar = _interopRequireDefault(require("../_vendors/ScrollBar"));
var _excluded = ["horizontalScrollStyle", "verticalScrollStyle", "columns", "headColumns", "bodyColumns", "isHeadHidden", "isFootHidden", "isLayoutFixed", "isHeadFixed", "isFootFixed", "data", "footData", "scroll", "useDynamicRender", "dynamicRenderIndex", "scrollHeight", "rowHeight", "scrollBuffer", "defaultColumnWidth", "onScroll", "onWheel", "onColumnMeasure", "onInit", "onGetScrollerEl"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ScrollTable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ScrollTable, _Component);
  var _super = _createSuper(ScrollTable);
  function ScrollTable(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ScrollTable);
    for (var _len = arguments.length, _restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      _restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(_restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateFragmentEl", function (fragment) {
      var _assertThisInitialize, _assertThisInitialize2;
      var onGetScrollerEl = _this.props.onGetScrollerEl,
        instance = (_assertThisInitialize = (0, _assertThisInitialized2["default"])(_this)) === null || _assertThisInitialize === void 0 ? void 0 : (_assertThisInitialize2 = _assertThisInitialize["".concat(fragment, "Scroller")]) === null || _assertThisInitialize2 === void 0 ? void 0 : _assertThisInitialize2.current,
        el = instance && (0, _reactDom.findDOMNode)(instance);
      if (!onGetScrollerEl || !el || _this.lastScrollerEl[fragment] === el) {
        return;
      }
      onGetScrollerEl(fragment, el);
      _this.lastScrollerEl[fragment] = el;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateEl", function () {
      var _this$props = _this.props,
        isHeadFixed = _this$props.isHeadFixed,
        isFootFixed = _this$props.isFootFixed;
      _this.updateFragmentEl(_TableFragment["default"].BODY);
      isHeadFixed && _this.updateFragmentEl(_TableFragment["default"].HEAD);
      isFootFixed && _this.updateFragmentEl(_TableFragment["default"].FOOT);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "hasVerticalScroll", function () {
      var scrollEl = _this.lastScrollerEl[_TableFragment["default"].BODY];
      if (!scrollEl) {
        return false;
      }
      return scrollEl.scrollHeight > scrollEl.clientHeight;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleColumnsSpan", function () {
      var _this$props$onRequest, _this$props2;
      for (var _len2 = arguments.length, restArgs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        restArgs[_key2] = arguments[_key2];
      }
      return (_this$props$onRequest = (_this$props2 = _this.props).onRequestColumnsSpan) === null || _this$props$onRequest === void 0 ? void 0 : _this$props$onRequest.call.apply(_this$props$onRequest, [_this$props2].concat(restArgs));
    });
    _this.headScroller = /*#__PURE__*/(0, _react.createRef)();
    _this.bodyScroller = /*#__PURE__*/(0, _react.createRef)();
    _this.footScroller = /*#__PURE__*/(0, _react.createRef)();
    _this.lastScrollerEl = {};
    return _this;
  }
  (0, _createClass2["default"])(ScrollTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props$onInit, _this$props3;
      this.updateEl();
      (_this$props$onInit = (_this$props3 = this.props).onInit) === null || _this$props$onInit === void 0 ? void 0 : _this$props$onInit.call(_this$props3);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.updateEl();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        horizontalScrollStyle = _this$props4.horizontalScrollStyle,
        verticalScrollStyle = _this$props4.verticalScrollStyle,
        columns = _this$props4.columns,
        headColumns = _this$props4.headColumns,
        bodyColumns = _this$props4.bodyColumns,
        isHeadHidden = _this$props4.isHeadHidden,
        isFootHidden = _this$props4.isFootHidden,
        isLayoutFixed = _this$props4.isLayoutFixed,
        isHeadFixed = _this$props4.isHeadFixed,
        isFootFixed = _this$props4.isFootFixed,
        data = _this$props4.data,
        footData = _this$props4.footData,
        scroll = _this$props4.scroll,
        useDynamicRender = _this$props4.useDynamicRender,
        dynamicRenderIndex = _this$props4.dynamicRenderIndex,
        scrollHeight = _this$props4.scrollHeight,
        rowHeight = _this$props4.rowHeight,
        scrollBuffer = _this$props4.scrollBuffer,
        defaultColumnWidth = _this$props4.defaultColumnWidth,
        onScroll = _this$props4.onScroll,
        onWheel = _this$props4.onWheel,
        onColumnMeasure = _this$props4.onColumnMeasure,
        onInit = _this$props4.onInit,
        onGetScrollerEl = _this$props4.onGetScrollerEl,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props4, _excluded);
      if (!columns && !headColumns && !bodyColumns) {
        return null;
      }
      var hasVerticalScroll = this.hasVerticalScroll();
      var hasHead = !isHeadHidden && isHeadFixed;
      var hasFoot = !isFootHidden && isFootFixed;
      var scrollableTableStyle = _ScrollBar["default"].getHideHorizontalScrollBarStyle();
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, hasHead ? /*#__PURE__*/_react["default"].createElement(_ScrollableTable["default"], {
        ref: this.headScroller,
        className: "scroll-table-head",
        style: scrollableTableStyle,
        fragment: _TableFragment["default"].HEAD,
        scroll: scroll,
        useDynamicRender: useDynamicRender,
        scrollHeight: scrollHeight,
        rowHeight: rowHeight,
        scrollBuffer: scrollBuffer,
        onScroll: onScroll
      }, function (scrollEl) {
        return /*#__PURE__*/_react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
          className: "table-head",
          fragment: _TableFragment["default"].HEAD,
          columns: columns,
          headColumns: headColumns,
          bodyColumns: bodyColumns,
          isHeadFixed: isHeadFixed,
          isFootFixed: isFootFixed,
          data: data,
          footData: footData,
          scrollEl: scrollEl,
          useDynamicRender: useDynamicRender,
          scrollHeight: scrollHeight,
          rowHeight: rowHeight,
          scrollBuffer: scrollBuffer,
          hasVerticalScroll: hasVerticalScroll,
          isBodyHidden: true,
          isFootHidden: true,
          useColumnsWidth: true,
          isLayoutFixed: isLayoutFixed,
          defaultColumnWidth: defaultColumnWidth,
          onRequestColumnsSpan: _this2.handleColumnsSpan
        }));
      }) : null, /*#__PURE__*/_react["default"].createElement(_ScrollableTable["default"], {
        ref: this.bodyScroller,
        className: (0, _classnames["default"])('scroll-table-body', {
          'has-head': hasHead,
          'has-foot': hasFoot
        }),
        style: verticalScrollStyle,
        scroll: scroll,
        useDynamicRender: useDynamicRender,
        scrollHeight: scrollHeight,
        rowHeight: rowHeight,
        scrollBuffer: scrollBuffer,
        onScroll: onScroll,
        onWheel: onWheel
      }, function (scrollEl) {
        return /*#__PURE__*/_react["default"].createElement(_DynamicRenderTableProvider["default"], {
          data: data,
          useDynamicRender: useDynamicRender,
          rowHeight: rowHeight
        }, /*#__PURE__*/_react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
          className: "table-body",
          style: {
            width: horizontalScrollStyle === null || horizontalScrollStyle === void 0 ? void 0 : horizontalScrollStyle.width,
            minWidth: horizontalScrollStyle !== null && horizontalScrollStyle !== void 0 && horizontalScrollStyle.width ? '100%' : null,
            transform: useDynamicRender && dynamicRenderIndex ? "translateY(".concat(dynamicRenderIndex.startWithBuffer * rowHeight, "px)") : null
          },
          fragment: _TableFragment["default"].BODY,
          columns: columns,
          headColumns: headColumns,
          bodyColumns: bodyColumns,
          isHeadFixed: isHeadFixed,
          isFootFixed: isFootFixed,
          isLayoutFixed: isLayoutFixed,
          isHeadHidden: isHeadHidden || isHeadFixed,
          isFootHidden: isFootHidden || isFootFixed,
          data: data,
          footData: footData,
          scrollEl: scrollEl,
          useDynamicRender: useDynamicRender,
          scrollHeight: scrollHeight,
          rowHeight: rowHeight,
          scrollBuffer: scrollBuffer,
          defaultColumnWidth: defaultColumnWidth,
          onRequestColumnsSpan: _this2.handleColumnsSpan,
          onColumnMeasure: onColumnMeasure
        })));
      }), hasFoot ? /*#__PURE__*/_react["default"].createElement(_ScrollableTable["default"], {
        ref: this.footScroller,
        className: "scroll-table-foot",
        style: scrollableTableStyle,
        fragment: _TableFragment["default"].FOOT,
        scroll: scroll,
        useDynamicRender: useDynamicRender,
        scrollHeight: scrollHeight,
        rowHeight: rowHeight,
        scrollBuffer: scrollBuffer,
        onScroll: onScroll
      }, function (scrollEl) {
        return /*#__PURE__*/_react["default"].createElement(_BaseTable["default"], (0, _extends2["default"])({}, restProps, {
          className: "table-foot",
          fragment: _TableFragment["default"].FOOT,
          columns: columns,
          headColumns: headColumns,
          bodyColumns: bodyColumns,
          isHeadFixed: isHeadFixed,
          isFootFixed: isFootFixed,
          ignoreColumnSpan: true,
          data: data,
          footData: footData,
          scrollEl: scrollEl,
          useDynamicRender: useDynamicRender,
          scrollHeight: scrollHeight,
          rowHeight: rowHeight,
          scrollBuffer: scrollBuffer,
          hasVerticalScroll: hasVerticalScroll,
          isHeadHidden: true,
          isBodyHidden: true,
          useColumnsWidth: true,
          isLayoutFixed: isLayoutFixed,
          defaultColumnWidth: defaultColumnWidth,
          onRequestColumnsSpan: _this2.handleColumnsSpan
        }));
      }) : null);
    }
  }]);
  return ScrollTable;
}(_react.Component);
(0, _defineProperty2["default"])(ScrollTable, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(ScrollTable, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ScrollTable, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(ScrollTable, "SortingType", _SortingType["default"]);
ScrollTable.propTypes = {
  horizontalScrollStyle: _propTypes["default"].object,
  verticalScrollStyle: _propTypes["default"].object,
  /**
   * The theme of the table select radio or checkbox.
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  /**
   * The select all mode of table, all or current page.
   */
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })),
  headColumns: _propTypes["default"].array,
  bodyColumns: _propTypes["default"].array,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  data: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  dynamicRenderData: _propTypes["default"].array,
  value: _propTypes["default"].array,
  idField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isRowDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  expandRows: _propTypes["default"].array,
  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  isClickSorting: _propTypes["default"].bool,
  /**
   * fixed
   */
  isLayoutFixed: _propTypes["default"].bool,
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,
  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,
  /**
   * has renderer
   */
  hasHeadRenderer: _propTypes["default"].bool,
  hasBodyRenderer: _propTypes["default"].bool,
  hasFootRenderer: _propTypes["default"].bool,
  /**
   * fixed column
   */
  hasFixedLeftColumn: _propTypes["default"].bool,
  hasFixedRightColumn: _propTypes["default"].bool,
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  dynamicRenderIndex: _propTypes["default"].object,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  maxColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  /**
   * callback
   */
  onInit: _propTypes["default"].func,
  onGetScrollerEl: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onScroll: _propTypes["default"].func,
  onWheel: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onRequestColumnsSpan: _propTypes["default"].func,
  onColumnsWidthChange: _propTypes["default"].func,
  onColumnResizeStart: _propTypes["default"].func,
  onColumnResizeEnd: _propTypes["default"].func,
  onColumnMeasure: _propTypes["default"].func
};
ScrollTable.defaultProps = {
  columnKeyField: 'key',
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  idField: 'id',
  expandRows: [],
  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  isClickSorting: true,
  /**
   * fixed
   */
  isLayoutFixed: true,
  isHeadFixed: false,
  isFootFixed: false,
  /**
   * hidden
   */
  isHeadHidden: false,
  isFootHidden: false,
  /**
   * has renderer
   */
  hasHeadRenderer: true,
  hasBodyRenderer: true,
  hasFootRenderer: true,
  /**
   * fixed column
   */
  hasFixedLeftColumn: false,
  hasFixedRightColumn: false,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8,
  /**
   * column resizable
   */
  defaultColumnWidth: 100,
  minColumnWidth: 64,
  maxColumnWidth: Infinity
};
var _default = ScrollTable;
exports["default"] = _default;