"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _excluded = ["scroll", "useDynamicRender", "children", "fragment", "scrollHeight", "rowHeight", "scrollBuffer"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ScrollableTable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ScrollableTable, _Component);
  var _super = _createSuper(ScrollableTable);
  function ScrollableTable(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ScrollableTable);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getChildren", function () {
      var children = _this.props.children,
        wrapperEl = _this.state.wrapperEl;
      return (typeof children === 'function' ? children(wrapperEl) : children) || null;
    });
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      wrapperEl: null
    };
    return _this;
  }
  (0, _createClass2["default"])(ScrollableTable, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        wrapperEl: this.wrapper && this.wrapper.current
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        scroll = _this$props.scroll,
        useDynamicRender = _this$props.useDynamicRender,
        c = _this$props.children,
        fragment = _this$props.fragment,
        scrollHeight = _this$props.scrollHeight,
        rowHeight = _this$props.rowHeight,
        scrollBuffer = _this$props.scrollBuffer,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        children = this.getChildren();
      return useDynamicRender || !(0, _isEmpty["default"])(scroll) ? /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, restProps, {
        ref: this.wrapper
      }), children) : children;
    }
  }]);
  return ScrollableTable;
}(_react.Component);
ScrollableTable.propTypes = {
  children: _propTypes["default"].any,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  /**
   * scroll
   */
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),
  fragment: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TableFragment["default"])),
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  onScroll: _propTypes["default"].func
};
ScrollableTable.defaultProps = {
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8
};
var _default = ScrollableTable;
exports["default"] = _default;