"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ScrollTable = _interopRequireDefault(require("../_ScrollTable"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _Theme = _interopRequireDefault(require("../Theme"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableLayout = _interopRequireDefault(require("../_vendors/TableLayout"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _Calculation = _interopRequireDefault(require("../_vendors/Calculation"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _excluded = ["columns", "data", "footData", "scroll", "noDataText", "isLayoutFixed", "isHeadHidden", "isFootHidden", "expandRows", "useDynamicRender", "minColumnWidth", "maxColumnWidth", "isSelectRecursive", "selectUncheckedIconCls", "selectCheckedIconCls", "resizing", "isSelectAllDisabled", "selectIndeterminateIconCls", "selectColumn", "expandIconCls", "autoSorting", "isPaginated", "page", "pageSize", "canBeExpanded", "scrollTop", "onPingLeftChange", "onPingRightChange", "sortingFunc", "onChange", "onExpand", "onCollapse", "onExpandChange", "onDataUpdate", "onSelect", "onSelectAll", "onDeselect", "onDeselectAll", "onScrollTopChange", "onScroll", "onResizeStart", "onResizeEnd"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TableContent = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TableContent, _Component);
  var _super = _createSuper(TableContent);
  function TableContent(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TableContent);
    for (var _len = arguments.length, _restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      _restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(_restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (node, rowIndex, colIndex, collapsed, depth, path) {
      var _this$props$onSelect, _this$props2, _this$props$onChange, _this$props3;
      if (!node || _this.props.selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var _this$props = _this.props,
        data = _this$props.data,
        value = _this$props.value,
        isSelectRecursive = _this$props.isSelectRecursive,
        idField = _this$props.idField;
      var result = value && (0, _isArray["default"])(value) ? value.slice() : [];
      _TableCalculation["default"].handleSelect(node, result, idField, isSelectRecursive);
      if (isSelectRecursive) {
        result = _TableCalculation["default"].formatValue(result, data, idField);
      }
      (_this$props$onSelect = (_this$props2 = _this.props).onSelect) === null || _this$props$onSelect === void 0 ? void 0 : _this$props$onSelect.call(_this$props2, node, rowIndex, colIndex, collapsed, depth, path);
      (_this$props$onChange = (_this$props3 = _this.props).onChange) === null || _this$props$onChange === void 0 ? void 0 : _this$props$onChange.call(_this$props3, result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDeselect", function (node, rowIndex, colIndex, collapsed, depth, path) {
      var _this$props$onDeselec, _this$props5, _this$props$onChange2, _this$props6;
      if (!node || _this.props.selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      var _this$props4 = _this.props,
        isSelectRecursive = _this$props4.isSelectRecursive,
        data = _this$props4.data,
        value = _this$props4.value,
        idField = _this$props4.idField;
      var result = value && (0, _isArray["default"])(value) ? value.slice() : [];
      if (result.length > 0) {
        _TableCalculation["default"].handleDeselect(node, result, idField, isSelectRecursive);
        if (isSelectRecursive) {
          result = _TableCalculation["default"].formatValue(result, data, idField);
        }
      }
      (_this$props$onDeselec = (_this$props5 = _this.props).onDeselect) === null || _this$props$onDeselec === void 0 ? void 0 : _this$props$onDeselec.call(_this$props5, node, rowIndex, colIndex, collapsed, depth, path);
      (_this$props$onChange2 = (_this$props6 = _this.props).onChange) === null || _this$props$onChange2 === void 0 ? void 0 : _this$props$onChange2.call(_this$props6, result);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAll", function () {
      var _this$props$onSelectA, _this$props8, _this$props$onChange3, _this$props9;
      var _this$props7 = _this.props,
        selectMode = _this$props7.selectMode,
        selectAllMode = _this$props7.selectAllMode,
        data = _this$props7.data,
        value = _this$props7.value,
        disabled = _this$props7.disabled,
        idField = _this$props7.idField;
      if (disabled || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      _TableCalculation["default"].handleSelectAll(selectAllMode === _SelectAllMode["default"].ALL ? data : _this.tableData, value, idField);
      (_this$props$onSelectA = (_this$props8 = _this.props).onSelectAll) === null || _this$props$onSelectA === void 0 ? void 0 : _this$props$onSelectA.call(_this$props8, value);
      (_this$props$onChange3 = (_this$props9 = _this.props).onChange) === null || _this$props$onChange3 === void 0 ? void 0 : _this$props$onChange3.call(_this$props9, value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleDeselectAll", function () {
      var _this$props$onDeselec2, _this$props11, _this$props$onChange4, _this$props12;
      var _this$props10 = _this.props,
        selectMode = _this$props10.selectMode,
        value = _this$props10.value,
        disabled = _this$props10.disabled;
      if (disabled || selectMode !== _SelectMode["default"].MULTI_SELECT) {
        return;
      }
      (_this$props$onDeselec2 = (_this$props11 = _this.props).onDeselectAll) === null || _this$props$onDeselec2 === void 0 ? void 0 : _this$props$onDeselec2.call(_this$props11, value);
      (_this$props$onChange4 = (_this$props12 = _this.props).onChange) === null || _this$props$onChange4 === void 0 ? void 0 : _this$props$onChange4.call(_this$props12, []);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "formatColumns", function () {
      var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.sortedColumns || _this.props.columns;
      if (!columns || columns.length < 1) {
        return columns;
      }
      var _this$props13 = _this.props,
        columnKeyField = _this$props13.columnKeyField,
        selectTheme = _this$props13.selectTheme,
        selectMode = _this$props13.selectMode,
        selectAllMode = _this$props13.selectAllMode,
        selectColumn = _this$props13.selectColumn,
        data = _this$props13.data,
        disabled = _this$props13.disabled,
        isRowDisabled = _this$props13.isRowDisabled,
        value = _this$props13.value,
        idField = _this$props13.idField,
        canBeExpanded = _this$props13.canBeExpanded,
        isSelectAllDisabled = _this$props13.isSelectAllDisabled,
        expandIconCls = _this$props13.expandIconCls,
        selectUncheckedIconCls = _this$props13.selectUncheckedIconCls,
        selectCheckedIconCls = _this$props13.selectCheckedIconCls,
        selectIndeterminateIconCls = _this$props13.selectIndeterminateIconCls;
      var firstColumn = _TableCalculation["default"].getFirstColumn(columns);
      var result = (0, _toConsumableArray2["default"])(columns);

      /**
       * handle expand
       */
      if (canBeExpanded) {
        result[0] = (0, _cloneDeep["default"])(columns[0]);
        var expandColumn = _TableCalculation["default"].getFirstColumn(result);
        if (expandColumn) {
          expandColumn.bodyRenderer = function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
            return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
              className: (0, _classnames["default"])('table-indent', "indent-level-".concat(depth)),
              style: {
                paddingLeft: depth * 20
              }
            }), _TableCalculation["default"].needCollapseButtonSpacing(tableData) ? /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
              className: (0, _classnames["default"])('expand-button', {
                hidden: !rowData || !rowData.children || rowData.children.length < 1
              }),
              iconCls: expandIconCls,
              disableTouchRipple: true,
              onClick: function onClick() {
                return _this.handleExpandChange(!collapsed, rowData);
              }
            }) : null, typeof firstColumn.bodyRenderer === 'function' ? firstColumn.bodyRenderer(rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) : firstColumn.bodyRenderer);
          };
          expandColumn.bodyNoWrap = function (rowData, rowIndex, colIndex, tableData) {
            return _TableCalculation["default"].needCollapseButtonSpacing(tableData) || firstColumn.bodyNoWrap;
          };
        }
      }

      /**
       * handle multi select
       */
      if (selectMode === _SelectMode["default"].MULTI_SELECT) {
        var _objectSpread2;
        result.unshift(_objectSpread(_objectSpread({}, selectColumn), {}, (_objectSpread2 = {}, (0, _defineProperty2["default"])(_objectSpread2, columnKeyField, 'table-multi-select-column'), (0, _defineProperty2["default"])(_objectSpread2, "fixed", (selectColumn === null || selectColumn === void 0 ? void 0 : selectColumn.fixed) || columns[0].fixed), (0, _defineProperty2["default"])(_objectSpread2, "align", (selectColumn === null || selectColumn === void 0 ? void 0 : selectColumn.align) || _HorizontalAlign["default"].CENTER), (0, _defineProperty2["default"])(_objectSpread2, "width", (selectColumn === null || selectColumn === void 0 ? void 0 : selectColumn.width) || 64), (0, _defineProperty2["default"])(_objectSpread2, "headClassName", (0, _classnames["default"])('table-select-th', selectColumn ? (0, _defineProperty2["default"])({}, selectColumn.headClassName, selectColumn.headClassName) : '')), (0, _defineProperty2["default"])(_objectSpread2, "headRenderer", function headRenderer(tableData, colIndex) {
          var _TC$isSelectAllChecke = _TableCalculation["default"].isSelectAllChecked(selectAllMode === _SelectAllMode["default"].ALL ? data : _this.tableData, value, idField),
            checked = _TC$isSelectAllChecke.checked,
            indeterminate = _TC$isSelectAllChecke.indeterminate;
          var checkboxInstance = /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
            className: "table-select",
            theme: selectTheme,
            checked: checked,
            disabled: isSelectAllDisabled || disabled,
            indeterminate: indeterminate,
            uncheckedIconCls: selectUncheckedIconCls,
            checkedIconCls: selectCheckedIconCls,
            indeterminateIconCls: selectIndeterminateIconCls,
            onCheck: _this.handleSelectAll,
            onUncheck: _this.handleDeselectAll
          });
          if (selectColumn !== null && selectColumn !== void 0 && selectColumn.headRenderer) {
            if (typeof selectColumn.headRenderer === 'function') {
              return selectColumn.headRenderer(checkboxInstance, tableData, colIndex);
            }
            return selectColumn.headRenderer;
          }
          return checkboxInstance;
        }), (0, _defineProperty2["default"])(_objectSpread2, "bodyClassName", (0, _classnames["default"])('table-select-td', selectColumn ? (0, _defineProperty2["default"])({}, selectColumn.bodyClassName, selectColumn.bodyClassName) : '')), (0, _defineProperty2["default"])(_objectSpread2, "bodyRenderer", function bodyRenderer(rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
          var checkboxInstance = /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
            className: "table-select",
            theme: selectTheme,
            disabled: disabled || _TableCalculation["default"].isNodeDisabled(rowData, isRowDisabled),
            checked: _TableCalculation["default"].isNodeChecked(rowData, value, idField),
            indeterminate: _Calculation["default"].isItemIndeterminate(rowData, value, {
              valueField: idField,
              displayField: idField
            }),
            uncheckedIconCls: selectUncheckedIconCls,
            checkedIconCls: selectCheckedIconCls,
            indeterminateIconCls: selectIndeterminateIconCls,
            onCheck: function onCheck() {
              return _this.handleSelect(rowData, rowIndex, colIndex, tableData, collapsed, depth, path);
            },
            onUncheck: function onUncheck() {
              return _this.handleDeselect(rowData, rowIndex, colIndex, tableData, collapsed, depth, path);
            }
          });
          if (selectColumn !== null && selectColumn !== void 0 && selectColumn.bodyRenderer) {
            if (typeof selectColumn.bodyRenderer === 'function') {
              return selectColumn.bodyRenderer(checkboxInstance, rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path);
            }
            return selectColumn === null || selectColumn === void 0 ? void 0 : selectColumn.bodyRenderer;
          }
          return checkboxInstance;
        }), _objectSpread2)));
      }
      return result;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "sortData", function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.data;
      var _this$props14 = _this.props,
        sorting = _this$props14.sorting,
        autoSorting = _this$props14.autoSorting,
        sortingFunc = _this$props14.sortingFunc;
      return autoSorting && sorting ? _TableCalculation["default"].sortTableData(data, sorting, sortingFunc) : data;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "paginateData", function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.props.data;
      if (!data) {
        return [];
      }
      if (!_this.props.isPaginated) {
        return data;
      }
      var _this$props15 = _this.props,
        page = _this$props15.page,
        pageSize = _this$props15.pageSize;
      var len = data.length;
      var start = page * pageSize;
      var stop = start + pageSize;
      start = start < 0 ? 0 : start;
      stop = stop > len ? len : stop;
      return data.slice(start, stop);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getIndex", function (data) {
      var _this$props16 = _this.props,
        scrollTop = _this$props16.scrollTop,
        scrollHeight = _this$props16.scrollHeight,
        rowHeight = _this$props16.rowHeight,
        scrollBuffer = _this$props16.scrollBuffer;
      return _Calculation["default"].displayIndexByScrollTop(data, scrollHeight, rowHeight, scrollTop, scrollBuffer);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "debounceResizeFixLayout", (0, _debounce["default"])(function () {
      var resizing = _this.props.resizing;
      if (resizing) {
        var _this$props$onResizeE, _this$props17;
        (_this$props$onResizeE = (_this$props17 = _this.props).onResizeEnd) === null || _this$props$onResizeE === void 0 ? void 0 : _this$props$onResizeE.call(_this$props17);
      }
    }, 600));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleReize", function (e) {
      var resizing = _this.props.resizing;
      if (!resizing) {
        var _this$props$onResizeS, _this$props18;
        (_this$props$onResizeS = (_this$props18 = _this.props).onResizeStart) === null || _this$props$onResizeS === void 0 ? void 0 : _this$props$onResizeS.call(_this$props18, e);
      } else {
        _this.debounceResizeFixLayout();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleGetScrollerEl", function (fragment, el) {
      _this["".concat(fragment, "Scroller")] = el;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollChange", function (e) {
      var _this$props$onScroll, _this$props19;
      (_this$props$onScroll = (_this$props19 = _this.props).onScroll) === null || _this$props$onScroll === void 0 ? void 0 : _this$props$onScroll.call(_this$props19, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScrollPingChange", function () {
      var _this$props$onPingLef, _this$props20, _this$props$onPingRig, _this$props21;
      var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.bodyScroller;
      if (!target) {
        return;
      }
      var scrollLeft = target.scrollLeft,
        scrollWidth = target.scrollWidth,
        offsetWidth = target.offsetWidth;
      (_this$props$onPingLef = (_this$props20 = _this.props).onPingLeftChange) === null || _this$props$onPingLef === void 0 ? void 0 : _this$props$onPingLef.call(_this$props20, scrollLeft !== 0);
      (_this$props$onPingRig = (_this$props21 = _this.props).onPingRightChange) === null || _this$props$onPingRig === void 0 ? void 0 : _this$props$onPingRig.call(_this$props21, scrollLeft < scrollWidth - offsetWidth);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleHorizontalScroll", function (e) {
      if (!e) {
        return;
      }
      var _this$props22 = _this.props,
        isHeadFixed = _this$props22.isHeadFixed,
        isFootFixed = _this$props22.isFootFixed;
      var target = e.target;
      var scrollLeft = target.scrollLeft;
      if (scrollLeft !== _this.lastScrollLeft) {
        switch (target) {
          case _this.bodyScroller:
            {
              if (isHeadFixed && _this.headScroller) {
                _this.headScroller.scrollLeft = scrollLeft;
              }
              if (isFootFixed && _this.headScroller && _this.footScroller) {
                _this.footScroller.scrollLeft = scrollLeft;
              }
              break;
            }
          case _this.headScroller:
            {
              if (_this.bodyScroller) {
                _this.bodyScroller.scrollLeft = scrollLeft;
              }
              if (isFootFixed && _this.headScroller && _this.footScroller) {
                _this.footScroller.scrollLeft = scrollLeft;
              }
              break;
            }
          case _this.footScroller:
            {
              if (isHeadFixed && _this.headScroller) {
                _this.headScroller.scrollLeft = scrollLeft;
              }
              if (_this.bodyScroller) {
                _this.bodyScroller.scrollLeft = scrollLeft;
              }
              break;
            }
        }
        _this.handleScrollPingChange(target);
        _this.lastScrollLeft = scrollLeft;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleVerticalScroll", function (e) {
      if (!e) {
        return;
      }
      var target = e.target;
      var scrollTop = target.scrollTop;
      if (scrollTop !== _this.lastScrollTop) {
        if (target !== _this.headScroller && target !== _this.footScroller) {
          var _this$props$onScrollT, _this$props23;
          (_this$props$onScrollT = (_this$props23 = _this.props).onScrollTopChange) === null || _this$props$onScrollT === void 0 ? void 0 : _this$props$onScrollT.call(_this$props23, scrollTop);
        }
        _this.lastScrollTop = scrollTop;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleScroll", function (e) {
      if (!e || e.currentTarget !== e.target) {
        return;
      }
      _this.handleScrollChange(e);
      _this.handleHorizontalScroll(e);
      _this.handleVerticalScroll(e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleWheel", function (e) {
      if (!window.navigator.userAgent.match(/Trident\/7\./)) {
        return;
      }
      e.preventDefault(e);
      _this.handleScrollChange(e);
      var wd = e.deltaY;
      var target = e.target;
      var scrollTop;
      if (_this.lastScrollTop) {
        scrollTop = _this.lastScrollTop + wd;
      } else {
        scrollTop = wd;
      }
      if (_this.bodyScroller && _this.bodyScroller !== target) {
        var _this$props$onScrollT2, _this$props24;
        (_this$props$onScrollT2 = (_this$props24 = _this.props).onScrollTopChange) === null || _this$props$onScrollT2 === void 0 ? void 0 : _this$props$onScrollT2.call(_this$props24, scrollTop);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleExpandChange", function (collapsed, rowData) {
      var _this$props25 = _this.props,
        idField = _this$props25.idField,
        expandRows = _this$props25.expandRows;
      if (collapsed) {
        var _this$props$onCollaps, _this$props26;
        (_this$props$onCollaps = (_this$props26 = _this.props).onCollapse) === null || _this$props$onCollaps === void 0 ? void 0 : _this$props$onCollaps.call(_this$props26, rowData);
        var index = _TableCalculation["default"].indexOfNodeInValue(rowData, expandRows, idField);
        if (index !== -1) {
          var _this$props$onExpandC, _this$props27;
          expandRows.splice(index, 1);
          (_this$props$onExpandC = (_this$props27 = _this.props).onExpandChange) === null || _this$props$onExpandC === void 0 ? void 0 : _this$props$onExpandC.call(_this$props27, expandRows);
        }
      } else {
        var _this$props$onExpand, _this$props28;
        (_this$props$onExpand = (_this$props28 = _this.props).onExpand) === null || _this$props$onExpand === void 0 ? void 0 : _this$props$onExpand.call(_this$props28, rowData);
        var _index = _TableCalculation["default"].indexOfNodeInValue(rowData, expandRows, idField);
        if (_index === -1) {
          var _this$props$onExpandC2, _this$props29;
          expandRows.push(rowData);
          (_this$props$onExpandC2 = (_this$props29 = _this.props).onExpandChange) === null || _this$props$onExpandC2 === void 0 ? void 0 : _this$props$onExpandC2.call(_this$props29, expandRows, function () {
            var _this$props30 = _this.props,
              value = _this$props30.value,
              selectMode = _this$props30.selectMode,
              isSelectRecursive = _this$props30.isSelectRecursive,
              idField = _this$props30.idField;
            if (selectMode === _SelectMode["default"].MULTI_SELECT && isSelectRecursive && _TableCalculation["default"].isNodeChecked(rowData, value, idField)) {
              var _this$props$onChange5, _this$props31;
              (_this$props$onChange5 = (_this$props31 = _this.props).onChange) === null || _this$props$onChange5 === void 0 ? void 0 : _this$props$onChange5.call(_this$props31, _TableCalculation["default"].recursiveSelectChildren(rowData, value));
            }
          });
        }
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRequestColumnsSpan", function (fragment) {
      var columns = _this.props.columns;
      for (var _len2 = arguments.length, restArgs = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        restArgs[_key2 - 1] = arguments[_key2];
      }
      return _TableCalculation["default"].getAdvancedColumnsSpan.apply(_TableCalculation["default"], [columns, fragment].concat(restArgs));
    });
    _this.headScroller = null;
    _this.bodyScroller = null;
    _this.footScroller = null;
    _this.lastScrollLeft = 0;
    _this.lastScrollTop = 0;
    _this.wrapper = /*#__PURE__*/(0, _react.createRef)();
    _this.wrapperEl = null;

    // sorted current page cache data
    _this.tableData = [];
    return _this;
  }
  (0, _createClass2["default"])(TableContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$wrapper;
      // get elements
      this.wrapperEl = (_this$wrapper = this.wrapper) === null || _this$wrapper === void 0 ? void 0 : _this$wrapper.current;

      // bind event
      _Event["default"].addEvent(window, 'resize', this.handleReize);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this$props$onDataUpd, _this$props32;
      (_this$props$onDataUpd = (_this$props32 = this.props).onDataUpdate) === null || _this$props$onDataUpd === void 0 ? void 0 : _this$props$onDataUpd.call(_this$props32, this.tableData);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      _Event["default"].removeEvent(window, 'resize', this.handleReize);
    }

    /**
     * handle one node selected
     * @param node
     * @param rowIndex
     * @param colIndex
     * @param collapsed
     * @param depth
     * @param path
     */
  }, {
    key: "render",
    value: function render() {
      var _this$props33 = this.props,
        columns = _this$props33.columns,
        data = _this$props33.data,
        footData = _this$props33.footData,
        scroll = _this$props33.scroll,
        noDataText = _this$props33.noDataText,
        isLayoutFixed = _this$props33.isLayoutFixed,
        isHeadHidden = _this$props33.isHeadHidden,
        isFootHidden = _this$props33.isFootHidden,
        expandRows = _this$props33.expandRows,
        useDynamicRender = _this$props33.useDynamicRender,
        minColumnWidth = _this$props33.minColumnWidth,
        maxColumnWidth = _this$props33.maxColumnWidth,
        isSelectRecursive = _this$props33.isSelectRecursive,
        selectUncheckedIconCls = _this$props33.selectUncheckedIconCls,
        selectCheckedIconCls = _this$props33.selectCheckedIconCls,
        resizing = _this$props33.resizing,
        isSelectAllDisabled = _this$props33.isSelectAllDisabled,
        selectIndeterminateIconCls = _this$props33.selectIndeterminateIconCls,
        selectColumn = _this$props33.selectColumn,
        expandIconCls = _this$props33.expandIconCls,
        autoSorting = _this$props33.autoSorting,
        isPaginated = _this$props33.isPaginated,
        page = _this$props33.page,
        pageSize = _this$props33.pageSize,
        canBeExpanded = _this$props33.canBeExpanded,
        scrollTop = _this$props33.scrollTop,
        onPingLeftChange = _this$props33.onPingLeftChange,
        onPingRightChange = _this$props33.onPingRightChange,
        sortingFunc = _this$props33.sortingFunc,
        onChange = _this$props33.onChange,
        onExpand = _this$props33.onExpand,
        onCollapse = _this$props33.onCollapse,
        onExpandChange = _this$props33.onExpandChange,
        onDataUpdate = _this$props33.onDataUpdate,
        onSelect = _this$props33.onSelect,
        onSelectAll = _this$props33.onSelectAll,
        onDeselect = _this$props33.onDeselect,
        onDeselectAll = _this$props33.onDeselectAll,
        onScrollTopChange = _this$props33.onScrollTopChange,
        onScroll = _this$props33.onScroll,
        onResizeStart = _this$props33.onResizeStart,
        onResizeEnd = _this$props33.onResizeEnd,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props33, _excluded);

      // get sorted columns according to fixed column
      var _TC$sortColumns = _TableCalculation["default"].sortColumns(columns),
        sortedColumns = _TC$sortColumns.sortedColumns,
        hasFixedLeftColumn = _TC$sortColumns.hasFixedLeftColumn,
        hasFixedRightColumn = _TC$sortColumns.hasFixedRightColumn;
      this.sortedColumns = sortedColumns;
      this.hasFixedLeftColumn = hasFixedLeftColumn;
      this.hasFixedRightColumn = hasFixedRightColumn;

      // add row expand and multi select column
      this.formatedColumns = this.formatColumns(this.sortedColumns);
      if (!this.formatedColumns) {
        return null;
      }
      this.headColumns = _TableCalculation["default"].getHeadColumns(this.formatedColumns);
      this.bodyColumns = _TableCalculation["default"].getBodyColumns(this.formatedColumns);
      this.tableData = this.paginateData(this.sortData(data));
      if (useDynamicRender) {
        this.dynamicRenderIndex = this.getIndex(this.tableData);
        this.dynamicRenderData = this.tableData && this.dynamicRenderIndex ? this.tableData.slice(this.dynamicRenderIndex.startWithBuffer, this.dynamicRenderIndex.stopWithBuffer + 1) : this.tableData;
      }
      this.finalData = useDynamicRender ? this.dynamicRenderData : this.tableData;
      var _TL$getScrollerStyle = _TableLayout["default"].getScrollerStyle(scroll, this.props),
        horizontalScrollStyle = _TL$getScrollerStyle.horizontalScrollStyle,
        verticalScrollStyle = _TL$getScrollerStyle.verticalScrollStyle;
      var isFinalHeadHidden = isHeadHidden || !_TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].HEAD);
      var isFinalFootHidden = isFootHidden || !_TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].FOOT);
      var hasHeadRenderer = _TableCalculation["default"].hasHeadRenderer(this.headColumns);
      var hasBodyRenderer = _TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].BODY);
      var hasFootRenderer = _TableCalculation["default"].hasRenderer(this.bodyColumns, _TableFragment["default"].FOOT);
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.wrapper,
        className: "table-content"
      }, /*#__PURE__*/_react["default"].createElement(_ScrollTable["default"], (0, _extends2["default"])({}, restProps, {
        horizontalScrollStyle: horizontalScrollStyle,
        verticalScrollStyle: verticalScrollStyle,
        headColumns: this.headColumns,
        bodyColumns: this.bodyColumns,
        data: this.tableData,
        footData: footData,
        dynamicRenderData: this.dynamicRenderData,
        expandRows: expandRows,
        isLayoutFixed: isLayoutFixed,
        isHeadHidden: isFinalHeadHidden,
        isFootHidden: isFinalFootHidden,
        hasFixedLeftColumn: hasFixedLeftColumn,
        hasFixedRightColumn: hasFixedRightColumn,
        hasHeadRenderer: hasHeadRenderer,
        hasBodyRenderer: hasBodyRenderer,
        hasFootRenderer: hasFootRenderer,
        scroll: scroll,
        useDynamicRender: useDynamicRender,
        dynamicRenderIndex: this.dynamicRenderIndex,
        minColumnWidth: minColumnWidth,
        maxColumnWidth: maxColumnWidth,
        onInit: this.handleScrollPingChange,
        onScroll: this.handleScroll,
        onWheel: this.handleWheel,
        onRequestColumnsSpan: this.handleRequestColumnsSpan,
        onGetScrollerEl: this.handleGetScrollerEl
      }))), noDataText && (!this.finalData || this.finalData.length < 1) ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "table-no-data"
      }, noDataText) : null);
    }
  }]);
  return TableContent;
}(_react.Component);
(0, _defineProperty2["default"])(TableContent, "Fragment", _TableFragment["default"]);
(0, _defineProperty2["default"])(TableContent, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(TableContent, "Fixed", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(TableContent, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TableContent, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(TableContent, "SortingType", _SortingType["default"]);
TableContent.propTypes = {
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  data: _propTypes["default"].array,
  footData: _propTypes["default"].array,
  value: _propTypes["default"].array,
  idField: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  isRowDisabled: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  noDataText: _propTypes["default"].any,
  /**
   * expand
   */
  canBeExpanded: _propTypes["default"].bool,
  expandRows: _propTypes["default"].array,
  expandIconCls: _propTypes["default"].string,
  /**
   * selection
   */
  selectTheme: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_Theme["default"])),
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  selectAllMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectAllMode["default"])),
  selectColumn: _propTypes["default"].shape({
    /**
     * fixed position of column ( 'left' / 'right' )
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any
  }),
  isSelectAllDisabled: _propTypes["default"].bool,
  isSelectRecursive: _propTypes["default"].bool,
  selectUncheckedIconCls: _propTypes["default"].string,
  selectCheckedIconCls: _propTypes["default"].string,
  selectIndeterminateIconCls: _propTypes["default"].string,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
  sortingAscIconCls: _propTypes["default"].string,
  sortingDescIconCls: _propTypes["default"].string,
  autoSorting: _propTypes["default"].bool,
  isClickSorting: _propTypes["default"].bool,
  sortingFunc: _propTypes["default"].func,
  /**
   * pagination
   */
  isPaginated: _propTypes["default"].bool,
  page: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  /**
   * hidden
   */
  isHeadHidden: _propTypes["default"].bool,
  isFootHidden: _propTypes["default"].bool,
  /**
   * fixed
   */
  isLayoutFixed: _propTypes["default"].bool,
  isHeadFixed: _propTypes["default"].bool,
  isFootFixed: _propTypes["default"].bool,
  /**
   * scroll
   */
  scrollLeft: _propTypes["default"].number,
  scrollTop: _propTypes["default"].number,
  scroll: _propTypes["default"].shape({
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
  }),
  /**
   * resize
   */
  resizing: _propTypes["default"].bool,
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  scrollHeight: _propTypes["default"].number,
  rowHeight: _propTypes["default"].number,
  scrollBuffer: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  minColumnWidth: _propTypes["default"].number,
  maxColumnWidth: _propTypes["default"].number,
  resizingColumn: _propTypes["default"].object,
  /**
   * callback
   */
  onChange: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onSelectAll: _propTypes["default"].func,
  onDeselectAll: _propTypes["default"].func,
  onExpand: _propTypes["default"].func,
  onCollapse: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onSortChange: _propTypes["default"].func,
  onPingLeftChange: _propTypes["default"].func,
  onPingRightChange: _propTypes["default"].func,
  onScrollTopChange: _propTypes["default"].func,
  onScroll: _propTypes["default"].func,
  onResizeStart: _propTypes["default"].func,
  onResizeEnd: _propTypes["default"].func,
  onDataUpdate: _propTypes["default"].func,
  onColumnsWidthChange: _propTypes["default"].func,
  onColumnResizeStart: _propTypes["default"].func,
  onColumnResizeEnd: _propTypes["default"].func,
  onColumnMeasure: _propTypes["default"].func
};
TableContent.defaultProps = {
  columnKeyField: 'key',
  disabled: false,
  idField: 'id',
  noDataText: 'No Data',
  /**
   * expand
   */
  expandRows: [],
  expandIconCls: 'fas fa-chevron-right',
  /**
   * selection
   */
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  selectAllMode: _SelectAllMode["default"].CURRENT_PAGE,
  isSelectRecursive: false,
  selectUncheckedIconCls: 'far fa-square',
  selectCheckedIconCls: 'fas fa-check-square',
  selectIndeterminateIconCls: 'fas fa-minus-square',
  /**
   * scroll
   */
  scrollTop: 0,
  /**
   * resize
   */
  resizing: false,
  /**
   * sorting
   */
  defaultSortingType: _SortingType["default"].ASC,
  sortingAscIconCls: 'fas fa-sort-up',
  sortingDescIconCls: 'fas fa-sort-down',
  autoSorting: true,
  isClickSorting: true,
  /**
   * pagination
   */
  isPaginated: true,
  page: 0,
  pageSize: 10,
  /**
   * hidden
   */
  isLayoutFixed: true,
  isHeadHidden: false,
  isFootHidden: false,
  /**
   * fixed
   */
  isHeadFixed: false,
  isFootFixed: false,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  scrollHeight: 500,
  rowHeight: 50,
  scrollBuffer: 8,
  /**
   * column resizable
   */
  defaultColumnWidth: 100,
  minColumnWidth: 64,
  maxColumnWidth: Infinity
};
var _default = TableContent;
exports["default"] = _default;