"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Pagination = _interopRequireDefault(require("../Pagination"));
var _BriefPagination = _interopRequireDefault(require("../BriefPagination"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _ComponentUtil = _interopRequireDefault(require("../_vendors/ComponentUtil"));
var _excluded = ["className", "style", "data", "value", "paginationSelectionVisible", "paginationSelectionRenderer", "paginationTotalVisible", "paginationTotalRenderer", "paginationPageVisible", "paginationPageSizeVisible", "paginationPageSizeRightIconCls", "paginationPrevIconCls", "paginationNextIconCls", "paginationFirstIconCls", "paginationLastIconCls"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TablePagination = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TablePagination, _Component);
  var _super = _createSuper(TablePagination);
  function TablePagination(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TablePagination);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getPaginationComponent", function () {
      var useFullPagination = _this.props.useFullPagination;
      return useFullPagination ? _Pagination["default"] : _BriefPagination["default"];
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handlePaginationChange", function (pagination) {
      _this.setState(pagination, function () {
        var onPaginationChange = _this.props.onPaginationChange;
        onPaginationChange && onPaginationChange(pagination);
      });
    });
    _this.state = {
      page: props.page,
      pageSize: props.pageSize
    };
    return _this;
  }
  (0, _createClass2["default"])(TablePagination, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        style = _this$props.style,
        data = _this$props.data,
        value = _this$props.value,
        paginationSelectionVisible = _this$props.paginationSelectionVisible,
        paginationSelectionRenderer = _this$props.paginationSelectionRenderer,
        paginationTotalVisible = _this$props.paginationTotalVisible,
        paginationTotalRenderer = _this$props.paginationTotalRenderer,
        paginationPageVisible = _this$props.paginationPageVisible,
        paginationPageSizeVisible = _this$props.paginationPageSizeVisible,
        paginationPageSizeRightIconCls = _this$props.paginationPageSizeRightIconCls,
        paginationPrevIconCls = _this$props.paginationPrevIconCls,
        paginationNextIconCls = _this$props.paginationNextIconCls,
        paginationFirstIconCls = _this$props.paginationFirstIconCls,
        paginationLastIconCls = _this$props.paginationLastIconCls,
        restProps = (0, _objectWithoutProperties2["default"])(_this$props, _excluded),
        PaginationComponent = this.getPaginationComponent();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('table-pagination', (0, _defineProperty2["default"])({}, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement(PaginationComponent, (0, _extends2["default"])({}, restProps, {
        total: data && data.length || 0,
        selectedCount: value && value.length || 0,
        selectionVisible: paginationSelectionVisible,
        totalVisible: paginationTotalVisible,
        pageVisible: paginationPageVisible,
        pageSizeVisible: paginationPageSizeVisible,
        pageSizeRightIconCls: paginationPageSizeRightIconCls,
        prevIconCls: paginationPrevIconCls,
        nextIconCls: paginationNextIconCls,
        firstIconCls: paginationFirstIconCls,
        lastIconCls: paginationLastIconCls,
        selectionRenderer: paginationSelectionRenderer,
        totalRenderer: paginationTotalRenderer,
        onChange: this.handlePaginationChange
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      return {
        prevProps: props,
        page: _ComponentUtil["default"].getDerivedState(props, state, 'page'),
        pageSize: _ComponentUtil["default"].getDerivedState(props, state, 'pageSize')
      };
    }
  }]);
  return TablePagination;
}(_react.Component);
(0, _defineProperty2["default"])(TablePagination, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(TablePagination, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(TablePagination, "SortingType", _SortingType["default"]);
TablePagination.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * The select mode of table.
   */
  selectMode: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SelectMode["default"])),
  data: _propTypes["default"].array,
  value: _propTypes["default"].any,
  page: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  pageSizes: _propTypes["default"].array,
  parentEl: _propTypes["default"].object,
  useFullPagination: _propTypes["default"].bool,
  pageSizeValueField: _propTypes["default"].string,
  pageSizeDisplayField: _propTypes["default"].string,
  paginationSelectionVisible: _propTypes["default"].bool,
  paginationTotalVisible: _propTypes["default"].bool,
  paginationPageVisible: _propTypes["default"].bool,
  paginationPageSizeVisible: _propTypes["default"].bool,
  paginationPageSizeRightIconCls: _propTypes["default"].string,
  paginationPrevIconCls: _propTypes["default"].string,
  paginationNextIconCls: _propTypes["default"].string,
  paginationFirstIconCls: _propTypes["default"].string,
  paginationLastIconCls: _propTypes["default"].string,
  paginationSelectionRenderer: _propTypes["default"].func,
  paginationTotalRenderer: _propTypes["default"].func,
  onPaginationChange: _propTypes["default"].func,
  onPageChange: _propTypes["default"].func,
  onPageSizeChange: _propTypes["default"].func
};
TablePagination.defaultProps = {
  selectMode: _SelectMode["default"].SINGLE_SELECT,
  page: 0,
  pageSize: 10,
  pageSizes: [5, 10, 15, 20],
  useFullPagination: false,
  pageSizeValueField: 'value',
  pageSizeDisplayField: 'text',
  paginationSelectionVisible: false,
  paginationTotalVisible: true,
  paginationPageVisible: true,
  paginationPageSizeVisible: true,
  paginationPageSizeRightIconCls: 'fas fa-angle-down',
  paginationPrevIconCls: 'fas fa-angle-left',
  paginationNextIconCls: 'fas fa-angle-right',
  paginationFirstIconCls: 'fas fa-angle-double-left',
  paginationLastIconCls: 'fas fa-angle-double-right'
};
var _default = TablePagination;
exports["default"] = _default;