"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactBeautifulDnd = require("react-beautiful-dnd");
var _IconButton = _interopRequireDefault(require("../IconButton"));
var _TabButton = _interopRequireDefault(require("../_TabButton"));
var _Position = _interopRequireDefault(require("../_statics/Position"));
var _Direction = _interopRequireDefault(require("../_statics/Direction"));
var _classnames = _interopRequireDefault(require("classnames"));
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _Event = _interopRequireDefault(require("../_vendors/Event"));
var _ScrollBar = _interopRequireDefault(require("../_vendors/ScrollBar"));
var _Valid = _interopRequireDefault(require("../_vendors/Valid"));
var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));
var _excluded = ["style", "value", "renderer", "tabButtonRenderer", "tabContentRenderer", "onActive"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tabs = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tabs, _Component);
  var _super = _createSuper(Tabs);
  function Tabs(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tabs);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isTabsOverflow", function () {
      if (!_this.tabsEl) {
        return false;
      }
      var scrollEl = _this.tabsEl.querySelector('.tab-buttons-wrapper');
      if (!scrollEl) {
        return false;
      }
      return Math.floor(_this.tabsEl.offsetWidth) < Math.floor(scrollEl.offsetWidth);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isScrollLeftButtonDisabled", function () {
      return _this.tabsEl.scrollLeft <= 0;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isScrollRightButtonDisabled", function () {
      if (!_this.tabsEl) {
        return false;
      }
      return _this.tabsEl.scrollLeft >= _this.tabsEl.scrollWidth - _this.tabsEl.offsetWidth;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getScrollerStyle", function () {
      var horizontalScrollBarSize = _ScrollBar["default"].getSize(_Direction["default"].HORIZONTAL);
      if (!horizontalScrollBarSize || horizontalScrollBarSize <= 0) {
        return null;
      }
      return {
        height: "calc(100% + ".concat(horizontalScrollBarSize, "px)"),
        marginBottom: -horizontalScrollBarSize
      };
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "clearTabsScrollTimeout", function () {
      _this.tabsScrollTimeout && clearTimeout(_this.tabsScrollTimeout);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnTabsScroll", function (e) {
      _this.setState({
        scrollLeft: e.target.scrollLeft
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabsScroll", function (direction, keepScrolling) {
      if (!_this.tabsEl) {
        return;
      }
      var _this$props = _this.props,
        scrollStep = _this$props.scrollStep,
        scrollInterval = _this$props.scrollInterval,
        keepScrollingWait = _this$props.keepScrollingWait;
      _this.tabsEl.scrollLeft += (direction === _Position["default"].LEFT ? -1 : 1) * scrollStep;
      _this.setState({
        scrollLeft: _this.tabsEl.scrollLeft
      });
      _this.clearTabsScrollTimeout();
      _this.tabsScrollTimeout = setTimeout(function () {
        return _this.handleTabsScroll(direction, true);
      }, keepScrolling === true ? scrollInterval : keepScrollingWait);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "tabsScrollLeft", function (e) {
      var _this$props$onScrollL, _this$props2;
      _this.handleTabsScroll(_Position["default"].LEFT);
      (_this$props$onScrollL = (_this$props2 = _this.props).onScrollLeftButtonMouseDown) === null || _this$props$onScrollL === void 0 ? void 0 : _this$props$onScrollL.call(_this$props2, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "tabsScrollRight", function (e) {
      var _this$props$onScrollR, _this$props3;
      _this.handleTabsScroll(_Position["default"].RIGHT);
      (_this$props$onScrollR = (_this$props3 = _this.props).onScrollRightButtonMouseDown) === null || _this$props$onScrollR === void 0 ? void 0 : _this$props$onScrollR.call(_this$props3, e);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleInkBarSizeChange", function () {
      if (!_this.tabsEl) {
        return;
      }
      var tabs = _this.tabsEl.querySelectorAll('.tab-buttons .tab-button');
      if (!tabs || tabs.length < 1) {
        return;
      }
      var activatedIndex = _Valid["default"].range(_this.props.activatedIndex, 0, tabs.length - 1);
      var activatedtab = tabs[activatedIndex];
      if (!activatedtab) {
        return;
      }
      if (activatedtab.offsetWidth !== _this.state.inkBarWidth) {
        _this.setState({
          inkBarWidth: activatedtab.offsetWidth
        });
      }
      if (activatedtab.offsetLeft !== _this.state.inkBarOffsetLeft) {
        _this.setState({
          inkBarOffsetLeft: activatedtab.offsetLeft
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTabsOverflowChange", function () {
      var isTabsOverflow = _this.props.isTabsOverflow;
      var current = _this.isTabsOverflow();
      if (current !== isTabsOverflow) {
        var _this$props$onTabsOve, _this$props4;
        if (current && _this.tabsEl) {
          _this.setState({
            scrollLeft: _this.tabsEl.scrollLeft
          });
        }
        (_this$props$onTabsOve = (_this$props4 = _this.props).onTabsOverflowChange) === null || _this$props$onTabsOve === void 0 ? void 0 : _this$props$onTabsOve.call(_this$props4, !isTabsOverflow);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleResize", (0, _debounce["default"])(function () {
      _this.handleInkBarSizeChange();
      _this.handleTabsOverflowChange();
    }, 150));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "addObserver", function () {
      if (_this.tabsEl && !_this.observer) {
        _this.observer = new _resizeObserverPolyfill["default"](_this.handleMeasure);
        _this.observer.observe(_this.tabsEl);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleMeasure", function (entries) {
      var target = entries[0].target;
      var _target$getBoundingCl = target.getBoundingClientRect(),
        width = _target$getBoundingCl.width;
      var fixedWidth = Math.floor(width);
      if (_this.lastWidth !== fixedWidth) {
        _this.lastWidth = fixedWidth;
        _this.setState({
          scrollLeft: _this.tabsEl.scrollLeft
        });
      }
    });
    _this.tabs = /*#__PURE__*/(0, _react.createRef)();
    _this.tabsEl = null;
    _this.scrollLeftButton = /*#__PURE__*/(0, _react.createRef)();
    _this.scrollRightButton = /*#__PURE__*/(0, _react.createRef)();
    _this.tabsScrollTimeout = null;
    _this.observer = null;
    _this.lastWidth = null;
    _this.state = {
      scrollLeft: 0,
      inkBarWidth: 0,
      inkBarOffsetLeft: 0
    };
    return _this;
  }
  (0, _createClass2["default"])(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$tabs;
      this.tabsEl = (_this$tabs = this.tabs) === null || _this$tabs === void 0 ? void 0 : _this$tabs.current;
      _Event["default"].addEvent(window, 'resize', this.handleResize);
      _Event["default"].addEvent(document, 'mouseup', this.clearTabsScrollTimeout);
      this.addObserver();
      this.handleInkBarSizeChange();
      this.handleTabsOverflowChange();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.addObserver();
      this.handleInkBarSizeChange();
      this.handleTabsOverflowChange();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeObserver();
      _Event["default"].removeEvent(window, 'resize', this.handleResize);
      _Event["default"].removeEvent(document, 'mouseup', this.clearTabsScrollTimeout);
    }
  }, {
    key: "removeObserver",
    value: function removeObserver() {
      if (this.observer) {
        this.observer.disconnect();
        this.observer = null;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
        children = _this$props5.children,
        className = _this$props5.className,
        style = _this$props5.style,
        isTabFullWidth = _this$props5.isTabFullWidth,
        isInkBarHidden = _this$props5.isInkBarHidden,
        data = _this$props5.data,
        activatedIndex = _this$props5.activatedIndex,
        isTabsOverflow = _this$props5.isTabsOverflow,
        draggable = _this$props5.draggable,
        idField = _this$props5.idField,
        scrollLeftIconCls = _this$props5.scrollLeftIconCls,
        scrollRightIconCls = _this$props5.scrollRightIconCls,
        onTabMouseDown = _this$props5.onTabMouseDown,
        onTabMouseUp = _this$props5.onTabMouseUp,
        onTabClick = _this$props5.onTabClick,
        onTabButtonDragStart = _this$props5.onTabButtonDragStart,
        onTabButtonDragEnd = _this$props5.onTabButtonDragEnd;
      var _this$state = this.state,
        scrollLeft = _this$state.scrollLeft,
        inkBarWidth = _this$state.inkBarWidth,
        inkBarOffsetLeft = _this$state.inkBarOffsetLeft;
      var scrollerStyle = this.getScrollerStyle();
      return /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
        onDragStart: onTabButtonDragStart,
        onDragEnd: onTabButtonDragEnd
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('tabs', (0, _defineProperty2["default"])({
          'auto-width': !isTabFullWidth
        }, className, className)),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.tabs,
        className: "tabs-scroller",
        style: scrollerStyle,
        onScroll: this.handleOnTabsScroll
      }, /*#__PURE__*/_react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "droppable",
        direction: "horizontal"
      }, function (dropProvided) {
        return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
          className: "tab-buttons-wrapper",
          ref: dropProvided.innerRef
        }, dropProvided.droppableProps), /*#__PURE__*/_react["default"].createElement("div", {
          className: "tab-buttons"
        }, (data === null || data === void 0 ? void 0 : data.map(function (item, index) {
          var style = item.style,
            value = item.value,
            renderer = item.renderer,
            tabButtonRenderer = item.tabButtonRenderer,
            tabContentRenderer = item.tabContentRenderer,
            onActive = item.onActive,
            restProps = (0, _objectWithoutProperties2["default"])(item, _excluded);
          var activated = activatedIndex === index;
          var tabButton = /*#__PURE__*/_react["default"].createElement(_TabButton["default"], (0, _extends2["default"])({}, restProps, {
            key: idField && item[idField] || index,
            style: _objectSpread(_objectSpread({}, style), {}, {
              width: isTabFullWidth ? "".concat(100 / data.length, "%") : 'auto'
            }),
            data: item,
            value: value,
            index: index,
            isTabFullWidth: isTabFullWidth,
            activated: activated,
            draggable: draggable,
            renderer: renderer && typeof renderer === 'function' ? renderer.bind(null, value, activated) : renderer,
            onMouseDown: onTabMouseDown,
            onMouseUp: onTabMouseUp,
            onClick: onTabClick
          }));
          if (tabButtonRenderer) {
            if (typeof tabButtonRenderer === 'function') {
              return tabButtonRenderer(value, activated, tabButton);
            }
            return tabButtonRenderer;
          }
          return tabButton;
        })) || null, dropProvided.placeholder));
      }), !isInkBarHidden ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "ink-bar",
        style: {
          bottom: scrollerStyle ? 0 : 20,
          width: inkBarWidth,
          transform: "translateX(".concat(inkBarOffsetLeft, "px)")
        }
      }) : null, children), isTabsOverflow ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        ref: this.scrollLeftButton,
        className: "tab-button tab-scroll-left-button",
        iconCls: scrollLeftIconCls,
        disabled: this.isScrollLeftButtonDisabled(scrollLeft),
        onMouseDown: this.tabsScrollLeft
      }), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        ref: this.scrollRightButton,
        className: "tab-button tab-scroll-right-button",
        iconCls: scrollRightIconCls,
        disabled: this.isScrollRightButtonDisabled(scrollLeft),
        onMouseDown: this.tabsScrollRight
      })) : null));
    }
  }]);
  return Tabs;
}(_react.Component);
Tabs.propTypes = {
  children: _propTypes["default"].any,
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  style: _propTypes["default"].object,
  /**
   * Children passed into the TabsItem.
   */
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * The text value of the tab.Type can be string or number.
     */
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    /**
     * If true, the tab will be disabled.
     */
    disabled: _propTypes["default"].bool,
    /**
     * If true,the tab will be have loading effect.
     */
    isLoading: _propTypes["default"].bool,
    /**
     * If true,the element's ripple effect will be disabled.
     */
    disableTouchRipple: _propTypes["default"].bool,
    /**
     * Use this property to display an icon.It will display on the left.
     */
    iconCls: _propTypes["default"].string,
    /**
     * The position of the icon.
     */
    iconPosition: _propTypes["default"].string,
    /**
     * The render of tab button content.
     */
    renderer: _propTypes["default"].any,
    /**
     * The render of tab button.
     */
    tabButtonRenderer: _propTypes["default"].any,
    /**
     * The render content in tab.
     */
    tabContentRenderer: _propTypes["default"].any,
    /**
     * Callback function fired when click onActive tab.
     */
    onActive: _propTypes["default"].func
  })).isRequired,
  /**
   * Activated tab index.
   */
  activatedIndex: _propTypes["default"].number,
  /**
   * If true,the data is FullWidth.
   */
  isTabFullWidth: _propTypes["default"].bool,
  isInkBarHidden: _propTypes["default"].bool,
  isTabsOverflow: _propTypes["default"].bool,
  draggable: _propTypes["default"].bool,
  idField: _propTypes["default"].string,
  scrollLeftIconCls: _propTypes["default"].string,
  scrollRightIconCls: _propTypes["default"].string,
  scrollStep: _propTypes["default"].number,
  scrollInterval: _propTypes["default"].number,
  keepScrollingWait: _propTypes["default"].number,
  onTabClick: _propTypes["default"].func,
  onTabMouseDown: _propTypes["default"].func,
  onTabMouseUp: _propTypes["default"].func,
  onTabsOverflowChange: _propTypes["default"].func,
  onTabButtonDragStart: _propTypes["default"].func,
  onTabButtonDragEnd: _propTypes["default"].func,
  onScrollLeftButtonMouseDown: _propTypes["default"].func,
  onScrollRightButtonMouseDown: _propTypes["default"].func
};
Tabs.defaultProps = {
  data: [],
  activatedIndex: 0,
  isTabFullWidth: true,
  isInkBarHidden: false,
  draggable: false,
  scrollLeftIconCls: 'fas fa-chevron-left',
  scrollRightIconCls: 'fas fa-chevron-right',
  scrollStep: 100,
  scrollInterval: 100,
  keepScrollingWait: 250
};
var _default = Tabs;
exports["default"] = _default;