"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TipProvider = _interopRequireDefault(require("../TipProvider"));
var _Td = _interopRequireDefault(require("../_Td"));
var _TableFragment = _interopRequireDefault(require("../_statics/TableFragment"));
var _HorizontalAlign = _interopRequireDefault(require("../_statics/HorizontalAlign"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _SelectAllMode = _interopRequireDefault(require("../_statics/SelectAllMode"));
var _SortingType = _interopRequireDefault(require("../_statics/SortingType"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Util = _interopRequireDefault(require("../_vendors/Util"));
var _TableCalculation = _interopRequireDefault(require("../_vendors/TableCalculation"));
var _excluded = ["className", "style", "rowIndex", "data", "tableData", "isChecked", "disabled", "ignoreColumnSpan", "depth", "index", "path", "columns", "columnsWidth", "useDynamicRender", "rowHeight"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Tr = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Tr, _Component);
  var _super = _createSuper(Tr);
  function Tr(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Tr);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getDynamicRenderStyle", function () {
      var _this$props = _this.props,
        useDynamicRender = _this$props.useDynamicRender,
        rowHeight = _this$props.rowHeight;
      return useDynamicRender ? {
        height: rowHeight,
        paddingTop: 0,
        paddingBottom: 0
      } : null;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getTdStyle", function (column, originColumnIndex) {
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        columnKeyField = _this$props2.columnKeyField,
        columnsWidth = _this$props2.columnsWidth,
        defaultColumnWidth = _this$props2.defaultColumnWidth;
      return _objectSpread(_objectSpread(_objectSpread({}, column === null || column === void 0 ? void 0 : column.bodyStyle), _TableCalculation["default"].getStickyColumnStyle(column === null || column === void 0 ? void 0 : column.fixed, originColumnIndex, columns, columnKeyField, columnsWidth, defaultColumnWidth)), _this.getDynamicRenderStyle());
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isCollapsed", function () {
      var _this$props3 = _this.props,
        idField = _this$props3.idField,
        data = _this$props3.data,
        expandRows = _this$props3.expandRows;
      if (!expandRows || expandRows.length < 1) {
        return true;
      }
      return _TableCalculation["default"].indexOfNodeInValue(data, expandRows, idField) === -1;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getColumnsSpan", function () {
      var _this$props4 = _this.props,
        columns = _this$props4.columns,
        data = _this$props4.data,
        rowIndex = _this$props4.rowIndex,
        onRequestColumnsSpan = _this$props4.onRequestColumnsSpan;
      return onRequestColumnsSpan ? onRequestColumnsSpan(_TableFragment["default"].BODY, columns, data, rowIndex) : _TableCalculation["default"].getColumnsSpan(_TableFragment["default"].BODY, columns, data, rowIndex);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var _this$props$onRowClic, _this$props6;
      var _this$props5 = _this.props,
        data = _this$props5.data,
        rowIndex = _this$props5.rowIndex,
        disabled = _this$props5.disabled;
      !disabled && ((_this$props$onRowClic = (_this$props6 = _this.props).onRowClick) === null || _this$props$onRowClic === void 0 ? void 0 : _this$props$onRowClic.call(_this$props6, data, rowIndex, e));
    });
    return _this;
  }
  (0, _createClass2["default"])(Tr, [{
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this,
        _data$children;
      var _this$props7 = this.props,
        className = _this$props7.className,
        style = _this$props7.style,
        rowIndex = _this$props7.rowIndex,
        data = _this$props7.data,
        tableData = _this$props7.tableData,
        isChecked = _this$props7.isChecked,
        disabled = _this$props7.disabled,
        ignoreColumnSpan = _this$props7.ignoreColumnSpan,
        depth = _this$props7.depth,
        index = _this$props7.index,
        path = _this$props7.path,
        columns = _this$props7.columns,
        columnsWidth = _this$props7.columnsWidth,
        useDynamicRender = _this$props7.useDynamicRender,
        rowHeight = _this$props7.rowHeight,
        respProps = (0, _objectWithoutProperties2["default"])(_this$props7, _excluded),
        collapsed = this.isCollapsed(),
        columnsSpan = this.getColumnsSpan(),
        nodePath = path || [{
          index: index,
          node: data
        }];
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_TipProvider["default"], {
        className: data === null || data === void 0 ? void 0 : data.rowTipClassName,
        tipContent: data === null || data === void 0 ? void 0 : data.rowTip,
        position: data === null || data === void 0 ? void 0 : data.rowTipPosition
      }, /*#__PURE__*/_react["default"].createElement("tr", {
        className: (0, _classnames["default"])((_classNames = {
          checked: isChecked,
          expanded: !collapsed
        }, (0, _defineProperty2["default"])(_classNames, data === null || data === void 0 ? void 0 : data.rowClassName, data === null || data === void 0 ? void 0 : data.rowClassName), (0, _defineProperty2["default"])(_classNames, className, className), _classNames)),
        style: style,
        disabled: disabled,
        onClick: this.handleClick
      }, columnsSpan === null || columnsSpan === void 0 ? void 0 : columnsSpan.map(function (_ref, colIndex) {
        var _columnsSpan, _columnsSpan$column, _columnsSpan2, _columnsSpan2$column;
        var column = _ref.column,
          span = _ref.span,
          originColumnIndex = _ref.originColumnIndex;
        return column ? /*#__PURE__*/_react["default"].createElement(_Td["default"], (0, _extends2["default"])({}, respProps, {
          key: colIndex,
          className: (0, _classnames["default"])(column.bodyClassName, {
            'fixed-left': column.fixed === _HorizontalAlign["default"].LEFT,
            'last-fixed-left': column.fixed === _HorizontalAlign["default"].LEFT && (columnsSpan === null || columnsSpan === void 0 ? void 0 : (_columnsSpan = columnsSpan[colIndex + 1]) === null || _columnsSpan === void 0 ? void 0 : (_columnsSpan$column = _columnsSpan.column) === null || _columnsSpan$column === void 0 ? void 0 : _columnsSpan$column.fixed) !== _HorizontalAlign["default"].LEFT,
            'fixed-right': column.fixed === _HorizontalAlign["default"].RIGHT,
            'first-fixed-right': column.fixed === _HorizontalAlign["default"].RIGHT && (columnsSpan === null || columnsSpan === void 0 ? void 0 : (_columnsSpan2 = columnsSpan[colIndex - 1]) === null || _columnsSpan2 === void 0 ? void 0 : (_columnsSpan2$column = _columnsSpan2.column) === null || _columnsSpan2$column === void 0 ? void 0 : _columnsSpan2$column.fixed) !== _HorizontalAlign["default"].RIGHT
          }),
          style: _this2.getTdStyle(column, originColumnIndex),
          rowIndex: rowIndex,
          colIndex: colIndex,
          data: data,
          title: column.bodyTitle,
          tableData: tableData,
          collapsed: collapsed,
          renderer: column.bodyRenderer,
          align: column.bodyAlign || column.align,
          span: ignoreColumnSpan ? null : span,
          disabled: disabled,
          noWrap: _TableCalculation["default"].handleNoWrap(column.bodyNoWrap, column.noWrap, {
            data: data,
            rowIndex: rowIndex,
            colIndex: colIndex,
            tableData: tableData
          }),
          depth: depth,
          path: nodePath,
          sortable: column.sortable,
          sortingProp: column.sortingProp
        })) : null;
      }))), !collapsed && (data === null || data === void 0 ? void 0 : (_data$children = data.children) === null || _data$children === void 0 ? void 0 : _data$children.map(function (item, index) {
        return /*#__PURE__*/_react["default"].createElement(Tr, (0, _extends2["default"])({}, _this2.props, {
          key: index,
          index: index,
          data: item,
          parentData: data,
          depth: depth + 1,
          path: nodePath ? [].concat((0, _toConsumableArray2["default"])(nodePath), [{
            index: index,
            node: item
          }]) : [{
            index: index,
            node: item
          }]
        }));
      })) || null);
    }
  }]);
  return Tr;
}(_react.Component);
(0, _defineProperty2["default"])(Tr, "Align", _HorizontalAlign["default"]);
(0, _defineProperty2["default"])(Tr, "SelectMode", _SelectMode["default"]);
(0, _defineProperty2["default"])(Tr, "SelectAllMode", _SelectAllMode["default"]);
(0, _defineProperty2["default"])(Tr, "SortingType", _SortingType["default"]);
Tr.propTypes = {
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  rowIndex: _propTypes["default"].number,
  /**
   * Children passed into table header.
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    /**
     * unique keyof column.
     */
    key: _propTypes["default"].string,
    /**
     * fixed position of column ( 'left' / 'right' ).
     */
    fixed: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * width of column.
     */
    width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string, _propTypes["default"].func]),
    /**
     * minimum width of column.
     */
    minWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    /**
     * align of current column.
     */
    align: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * no wrap of current column.
     */
    noWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of header.
     */
    headClassName: _propTypes["default"].string,
    /**
     * Override the styles of header.
     */
    headStyle: _propTypes["default"].object,
    /**
     * align of table header cell
     */
    headAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headRenderer: _propTypes["default"].any,
    /**
     * The title in table head.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    headTitle: _propTypes["default"].any,
    /**
     * column span of table header.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    headSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table header.
     */
    headNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of td.
     */
    bodyClassName: _propTypes["default"].string,
    /**
     * Override the styles of td.
     */
    bodyStyle: _propTypes["default"].object,
    /**
     * align of table body cell.
     */
    bodyAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyRenderer: _propTypes["default"].any,
    /**
     * The title in table body.
     *  (1) callback:
     *      function (rowData, rowIndex, colIndex, parentData, tableData, collapsed, depth, path) {
     *          return rowData.id;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    bodyTitle: _propTypes["default"].any,
    /**
     * column span of table body.
     *  (1) function callback:
     *      function (rowData, colIndex, rowIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    bodySpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table body.
     */
    bodyNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * The class name of footer.
     */
    footClassName: _propTypes["default"].string,
    /**
     * Override the styles of footer.
     */
    footStyle: _propTypes["default"].object,
    /**
     * align of table footer cell
     */
    footAlign: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_HorizontalAlign["default"])),
    /**
     * The render content in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footRenderer: _propTypes["default"].any,
    /**
     * The title in table foot.
     *  (1) callback:
     *      function (tableData, colIndex) {
     *          return colIndex;
     *      }
     *
     *  (2) others:
     *      render whatever you pass
     */
    footTitle: _propTypes["default"].any,
    /**
     * column span of table foot.
     *  (1) function callback:
     *      function (tableData, colIndex) {
     *          return null;
     *      }
     *
     *  (2) number:
     *      render whatever you pass
     */
    footSpan: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].func]),
    /**
     * no wrap of table foot.
     */
    footNoWrap: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
    /**
     * If true, this column can be sorted.
     */
    sortable: _propTypes["default"].bool,
    /**
     * Sorting property.
     */
    sortingProp: _propTypes["default"].string,
    defaultSortingType: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"])),
    /**
     * whether the column can be resized
     */
    resizable: _propTypes["default"].bool
  })).isRequired,
  columnKeyField: _propTypes["default"].string,
  columnsWidth: _propTypes["default"].object,
  data: _propTypes["default"].shape({
    children: _propTypes["default"].array,
    rowClassName: _propTypes["default"].string,
    rowTipClassName: _propTypes["default"].string,
    rowTip: _propTypes["default"].any,
    rowTipPosition: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_TipProvider["default"].Position))
  }),
  parentData: _propTypes["default"].object,
  tableData: _propTypes["default"].array,
  isChecked: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  expandRows: _propTypes["default"].array,
  depth: _propTypes["default"].number,
  index: _propTypes["default"].number,
  path: _propTypes["default"].array,
  idField: _propTypes["default"].string,
  ignoreColumnSpan: _propTypes["default"].bool,
  scrollEl: _propTypes["default"].object,
  /**
   * sorting
   */
  sorting: _propTypes["default"].shape({
    prop: _propTypes["default"].string,
    type: _propTypes["default"].oneOf(_Util["default"].enumerateValue(_SortingType["default"]))
  }),
  /**
   * Dynamic Render
   */
  useDynamicRender: _propTypes["default"].bool,
  rowHeight: _propTypes["default"].number,
  /**
   * column resizable
   */
  defaultColumnWidth: _propTypes["default"].number,
  /**
   * callback
   */
  onRowClick: _propTypes["default"].func,
  onCellClick: _propTypes["default"].func,
  onExpandChange: _propTypes["default"].func,
  onRequestColumnsSpan: _propTypes["default"].func
};
Tr.defaultProps = {
  columnKeyField: 'key',
  rowIndex: 0,
  isChecked: false,
  disabled: false,
  expandRows: [],
  depth: 0,
  idField: 'id',
  ignoreColumnSpan: false,
  /**
   * Dynamic Render
   */
  useDynamicRender: false,
  rowHeight: 50,
  /**
   * column resizable
   */
  defaultColumnWidth: 100
};
var _default = Tr;
exports["default"] = _default;