"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));
var _classnames = _interopRequireDefault(require("classnames"));
var _TextField = _interopRequireDefault(require("../TextField"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var TransferList = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(TransferList, _Component);
  var _super = _createSuper(TransferList);
  function TransferList(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TransferList);
    for (var _len = arguments.length, restArgs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      restArgs[_key - 1] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this, props].concat(restArgs));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "select", function (item) {
      if (!item || item.disabled) {
        return;
      }
      var data = (0, _cloneDeep["default"])(_this.props.value),
        selectAll = _this.state.selectAll,
        flag = false;
      for (var i = 0; i < data.length; i++) {
        if (data[i].id === item.id) {
          flag = true;
          break;
        }
      }
      if (flag) {
        var index = data.findIndex(function (value) {
          return value.id == item.id;
        });
        data.splice(index, 1);
        selectAll = false;
      } else {
        data.push(item);
        if (data.length == _this.props.data.length) {
          selectAll = true;
        }
      }
      _this.setState({
        selectAll: selectAll
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(data);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectAll", function () {
      var _this$state = _this.state,
        selectAll = _this$state.selectAll,
        filter = _this$state.filter;
      var data = _this.props.data;
      var filterList = _this.getFilterList(data, filter);
      var newData = [];
      for (var i = 0; i < filterList.length; i++) {
        if (!filterList[i]['disabled']) {
          newData.push(filterList[i]);
        }
      }
      var value = selectAll ? [] : newData;
      _this.setState({
        selectAll: !selectAll
      }, function () {
        _this.props.onChange && _this.props.onChange(value);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleFilterChange", function (value) {
      _this.setState({
        filter: value,
        selectAll: false
      }, function () {
        _this.props.onChange && _this.props.onChange([]);
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getItemValue", function (id) {
      var data = _this.props.value;
      var flag = false;
      for (var i = 0; i < data.length; i++) {
        if (data[i].id === id) {
          flag = true;
          break;
        } else {
          flag = false;
        }
      }
      return flag;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getFilterList", function (list, filter) {
      return list.filter(function (value) {
        if ((0, _typeof2["default"])(value) == 'object') {
          return value.text.toUpperCase().indexOf(filter.toUpperCase()) != -1;
        } else {
          return value.toUpperCase().indexOf(filter.toUpperCase()) != -1;
        }
      });
    });
    _this.state = {
      filter: ''
    };
    return _this;
  }
  (0, _createClass2["default"])(TransferList, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        className = _this$props.className,
        listStyle = _this$props.listStyle,
        data = _this$props.data,
        value = _this$props.value,
        _this$state2 = this.state,
        filter = _this$state2.filter,
        selectAll = _this$state2.selectAll;
      this.filterList = this.getFilterList(data, filter);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])('transfer-list', (0, _defineProperty2["default"])({}, className, className)),
        style: listStyle
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "transfer-header"
      }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        label: value && value.length > 0 ? value.length + '/' + this.filterList.length + ' items' : this.filterList.length + ' items',
        checked: selectAll,
        onChange: this.handleSelectAll
      })), /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
        className: "search",
        rightIconCls: 'fas fa-search',
        onChange: this.handleFilterChange,
        placeholder: 'Search here',
        value: filter
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "options"
      }, this.filterList && this.filterList.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: item.text,
          className: "option ".concat(item.disabled ? 'disabled' : '')
        }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          label: item.text,
          checked: _this2.getItemValue(item.id),
          disabled: item.disabled ? item.disabled : false,
          onChange: function onChange() {
            return _this2.select(item);
          }
        }));
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      if (props && state && state.prevProps && (!props.data || !state.prevProps.data || props.data.length !== state.prevProps.data.length)) {
        return {
          prevProps: props,
          selectAll: false
        };
      }
      return {
        prevProps: props
      };
    }
  }]);
  return TransferList;
}(_react.Component);
TransferList.propTypes = {
  /**
   * The CSS class name of the root element.
   */
  className: _propTypes["default"].string,
  /**
   * Override the styles of the root element.
   */
  listStyle: _propTypes["default"].object,
  data: _propTypes["default"].array,
  value: _propTypes["default"].array,
  onChange: _propTypes["default"].func
};
var _default = TransferList;
exports["default"] = _default;