"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _SelectMode = _interopRequireDefault(require("../_statics/SelectMode"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _Valid = _interopRequireDefault(require("./Valid"));
var _Util = _interopRequireDefault(require("./Util"));
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function pageSize(pageSize, pageSizes, defaultValue) {
  if (pageSize) {
    return pageSize;
  }
  if (pageSizes && pageSizes.length > 0) {
    var _iterator = _createForOfIteratorHelper(pageSizes),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var item = _step.value;
        if (item > 0) {
          return item;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return defaultValue;
}
function displayIndexByScrollTop(data, listHeight, itemHeight) {
  var scrollTop = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var buffer = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  if (!data || !listHeight || !itemHeight) {
    return {
      start: 0,
      stop: 0,
      startWithBuffer: 0,
      stopWithBuffer: 0
    };
  }
  var len = data.length,
    start = Math.floor(scrollTop / itemHeight),
    stop = start + Math.ceil(listHeight / itemHeight);
  return {
    start: _Valid["default"].range(start, 0, len - 1),
    stop: _Valid["default"].range(stop, 0, len - 1),
    startWithBuffer: _Valid["default"].range(start - buffer, 0, len - 1),
    stopWithBuffer: _Valid["default"].range(stop + buffer, 0, len - 1)
  };
}
function displayIndexByScrollTopMulColumns(data, listHeight, itemHeight, column) {
  var scrollTop = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  var buffer = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
  if (!data || !listHeight || !itemHeight) {
    return {
      start: 0,
      stop: 0,
      startWithBuffer: 0,
      stopWithBuffer: 0
    };
  }
  var len = data.length,
    start = Math.floor(scrollTop / itemHeight) * column,
    stop = start + Math.ceil(listHeight / itemHeight) * column;
  return {
    start: _Valid["default"].range(start, 0, len - 1),
    stop: _Valid["default"].range(stop, 0, len - 1),
    startWithBuffer: _Valid["default"].range(_Valid["default"].range(start, 0, len - 1) - buffer, 0, len - 1),
    stopWithBuffer: _Valid["default"].range(stop + buffer, 0, len - 1)
  };
}
function getInitValue(props) {
  if (!props) {
    return;
  }
  var value = props.value,
    selectMode = props.selectMode;
  if (!selectMode) {
    return;
  }
  if (value != null) {
    return value;
  }
  switch (selectMode) {
    case _SelectMode["default"].MULTI_SELECT:
      return [];
    case _SelectMode["default"].SINGLE_SELECT:
      return null;
    default:
      return value;
  }
}
function getMultiSelectItemIndex(item, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var selectMode = props.selectMode,
    valueField = props.valueField,
    displayField = props.displayField;
  if (selectMode !== _SelectMode["default"].MULTI_SELECT || !item || !value) {
    return -1;
  }
  if (!(0, _isArray["default"])(value)) {
    return -1;
  }
  return value.findIndex(function (valueItem) {
    return _Util["default"].isValueEqual(valueItem, item, valueField, displayField);
  });
}
function isItemChecked(item, value, _ref) {
  var selectMode = _ref.selectMode,
    valueField = _ref.valueField,
    displayField = _ref.displayField;
  if (!item || value == null) {
    return false;
  }

  // Single Selection
  if (selectMode === _SelectMode["default"].SINGLE_SELECT) {
    return _Util["default"].isValueEqual(value, item, valueField, displayField);
  }

  // Multiple Selection
  if (!(0, _isArray["default"])(value) || value.length < 1) {
    return false;
  }
  var _iterator2 = _createForOfIteratorHelper(value),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var v = _step2.value;
      if (_Util["default"].isValueEqual(v, item, valueField, displayField)) {
        return true;
      }
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return false;
}
function isItemIndeterminate(node, value, _ref2) {
  var valueField = _ref2.valueField,
    displayField = _ref2.displayField;
  if (!node || !node.children || node.children.length < 1 || !value || !value.length || value.length < 1) {
    return false;
  }
  var total = 0,
    count = 0;
  _Util["default"].preOrderTraverse(node, function (nodeItem) {
    total++;
    if (value.findIndex(function (item) {
      return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(nodeItem, valueField, displayField);
    }) > -1) {
      count++;
    }
  });
  return count > 0 && total !== count;
}
function filterAutoCompleteData(filter, props) {
  var data = props.data,
    minFilterLength = props.minFilterLength;
  if (!filter || filter.length < minFilterLength) {
    return data;
  }
  var valueField = props.valueField,
    displayField = props.displayField,
    renderer = props.renderer;
  return data === null || data === void 0 ? void 0 : data.filter(function (item) {
    if (!item) {
      return false;
    }
    if (renderer) {
      return renderer(item).toString().toUpperCase().includes(filter.toUpperCase());
    }
    if ((0, _typeof2["default"])(item) === 'object') {
      var itemDisplay = _Util["default"].getTextByDisplayField(item, displayField, valueField);
      if (itemDisplay) {
        return itemDisplay.toString().toUpperCase().includes(filter.toUpperCase());
      }
    }
    return item.toString().toUpperCase().includes(filter.toUpperCase());
  });
}
function filterLocalAutoCompleteData(filter, props) {
  var data = props.data,
    minFilterLength = props.minFilterLength;
  if (!filter || filter.length < minFilterLength) {
    return data;
  }
  var valueField = props.valueField,
    displayField = props.displayField,
    renderer = props.renderer,
    filterCallback = props.filterCallback;
  if (filterCallback) {
    return filterCallback(filter, data);
  }
  return data === null || data === void 0 ? void 0 : data.filter(function (item) {
    if (!item) {
      return false;
    }
    if (renderer) {
      return renderer(item).toString().toUpperCase().includes(filter.toUpperCase());
    }
    if ((0, _typeof2["default"])(item) === 'object') {
      var itemDisplay = _Util["default"].getTextByDisplayField(item, displayField, valueField);
      if (itemDisplay) {
        return itemDisplay.toString().toUpperCase().includes(filter.toUpperCase());
      }
    }
    return item.toString().toUpperCase().includes(filter.toUpperCase());
  });
}
var _default = {
  pageSize: pageSize,
  displayIndexByScrollTop: displayIndexByScrollTop,
  getInitValue: getInitValue,
  getMultiSelectItemIndex: getMultiSelectItemIndex,
  displayIndexByScrollTopMulColumns: displayIndexByScrollTopMulColumns,
  isItemChecked: isItemChecked,
  isItemIndeterminate: isItemIndeterminate,
  filterAutoCompleteData: filterAutoCompleteData,
  filterLocalAutoCompleteData: filterLocalAutoCompleteData
};
exports["default"] = _default;