"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addRecursiveValue = addRecursiveValue;
exports.calDepth = calDepth;
exports.calPath = calPath;
exports["default"] = void 0;
exports.filterData = filterData;
exports.filterNode = filterNode;
exports.findNodeById = findNodeById;
exports.getTotalCount = getTotalCount;
exports.isCheckedAll = isCheckedAll;
exports.isCheckedIndeterminate = isCheckedIndeterminate;
exports.isNodeChecked = isNodeChecked;
exports.isNodeCheckedIndeterminate = isNodeCheckedIndeterminate;
exports.isNodeMatched = isNodeMatched;
exports.removeAllNode = removeAllNode;
exports.removeRecursiveValue = removeRecursiveValue;
exports.traverseDataCalPath = traverseDataCalPath;
exports.updateValue = updateValue;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _VirtualRoot = _interopRequireDefault(require("../_statics/VirtualRoot"));
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _Util = _interopRequireDefault(require("./Util"));
var _Calculation = _interopRequireDefault(require("./Calculation"));
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function calDepth(data, path) {
  var list = data,
    depth = 0;
  if (!data || !path) {
    return 0;
  }
  var _iterator = _createForOfIteratorHelper(path),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var item = _step.value;
      if (item.index in list) {
        list = list[item.index].children;
        depth++;
      } else {
        return depth;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  if (list && list.length > 0) {
    return depth + 1;
  }
  return depth;
}
function calPath(value, data, props) {
  if (!value || !data) {
    return;
  }
  return traverseDataCalPath(data, value, props, null);
}
function traverseDataCalPath(node, value, props, parent) {
  var index = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  if (!node || node.length < 1 || !value) {
    return;
  }
  var valueField = props.valueField,
    displayField = props.displayField;
  if (_Util["default"].getValueByValueField(node, valueField, displayField) === _Util["default"].getValueByValueField(value, valueField, displayField)) {
    if (!parent) {
      // root
      return null;
    } else {
      return [{
        node: node,
        index: index
      }];
    }
  }

  // find in children
  if (node.children && node.children.length > 0) {
    for (var i = 0, len = node.children.length; i < len; i++) {
      // traverse child node
      var path = traverseDataCalPath(node.children[i], value, props, node, i);

      // if finded in child node
      if (path) {
        if (!parent) {
          // root
          return path;
        }
        path.unshift({
          node: node,
          index: index
        });
        return path;
      }
    }
  }
}
function findNodeById(node, id, callback) {
  var index = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var parent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  if (!node) {
    return;
  }
  if ('' + node.id === '' + id) {
    callback && callback(node, index, parent);
    return true;
  }
  if (node.children && node.children.length > 0) {
    for (var i = 0, len = node.children.length; i < len; i++) {
      if (findNodeById(node.children[i], id, callback, i, node)) {
        return;
      }
    }
  }
}
function addRecursiveValue(node, value, props) {
  if (!node || !value) {
    return;
  }
  if (!_Calculation["default"].isItemChecked(node, value, props)) {
    value.push(node);
  }
  if (!node.children || node.children.length < 1) {
    return;
  }
  var _iterator2 = _createForOfIteratorHelper(node.children),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var item = _step2.value;
      addRecursiveValue(item, value, props);
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
}

/**
 * traverse tree data to update value when multi recursive select
 * @param value
 * @param props
 * @returns {Array}
 */
function updateValue(value, props) {
  var _ref;
  var data = props.data,
    valueField = props.valueField,
    displayField = props.displayField;
  var result = [];
  _Util["default"].postOrderTraverse((0, _isArray["default"])(data) ? (_ref = {}, (0, _defineProperty2["default"])(_ref, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref, "children", data), _ref) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      if (!node.children || node.children.length < 1) {
        if (value.findIndex(function (item) {
          return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(node, valueField, displayField);
        }) > -1) {
          result.push(node);
        }
      } else {
        if (node.children.every(function (child) {
          return result.findIndex(function (item) {
            return _Util["default"].getValueByValueField(item, valueField, displayField) === _Util["default"].getValueByValueField(child, valueField, displayField);
          }) > -1;
        })) {
          result.push(node);
        }
      }
    }
  });
  return result;
}
function getTotalCount(data) {
  var _ref2;
  if (!data) {
    return 0;
  }
  var result = 0;
  _Util["default"].preOrderTraverse((0, _isArray["default"])(data) ? (_ref2 = {}, (0, _defineProperty2["default"])(_ref2, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref2, "children", data), _ref2) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      result++;
    }
  });
  return result;
}
function isNodeMatched(node, filter, props) {
  var _value$toString, _value$toString$toUpp;
  if (node[_VirtualRoot["default"]]) {
    return true;
  }
  var value = _Util["default"].getTextByDisplayField(node, props && props.displayField || undefined, props && props.valueField || undefined);
  return value === null || value === void 0 ? void 0 : (_value$toString = value.toString()) === null || _value$toString === void 0 ? void 0 : (_value$toString$toUpp = _value$toString.toUpperCase()) === null || _value$toString$toUpp === void 0 ? void 0 : _value$toString$toUpp.includes(filter === null || filter === void 0 ? void 0 : filter.toUpperCase());
}
function filterNode(node, filter, option, matchCallback) {
  if (!node || !filter) {
    return node;
  }
  var result = _objectSpread({}, node),
    matched = matchCallback && typeof matchCallback === 'function' ? matchCallback(node, filter, option) : isNodeMatched(node, filter, option);
  if (!(option !== null && option !== void 0 && option.dropMatchedNodeUnmatchedChildren) && matched) {
    return result;
  }
  var hasChildMatched = false;
  if (node.children && node.children.length > 0) {
    result.children = [];
    var _iterator3 = _createForOfIteratorHelper(node.children),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var child = _step3.value;
        var filteredChild = filterNode(child, filter, option, matchCallback);
        if (filteredChild) {
          result.children.push(filteredChild);
        }
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    if (result.children && result.children.length > 0) {
      hasChildMatched = true;
    }
  }
  return matched || hasChildMatched ? result : null;
}
function filterData(data, filter, option, matchCallback) {
  var _ref3;
  if (!filter || !data || data.length < 1) {
    return data;
  }
  var isArrayData = (0, _isArray["default"])(data),
    result = filterNode(isArrayData ? (_ref3 = {}, (0, _defineProperty2["default"])(_ref3, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref3, "children", data), _ref3) : data, filter, option, matchCallback);
  return isArrayData ? (result === null || result === void 0 ? void 0 : result.children) || [] : result || null;
}
function isCheckedAll(data, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!data || !value || value.length < 1) {
    return false;
  }
  return isNodeChecked({
    children: (0, _isArray["default"])(data) ? data : [data]
  }, value, props);
}
function isCheckedIndeterminate(data, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!data || !value || value.length < 1) {
    return false;
  }
  return isNodeCheckedIndeterminate({
    children: (0, _isArray["default"])(data) ? data : [data]
  }, value, props);
}
function isNodeChecked(node, value) {
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!props.isSelectRecursive) {
    return _Calculation["default"].isItemChecked(node, value, props);
  }
  var result = true;
  _Util["default"].preOrderTraverse(node, function (currentNode) {
    // leaf node & not checked
    if (currentNode && (!currentNode.children || currentNode.children.length < 1) && !_Calculation["default"].isItemChecked(currentNode, value, props)) {
      result = false;
      return false;
    }
  });
  return result;
}
function isNodeCheckedIndeterminate(node, value, props) {
  if (!props.isSelectRecursive) {
    return _Calculation["default"].isItemIndeterminate(node, value, props);
  }
  var total = 0,
    count = 0;
  _Util["default"].preOrderTraverse(node, function (currentNode) {
    // leaf node & not checked
    if (currentNode && (!currentNode.children || currentNode.children.length < 1)) {
      total++;
      if (_Calculation["default"].isItemChecked(currentNode, value, props)) {
        count++;
      }
    }
  });
  return count > 0 && count < total;
}
function removeAllNode(data, value) {
  var _ref4;
  var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  if (!data || !value) {
    return value;
  }
  var valueField = props.valueField,
    displayField = props.displayField;
  _Util["default"].preOrderTraverse((0, _isArray["default"])(data) ? (_ref4 = {}, (0, _defineProperty2["default"])(_ref4, _VirtualRoot["default"], true), (0, _defineProperty2["default"])(_ref4, "children", data), _ref4) : data, function (node) {
    if (!(_VirtualRoot["default"] in node)) {
      var index = value.findIndex(function (item) {
        return _Util["default"].isValueEqual(node, item, valueField, displayField);
      });
      if (index !== -1) {
        value.splice(index, 1);
      }
    }
  });
  return value;
}
function removeRecursiveValue(node, value, props) {
  if (!node || !value) {
    return;
  }
  var index = _Calculation["default"].getMultiSelectItemIndex(node, value, props);
  if (index > -1) {
    value.splice(index, 1);
  }
  if (!node.children || node.children.length < 1) {
    return;
  }
  var _iterator4 = _createForOfIteratorHelper(node.children),
    _step4;
  try {
    for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
      var item = _step4.value;
      removeRecursiveValue(item, value, props);
    }
  } catch (err) {
    _iterator4.e(err);
  } finally {
    _iterator4.f();
  }
}
var _default = {
  calDepth: calDepth,
  calPath: calPath,
  findNodeById: findNodeById,
  addRecursiveValue: addRecursiveValue,
  updateValue: updateValue,
  getTotalCount: getTotalCount,
  filterData: filterData,
  isCheckedAll: isCheckedAll,
  isCheckedIndeterminate: isCheckedIndeterminate,
  isNodeChecked: isNodeChecked,
  isNodeCheckedIndeterminate: isNodeCheckedIndeterminate,
  removeAllNode: removeAllNode,
  removeRecursiveValue: removeRecursiveValue
};
exports["default"] = _default;